/**
 * 日历
 * @author贾志成
 * @date2017.12.20
 */
define(['moment'], function (moment) {
    var container = null,
        navbarInnerContainer = null,
        preloader = null,
        calendarInline = null,
        starttime = null, //开始日期
        endtime = null; //结束日期
    return {
        init: function (page) {
            if(page.from == 'right') {
                container = $$(page.container);
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar');
                preloader = container.find('.list-preloader');
                bindEvent();
            }
        }
    };
    // 事件绑定
    function bindEvent () {
        // 默认开始的结束开始时间为当月
        var startDate = new Date(),
        dateArrstring = moment(startDate).format('YYYY-MM-DD'),
        dateArr = dateArrstring.split('-');
        var month = (Number(dateArr[1])) > 9 ? Number(dateArr[1]) : ('0' + Number(dateArr[1]));
        endtime = starttime = dateArrstring;
        // 处理事件日期
        var timeArr = [new Date(2019, 11, 27), new Date(2019, 11, 28)];

        var array = [
            { state: 'y', date: '2019-10-01' },
            { state: 'y', date: '2019-10-03' },
            { state: 'y', date: '2019-10-29' },
            { state: 'y', date: '2019-10-30' },
            { state: 'n', date: '2019-09-29' },
            { state: 'y', date: '2019-09-05' },
            { state: 'n', date: '2019-11-01' },
            { state: 'y', date: '2019-11-02' },
            { state: 'n', date: '2019-11-03' },
        ];




        // 初始化日历
        calendarInline = app.calendar({
            container: '#calendar-inline-container-11',
            dateFormat: 'yyyy-mm-dd',
            dayNamesShort: ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'],
            monthNames: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
            value: [new Date()],
            header: false,
            footer: false,
            toolbarTemplate: '',
            onOpen: function (p) {
                navbarInnerContainer.find('.center').text(p.currentYear + '年 ' + p.params.monthNames[p.currentMonth]);
                app.sizeNavbars('.view-work');
                SetCalendarValue(p, array);
            },
            onMonthYearChangeStart: function (p) {
                navbarInnerContainer.find('.center').text(p.currentYear + '年 ' + p.params.monthNames[p.currentMonth]);
                app.sizeNavbars('.view-work');
                SetCalendarValue(p, array);
            },
            // onDayClick: function (p, dayContainer, year, month, day) {
            //     // 获取点击日期
            //     // var month = Number(month) + 1 > 9 ? Number(month) + 1 : '0' + (Number(month) + 1);
            //     // var day = Number(day) > 9 ? day : '0' + day;
            //     // endtime = starttime = year + '-' + month + '-' + day;
            //     // //清空展示列表
            //     // container.find('.list-block').html('');
            //     // preloader.show();
            //     // getEventList();
            // },
            // events: timeArr
        });
    };
    
//根据返回值设置日历的值
function SetCalendarValue(p, array) {
    $$('.picker-calendar-day').removeClass('day-n');
    $$('.picker-calendar-day').removeClass('day-y');

    $$.each(array, function (index, value) {
        //循环数据库得到的数据对每个数据进行处理
        var curData = new Date(value.date);
        var curYear = curData.getFullYear();
        var curMonth = curData.getMonth() + 1;
        if ((p.currentMonth + 1) == curMonth && p.currentYear == curYear) {
            var curDay = curData.getDate();
            var dom = $$('.picker-calendar-day').filter(function (index, value) {
                //筛选当天的数据，根据数据的状态进行当天数据CSS的添加
                var year = $$(value).attr('data-date').split('-')[0];
                var month = parseInt($$(value).attr('data-date').split('-')[1]) + 1;
                var day = $$(value).attr('data-date').split('-')[2];
                //年月日相等，就确定是当天
                if (year == curYear && month == curMonth && day == curDay) {
                    return $$(value);
                }
            });
            if (value.state == 'y') {
                dom.addClass('day-y');
            } else if (value.state == 'n') {
                dom.addClass('day-n');
            }
        }
    });

}
});