/**
 * 首页
 * @author 吴小龙
 * @date 2017-12-12
 */
define(['moment', 'plugin/highcharts/highcharts'], function (moment, highchartshart) {
    var container = null,
        pi = 0, //页数
        pz = 900,
        timeArr = [],
        todayDate = null, //当天日期
        new_dateFrist = null, //日历当月第一天
        new_dateLast = null, //日历当月最后一天
        date = null,
        year = null, //当前年份
        month = null, //月份
        mettingHtml = '',//会议
        callHtml = '',//拜访
        relationshipHtml = '',//客情
        baseSalesPeriodId = null; //业务期间ID 
    return {
        init: function (page) {
            container = $$(page.container);
            preloader = container.find('.task-con .list-preloader');
            // 加载极光推送
            require(['plugin/component/ajpush'], function (jpush) {
                jpush.init();
            });
            // 页面左上角名称展示：姓+名
            container.find('.nickname').text(localStorage.getItem('surname') + localStorage.getItem('name'));
            // 获取当前时间
            date = new Date;
            year = date.getFullYear();
            month = (date.getMonth() + 1);
            // 获取当前业务区间
            statisticsEvent('true');
            if (userType == 'ContractorEmployee') {
                // 服务商登录，不显示首页日常工作、悬浮按钮task-title
                container.find('.task-title').removeClass('hide');
                container.find('.content-block.task-con').removeClass('hide');
                // 日程、日历、悬浮按钮
                container.find('.calendar-con').addClass('hide');
                container.find('.calendar-title').addClass('hide');
                container.find('.speed-dial').addClass('hide');
            } else if (userType == 'BaseEmployee') {//BaseEmployee
                // 业务员登录，显示首页日常工作,待办事项隐藏
                container.find('.grid').removeClass('hide');
                container.find('.speed-dial').removeClass('hide');
                container.find('.calendar-con').removeClass('hide');
                container.find('.calendar-title').removeClass('hide');
                container.find('.task-con').addClass('hide');
                container.find('.task-title').addClass('hide');
                container.find('.salesPeriodNameTitle').addClass('hide');
                // 获取一段时间的日程数量
                // 日历当月第一天
                new_dateFrist = new Date(year, month - 1, 1)
                // 日历当月最后一天
                new_dateLast = new Date(new Date(year, month, 1).getTime() - 1000 * 60 * 60 * 24);
                GetRoutineWorkCountByDate(moment(new_dateFrist).format('YYYY-MM-DD'), moment(new_dateLast).format('YYYY-MM-DD'), false);
            } else {
                // 合规人员登录，只显示待办事项，隐藏首页日常工作
                container.find('.grid').removeClass('hide');
                container.find('.speed-dial').removeClass('hide');
                container.find('.calendar-con').removeClass('hide');
                container.find('.calendar-title').removeClass('hide');
                container.find('.task-con').addClass('hide');
                container.find('.task-title').addClass('hide');
                container.find('.salesPeriodNameTitle').addClass('hide');
                // 获取一段时间的日程数量
                // 日历当月第一天
                new_dateFrist = new Date(year, month - 1, 1)
                // 日历当月最后一天
                new_dateLast = new Date(new Date(year, month, 1).getTime() - 1000 * 60 * 60 * 24);
                GetRoutineWorkCountByDate(moment(new_dateFrist).format('YYYY-MM-DD'), moment(new_dateLast).format('YYYY-MM-DD'), false);
            }
            // 绑定事件
            bindEvent();
        }
    };
    // 绑定事件
    function bindEvent() {
        // 判断客户按钮是否显示：判断医院、药店、基层三方的查看权限
        if (!permissions.filingHospital.read && !permissions.filingDrugstore.read && !permissions.filingTerminal.read) {
            container.find('[name="client"]').addClass('hide');
        }
        // 判断审批按钮是否显示：判断审批、请假、差旅三方的查看权限
        if (!permissions.approval.read && !permissions.leave.read && !permissions.travel.read) {
            container.find('[name="approvalCon"]').addClass('hide');
        }
        // 判断添加按钮是否显示：判断会议、拜访、开发三方的添加权限
        if (!permissions.developmentPremises.create && !permissions.conferencePremises.create && !permissions.visitsPremises.create) {
            container.find('.speed-dial').addClass('hide');
        }
        // 遍历字段
        $$.each(permissions, function (key, value) {
            if (!value.read) {
                container.find('[name="' + key + '"]').addClass('hide');
            }
        });
        //发布按钮
        var addBtn = container.find('.speed-dial-buttons a');
        addBtn.on('click', function () {
            //点击后收起菜单
            container.find('.speed-dial').removeClass('speed-dial-opened');
        });
        var currentView = app.getCurrentView(),
            sysType = api.systemType;
        // 报告---点击有tab切换的模块，判断是哪个平台，跳转不同的首页
        container.find('[name="report"]').on('click', function () {
            currentView.router.load({
                url: './home/report/' + sysType + '-list.html'
            })
        });
        //监听营销-营销服务活动改变（添加、修改）
        $$(document).on('after-active-change', function () {
            preloader.show();
            container.find('.task-con .task-list').html('');
            pi = 0;
            getTaskData(1);
            getTaskData(2);
        });
        if (userType == 'ContractorEmployee') {
            // 服务商登录可以选择业务期间
            require(['plugin/component/autocomplete'], function (autocomplete) {
                // 参数：操作对象，接口地址，查询的列表内容，回调方法（选填，如果需要根据选择的内容查询相关内容，则传此参数）
                // 搜索业务期间
                autocomplete.initPopup('.salesPeriodName', 'api/services/app/BaseSalesPeriod/getBaseSalesPeriodToSelect2', '业务期间', '', selectSalesPeriodNameCallback);
            });
        }
        // 待办事项-右侧刷新功能
        container.find('.task-update').on('click', function () {
            preloader.show();
            container.find('.task-con .task-list').html('');
            pi = 0;
            getTaskData(1);
            getTaskData(2);
        });
        // 点击昵称跳转到个人简介页面
        container.find('.nickname').on('click', function () {
            currentView.router.load({
                url: './mine/user/index.html',
            })
        });
        // 日程-右侧刷新功能
        container.find('.calendar-update').on('click', function () {
            container.find('.calendar-con .list-preloader').show();
            container.find('.calendar-con .calendar-list').html('');
            getCalendarDataList();
        });
        // 监听：update-calendar
        $$(document).on('update-calendar', function () {
            container.find('.calendar-con .list-preloader').show();
            container.find('.calendar-con .calendar-list').html('');
            getCalendarDataList();
            GetRoutineWorkCountByDate(moment(new_dateFrist).format('YYYY-MM-DD'), moment(new_dateLast).format('YYYY-MM-DD'), true);
        });

    };
    // 选择业务期间回调
    function selectSalesPeriodNameCallback(data) {
        container.find('.salesPeriodName').text(data[0].text); //展示当前业务期间
        baseSalesPeriodId = data[0].id; //业务期间ID
        // 重新获取待办事项
        preloader.show();
        container.find('.task-con .task-list').html('');
        // 获取待办事项列表
        getTaskData(1);
        getTaskData(2);
    }
    //获取业务期间（当前月份所在的业务期间）
    function statisticsEvent(type) {
        var values = {
            year: year,
            month: month
        }
        var param = {
            ajaxUrl: 'api/services/app/baseSalesPeriod/GetPeriodByYearandMonth',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: statisticsEventCallback,
            ajaxAgainEvt: statisticsEvent,
            ajaxText: '获取业务期间',
            isInitial: type
        }
        common.ajaxMethod(param);
    };
    //获取业务期间回调
    function statisticsEventCallback(ret, param) {
        if (ret.result) {
            if (param.isInitial == 'true') {
                localStorage.setItem('currentPeriodName', ret.result.salesPeriodName); // 当前业务区间名称
                localStorage.setItem('currentPeriodId', ret.result.id); // 当前业务区间id
            }
            localStorage.setItem('selectPeriodName', ret.result.salesPeriodName); // 选择的业务期间名称
            localStorage.setItem('selectPeriodId', ret.result.id); // 选择的业务区间id
            container.find('.salesPeriodName').text(ret.result.salesPeriodName); //展示当前业务期间
            baseSalesPeriodId = ret.result.id; //业务期间ID
            // 获取待办事项列表
            getTaskData(1);
            getTaskData(2);
        }
    }
    // 获取待办事项
    function getTaskData(distinctType) {
        var url = '', values = {}, ajaxCallbackEvt = null;
        if (userType == 'ContractorEmployee') {
            // 服务商登录
            url = 'api/services/app/sPRPlan/getSPRReportList';
            values = {
                // status: 0, //0：全部，1：已完成，2：未完成（按照计划金额划分）
                distinctType: distinctType,// 1 个人 2 团队
                PeriodID: baseSalesPeriodId,
                IsAppFrom: true,
                maxResultCount: pz,
                skipCount: pi * pz
            };
            ajaxCallbackEvt = getTaskDataCallback;
        } else {
            // 药企登录
            url = 'api/services/app/workbench/GetApproveMsg';
            ajaxCallbackEvt = showYqTaskDataCallback;
        }
        var param = {
            ajaxUrl: url,
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: ajaxCallbackEvt,
            ajaxAgainEvt: getTaskData,
            ajaxText: '获取待办事项'
        }
        common.ajaxMethod(param);
    }
    // 展示药企待办事项
    function showYqTaskDataCallback(ret, param) {
        var data = ret.result.data, html = '';
        if (data.preContractorNum >= 0) {
            html += '<tr><td class="label-cell"><a href="./mine/serviceprovider-approval/list.html" class="link color-black"><span class="color-blue">' + data.preContractorNum + '</span> &nbsp; 家服务商备案待审批</a></td></tr>';
        }
        if (data.preCSPAgencyNum >= 0) {
            html += '<tr><td class="label-cell"><a href="./mine/csp-approval/list.html" class="link color-black"><span class="color-blue">' + data.preCSPAgencyNum + '</span> &nbsp; 家CSP机构待审批</a></td></tr>';
        }
        if (data.coopAgreementNum >= 0) {
            html += '<tr><td class="label-cell webLook"><span class="color-blue">' + data.coopAgreementNum + '</span> &nbsp; 份CSP服务协议待归档</td></tr>';
        }
        if (data.sprCompleteNum >= 0) {
            html += '<tr><td class="label-cell webLook"><span class="color-blue">' + data.sprCompleteNum + '</span> &nbsp; 份服务工作清单待审批</td></tr>';
        }
        if (data.customerNum >= 0) {
            html += '<tr><td class="label-cell webLook"><span class="color-blue">' + data.customerNum + '</span> &nbsp; 家客户备案待审批</td></tr>';
        }
        if (data.speInvoiceRepository >= 0) {
            html += '<tr><td class="label-cell webLook"><span class="color-blue">' + data.speInvoiceRepository + '</span> &nbsp; 份服务费用发票待审批</td></tr>';
        }
        container.find('.task-con .task-list').html('<div class="data-table card"><table><tbody>' + html + '</tbody></table></div>');
        // 点击提醒前往web端查看
        container.find('.task-con .webLook').off('click');
        container.find('.task-con .webLook').on('click', function () {
            app.alert('请前往web端进行操作', '温馨提示');
        });
        preloader.hide();
    }
    // 展示服务商待办事项
    function getTaskDataCallback(ret, param) {
        var urlJson = {
            '商业渠道调研': './marketing/research/organization/add.html',
            '临床终端调研': './marketing/research/hospital/add.html',
            '基层医疗调研': './marketing/research/terminal/add.html',
            '药店终端调研': './marketing/research/drugstore/add.html',
            '基层医疗开发': './marketing/development/terminal/add.html',
            '药店终端开发': './marketing/development/drugstore/add.html',
            '商业渠道维护': './marketing/maintenance/channel/add.html',
            '基层医疗维护': './marketing/maintenance/terminal/add.html',
            '临床终端维护': './marketing/maintenance/clinical/add.html',
            '药店终端维护': './marketing/maintenance/drugstore/add.html',
            '临床专业拜访': './marketing/activity/clinical-call/add.html',
            '患者专业随访': './marketing/activity/patient-call/add.html',
            '病例征集': './marketing/market-spread/case-collection/add.html',
            '样品赠品赠送': './marketing/activity/reportgift-sample/add.html',
            '商业进销存': './marketing/data/commercial-invoicing/add.html',
            '商业流向数据': './marketing/data/flow/add.html',
            '临床库存数据': './marketing/data/hospital-inventory/add.html',
            '基层医疗用药': './marketing/data/terminal-tender/add.html',
            '药店进销存': './marketing/data/terminal-inventory/add.html',
            '竞品营销数据收集': './marketing/data/competitive-product/add.html',
            '产品及品牌提示物宣传': './marketing/activity/reportproduct-crandpromo/add.html',
            '临床学术资料服务': './marketing/activity/report-clinical/add.html',
            '问卷调研': './marketing/questionnaire/add.html',
            '自办学术会议': './marketing/market-spread/organize-metting/add.html',
            '协办学术会议': './marketing/market-spread/assistance-metting/add.html',
            '赞助学术会议': './marketing/market-spread/sponsor-metting/add.html',
            '商业分销推广': './marketing/market-spread/commercial-distribution/add.html',
            '医生培训活动': './marketing/market-spread/doctor-training/add.html',
            '患者教育活动': './marketing/market-spread/patient-education/add.html',
            '临床准入服务': 'select',
            '商业合作开户': 'select',
            '区域竞品数据收集': '',
            '区域药品招标跟进': '',
            '区域临床路径跟踪': '',
            '区域政策信息收集': ''
        };
        if (param.ajaxValues.distinctType == '1') {
            // 个人
            var data = ret.result;
            // 循环整理跳转路径 url webText
            $$.each(data.items, function (key, value) {
                // 判断对应的服务活动是否在app内有展示
                if (urlJson[value.projectName]) {
                    // 判断对应的服务活动是否是需要直接添加的，如果是【select】则进行选择（选择未关联报告并已完成的数据）
                    if (urlJson[value.projectName] == 'select') {
                        value.addType = 'appSelect';
                    } else if (urlJson[value.projectName] == 'addAndEdit') {
                        // 如果已关联数据，则点击查看详情，主要用于类似调查问卷模块，一个报告只能关联一条数据，并且可以在app内添加的模块
                        value.addType = 'appaddAndEdit';
                    } else {
                        value.addType = 'appAdd';
                    }
                } else {
                    value.addType = 'webAdd';
                }
            });
            // 编译模板
            var template = container.find('.task-con #tab1 .task-tmp-list').html();
            var compiledTemplate = Template7.compile(template);
            var html = compiledTemplate(data);
            container.find('.task-con #tab1 .task-list').html('<div class="data-table card"><table><thead><tr><th class="label-cell">服务事宜</th><th class="numeric-cell text-center">计划</th><th class="numeric-cell">完成</th><th class="numeric-cell">完成率</th></tr></thead><tbody>' + html + '</tbody></table></div>');
            container.find('.task-con #tab1 .list-preloader').hide();
        } else {
            // 团队
            var data = ret.result;
            // 循环整理跳转路径 url webText
            $$.each(data.items, function (key, value) {
                // 判断对应的服务活动是否在app内有展示
                if (urlJson[value.projectName]) {
                    // 判断对应的服务活动是否是需要直接添加的，如果是【select】则进行选择（选择未关联报告并已完成的数据）
                    if (urlJson[value.projectName] == 'select') {
                        value.addType = 'appSelect';
                    } else if (urlJson[value.projectName] == 'addAndEdit') {
                        // 如果已关联数据，则点击查看详情，主要用于类似调查问卷模块，一个报告只能关联一条数据，并且可以在app内添加的模块
                        value.addType = 'appaddAndEdit';
                    } else {
                        value.addType = 'appAdd';
                    }
                } else {
                    value.addType = 'webAdd';
                }
            });
            // 编译模板
            var template = container.find('.task-con #tab2 .task-tmp-list').html();
            var compiledTemplate = Template7.compile(template);
            var html = compiledTemplate(data);
            container.find('.task-con #tab2 .task-list').html('<div class="data-table card"><table><thead><tr><th class="label-cell">服务事宜</th><th class="numeric-cell text-center">计划</th><th class="numeric-cell">完成</th><th class="numeric-cell">完成率</th></tr></thead><tbody>' + html + '</tbody></table></div>');
            container.find('.task-con #tab2 .list-preloader').hide();
        }
        // 待办事项点击事件
        taskClickEvt(urlJson);
    };
    // 待办事项点击事件
    function taskClickEvt(urlJson) {
        // 点击提醒前往web端查看
        container.find('.task-con .webLook').off('click');
        container.find('.task-con .webLook').on('click', function () {
            app.alert('请前往web端查看此项服务活动', '温馨提示');
        });
        // 点击事件 提醒前往web端添加
        container.find('.task-con .webAdd').off('click');
        container.find('.task-con .webAdd').on('click', function () {
            if ($$(this).hasClass('activeDone')) {
                return;
            };
            app.alert('请前往web端添加此项服务活动', '温馨提示');
        });
        // app添加
        container.find('.task-con .appAdd').off('click');
        container.find('.task-con .appAdd').on('click', function () {
            // 添加页面传值：报告Id、协议Id、业务期间Id、业务期间名称
            var data = {
                'sprReportId': '',//报告id
                'sprPlanDetailId': $$(this).attr('data-id'),//计划明细id
                'cooCoopAgreementID': $$(this).attr('data-cooCoopAgreementID'),//协议Id
                'calendarBeginDate': $$(this).attr('data-calendarBeginDate'),// 协议开始时间
                'calendarEndDate': $$(this).attr('data-calendarEndDate'),//日历结束时间
                'companyProduct': $$(this).attr('data-companyProduct'),// 产品列表
                'periodID': $$(this).attr('data-periodID'),// 业务期间id
                'periodName': $$(this).attr('data-periodName')// 业务期间名称
            },
                thisUrl = urlJson[$$(this).attr('data-projectName')],
                currentView = app.getCurrentView();
            if ($$(this).hasClass('activeDone')) {
                app.confirm($$(this).attr('data-projectName') + '完成率已达100%，是否继续创建?', '温馨提示', function () {
                    // 继续
                    currentView.router.load({
                        url: thisUrl,
                        query: {
                            taskData: data
                        }
                    });
                }, function () {
                    //点击取消
                    return;
                });
            } else {
                currentView.router.load({
                    url: thisUrl,
                    query: {
                        taskData: data
                    }
                });
            }
        });
        // 点击计划数量时，查看已关联的数据
        container.find('.task-con .appSelect').off('click');
        container.find('.task-con .appSelect').on('click', function () {
            var type = $$(this).attr('data-projectName'),// 类型
                planDetailId = $$(this).attr('data-id'),// 计划明细id
                periodID = $$(this).attr('data-periodID'); // 业务期间id
            var pageUrl = './home/task/list.html?sprPlanDetailId=' + planDetailId + '&type=' + type + '&periodID=' + periodID + '&isPlan=true';
            var currentView = app.getCurrentView();
            currentView.router.load({
                url: pageUrl
            });
        });
        // 点击计划数量时，选择已完成并未关联的数据（）
        container.find('.task-con .appaddAndEdit').off('click');
        container.find('.task-con .appaddAndEdit').on('click', function () {
            var type = $$(this).attr('data-projectName'),// 类型
                pageUrlJson = {
                    '问卷调研': { 'addurl': './marketing/questionnaire/add.html', 'detailUrl': './marketing/questionnaire/detail.html' }
                };
            // 添加页面传值：报告Id、协议Id、业务期间Id、业务期间名称
            var data = {
                'sprReportId': '',//报告id
                'sprPlanDetailId': $$(this).attr('data-id'),//计划明细id
                'cooCoopAgreementID': $$(this).attr('data-cooCoopAgreementID'),//协议Id
                'calendarBeginDate': $$(this).attr('data-calendarBeginDate'),// 协议开始时间
                'calendarEndDate': $$(this).attr('data-calendarEndDate'),//日历结束时间
                'periodID': $$(this).attr('data-periodID'),// 业务期间id
                'periodName': $$(this).attr('data-periodName')// 业务期间名称
            }, currentView = app.getCurrentView();
            currentView.router.load({
                url: pageUrlJson[type].addurl,
                query: {
                    taskData: data
                }
            });
        });
    }

    // 获取一段时间的日程数量
    function GetRoutineWorkCountByDate(beginDate, endDate, isUpdate) {
        app.showIndicator();
        var values = {
            beginDate: beginDate,
            endDate: endDate
        };
        var param = {
            ajaxUrl: 'api/services/app/calendar/GetRoutineWorkCountByDate',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: GetRoutineWorkCountByDateCallback,
            ajaxAgainEvt: GetRoutineWorkCountByDate,
            ajaxText: '获取某月日程计划数量',
            isUpdate: isUpdate
        }
        common.ajaxMethod(param);

    }
    function GetRoutineWorkCountByDateCallback(ret, param) {
        // 处理事件日期
        $$.each(ret.result, function (index, value) {
            if (value.count > 0) {
                // 如果日程数量大于0，则在日历中添加标志
                thisYear = value.date.split('-')[0];
                thisMon = value.date.split('-')[1] - 1;
                thisDay = value.date.split('-')[2];
                timeArr.push(new Date(thisYear, thisMon, thisDay));
            }
        })
        // 查询出结果后
        if (!param.isUpdate && param.isUpdate != 'true') {
            // 打开日历
            calendarShow(ret, param.isUpdate);
        } else {
            $$('.picker-calendar-day').removeClass('picker-calendar-day-has-events');
            // 获取日历显示年月
            var calendarData = new Date(param.ajaxValues.beginDate),
                calendarYear = calendarData.getFullYear(),
                calendarMonth = calendarData.getMonth();
            // 更新日历
            $$.each(timeArr, function (index, value) {
                //循环数据库得到的数据对每个数据进行处理
                var curData = value,
                    curYear = curData.getFullYear(),
                    curMonth = curData.getMonth();
                if (calendarMonth == curMonth && calendarYear == curYear) {
                    var curDay = curData.getDate();
                    var dom = container.find('.picker-calendar-day').filter(function (index, value) {
                        //筛选当天的数据，根据数据的状态进行当天数据CSS的添加
                        var year = $$(value).attr('data-year');
                        var month = $$(value).attr('data-month');
                        var day = $$(value).attr('data-day');
                        //年月日相等，就确定是当天
                        if (year == curYear && month == curMonth && day == curDay) {
                            return $$(value);
                        }
                    });
                    dom.addClass('picker-calendar-day-has-events');
                }
            });
        }
    }
    // 日历事件
    function calendarShow() {
        // 默认开始的结束开始时间为当月
        var startDate = new Date(),
            dateArrstring = moment(startDate).format('YYYY-MM-DD'),
            dateArr = dateArrstring.split('-');
        var month = (Number(dateArr[1])) > 9 ? Number(dateArr[1]) : ('0' + Number(dateArr[1]));
        endData = startData = dateArrstring;
        // 初始化日历
        var calendarInline = app.calendar({
            container: '#calendar-inline-container',
            dateFormat: 'yyyy-mm-dd',
            dayNamesShort: ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'],
            monthNames: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
            value: [new Date()],
            header: false,
            footer: false,
            toolbarTemplate: '<div class="toolbar calendar-custom-toolbar">' +
                '<div class="toolbar-inner">' +
                '<div class="left">' +
                '<a href="#" class="link icon-only"><i class="icon icon-back" style="color:#303a4c"></i></a>' +
                '</div>' +
                '<div class="center" style="color:#303a4c"></div>' +
                '<div class="right">' +
                '<a href="#" class="link icon-only"><i class="icon icon-drop-down" style="color:#303a4c"></i></a>' +
                '</div>' +
                '</div>' +
                '</div>',
            onOpen: function (p) {
                $$('.calendar-custom-toolbar .center').text(p.currentYear + '年 ' + p.params.monthNames[p.currentMonth]);
                $$('.calendar-custom-toolbar .left .link').on('click', function () {
                    calendarInline.prevMonth();

                    // 获取一段时间的日程数量
                    // 日历当月第一天
                    new_dateFrist = new Date(p.currentYear, p.currentMonth, 1)
                    // 日历当月最后一天
                    new_dateLast = new Date(new Date(p.currentYear, p.currentMonth + 1, 1).getTime() - 1000 * 60 * 60 * 24);
                    GetRoutineWorkCountByDate(moment(new_dateFrist).format('YYYY-MM-DD'), moment(new_dateLast).format('YYYY-MM-DD'), true);
                });
                $$('.calendar-custom-toolbar .right .link').on('click', function () {
                    calendarInline.nextMonth();
                    // 获取一段时间的日程数量
                    // 日历当月第一天
                    new_dateFrist = new Date(p.currentYear, p.currentMonth, 1)
                    // 日历当月最后一天
                    new_dateLast = new Date(new Date(p.currentYear, p.currentMonth + 1, 1).getTime() - 1000 * 60 * 60 * 24);
                    GetRoutineWorkCountByDate(moment(new_dateFrist).format('YYYY-MM-DD'), moment(new_dateLast).format('YYYY-MM-DD'), true);
                });
                getCalendarDataList();
            },
            onMonthYearChangeStart: function (p) {
                $$('.calendar-custom-toolbar .center').text(p.currentYear + '年 ' + p.params.monthNames[p.currentMonth]);
                // 获取一段时间的日程数量
                // 日历当月第一天
                new_dateFrist = new Date(p.currentYear, p.currentMonth, 1)
                // 日历当月最后一天
                new_dateLast = new Date(new Date(p.currentYear, p.currentMonth + 1, 1).getTime() - 1000 * 60 * 60 * 24);
                GetRoutineWorkCountByDate(moment(new_dateFrist).format('YYYY-MM-DD'), moment(new_dateLast).format('YYYY-MM-DD'), true);
            },
            onDayClick: function (p, dayContainer, year, month, day) {
                // 获取点击日期
                var month = Number(month) + 1 > 9 ? Number(month) + 1 : '0' + (Number(month) + 1);
                var day = Number(day) > 9 ? day : '0' + day;
                todayDate = year + '-' + month + '-' + day;
                //清空展示列表
                container.find('.calendar-con .calendar-list').html('');
                container.find('.calendar-con .list-preloader').show();
                // 获取当日日程
                getCalendarDataList();
            },
            events: timeArr
        });
    }
    // 获取日程活动列表
    function getCalendarDataList() {
        var values = {
            beginDate: todayDate ? todayDate : moment(new Date()).format('YYYY-MM-DD'),
            maxResultCount: 200,
            skipCount: 0,
        };
        var param = {
            ajaxUrl: 'api/services/app/calendar/GetRoutineWorkListByDate',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: getCalendarDataListCallback,
            ajaxAgainEvt: getCalendarDataList,
            ajaxText: '获取日程活动列表'
        }
        common.ajaxMethod(param);
    }
    function getCalendarDataListCallback(ret, param) {
        // 编译模板
        var template = container.find('.calendar-con .calendar-tmp-list').html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(ret.result);
        container.find('.calendar-con .calendar-list').html('<ul>' + html + '</ul>');
        container.find('.calendar-con .list-preloader').hide();
    }
})