/**
 * 产品及品牌提示物宣传详情
 * @author:娄浩
 * @date2018-6-12
 */
define(function () {
    var container = null,
        id = null,
        sharedId = null,// 分享id
        reportproductData = null, //产品及品牌提示物宣传详情数据
        currentView = null,
        navbarInnerContainer = null;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                currentView = app.getCurrentView();
                id = page.query.id;
                getData();
                bindEvent();
            }
        }
    };
    //获取数据
    function getData() {
        app.showIndicator();
        var param = {
            ajaxUrl: 'api/services/app/reportProductAndBrandPromo/GetReportProductAndBrandPromoById',
            ajaxMethod: 'post',
            ajaxValues: { id: id },
            ajaxCallback: showData,
            ajaxAgainEvt: getData,
            ajaxText: '产品及品牌提示物宣传详情'
        }
        common.ajaxMethod(param);
    }
    //展示数据
    function showData(ret) {
        reportproductData = ret.result;
        sharedId = ret.result.sharedId;
        var data = ret.result;
        // 根据状态显示底部工具栏内容0：进行中；1：已完成
        if (data.status != '1' || data.status != 1) {
            if (data.isApproval == false || data.isApproval == 'false') {
                //解除修改禁用
                navbarInnerContainer.find('.btn-edit').removeClass('disabled');
                container.find('.complete-btn').removeClass('disabled');
            }
            container.find('.complete-btn').text('完成');
        } else {
            container.find('.complete-btn').addClass('disabled');
            container.find('.complete-btn').text('已完成');
        }
        // 显示底部工具栏
        if (data.productAndBrandPromoId) {
            app.showToolbar(container.find('.toolbar'));
        }
        // 日期时间
        data.deliveryDate = data.deliveryDate ? common.dateFormat(data.deliveryDate, 'YYYY-MM-DD') : '';
        // 遍历字段
        $$.each(data, function (key, value) {
            container.find('[data-name="' + key + '"]').text(value);
        });
    }
    //绑定事件
    function bindEvent(data) {
        // 监听产品及品牌提示物宣传修改事件
        $$(document).off('after-active-change-detail');
        $$(document).on('after-active-change-detail', function (e) {
            getData();
        });
        //判断有无修改产品及品牌提示物宣传权限
        if (permissions.reportProductAndBrandPromo.update) {
            navbarInnerContainer.find('.btn-edit').removeClass('hide');
            navbarInnerContainer.find('.btn-edit').css('display', 'inline-flex');
            app.sizeNavbars('.view'); //iOS only
            //跳转编辑页面
            navbarInnerContainer.find('.btn-edit').on('click', function () {
                currentView.router.load({
                    url: './marketing/activity/reportproduct-crandpromo/edit.html',
                    query: {
                        reportproductData: reportproductData
                    }
                });
            });
        }
        //跳转答题人列表
        container.find('.people-btn').on('click', function () {
            currentView.router.load({
                url: './marketing/activity/reportproduct-crandpromo/viewer-list.html',
                query: {
                    id: id,
                }
            });
        });
        // 分享
        container.find('.share-btn').on('click', function () {
            var param = {
                shareedId: sharedId,
                typeId: 0,
                scene: '',
                templateId: sharedId,
                page: 'pages/reportproduct-crandpromo/detail/index' //需要打开的小程序页面路径
            };
            require(['plugin/component/share'], function (share) {
                share.init(param);
            });
        });
        // 完成
        container.find('.complete-btn').on('click', function () {
            if (reportproductData.deliveryNum == 0 || reportproductData.deliveryNum == '0') {
                app.alert('此服务活动还未投送，不能点击完成', '温馨提醒');
            } else {
                app.confirm('确认完成？', '温馨提醒', function () {
                    updateStatus(1);
                });
            }
        });
    }
    // 更改数据状态
    function updateStatus(status) {
        app.showIndicator();
        var values = {
            "id": id,
            "status": status
        };
        var param = {
            ajaxUrl: 'api/services/app/reportProductAndBrandPromo/UpdateReportProductAndBrandPromoStatus',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: ajaxCallback,
            ajaxAgainEvt: updateStatus,
            ajaxText: '产品及品牌提示物宣传完成'
        }
        common.ajaxMethod(param);
    }
    function ajaxCallback(ret) {
        common.notification('恭喜', '产品及品牌提示物宣传已完成', 'success');
        container.find('.complete-btn').addClass('disabled');
        container.find('.complete-btn').text('已完成');
    }
});