/**
 * 营销-新增问卷调研
 * @author :陈汝冰
 * @date 2018-05-15
 */
define(['plugin/validate', 'moment'], function (validate, moment) {
    var container = null,
        navbarInnerContainer = null,
        sprPlanDetailId = '',
        CoopAgreementId = '',
        taskData = null,
        researchSubjects = null, //调研对象
        pid = '';
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar');
                researchSubjects = page.query.researchSubjects;
                pid = '';
                taskData = page.query.taskData;
                sprPlanDetailId = taskData ? taskData.sprPlanDetailId : '';
                CoopAgreementId = taskData ? taskData.cooCoopAgreementID : '';
                bindEvent();
            }
        }
    };
    //事件绑定
    function bindEvent() {
        // 监听选择产品
        api.addEventListener({
            name: 'questionnaireProductSelect'
        }, function (ret, err) {
            if (ret && ret.value) {
                if (ret.value.type == 'productFormatList') {
                    if (pid != ret.value.productFormatList) {
                        container.find('[name="templeteId"]').val('');
                        container.find('[name="templeteIdName"]').val('');
                    }
                    pid = ret.value.productFormatList;
                } else {
                    if (pid != ret.value.productList) {
                        container.find('[name="templeteId"]').val('');
                        container.find('[name="templeteIdName"]').val('');
                    }
                    pid = ret.value.productList;
                }
                // 产品名称赋值
                container.find('[name="productIdName"]').val(ret.value.name);
                // 产品品规id
                container.find('[name="productList"]').val(ret.value.productList);
                // 产品目录id
                container.find('[name="productFormatList"]').val(ret.value.productFormatList);
            }
        });

        var time_begin = container.find('[name="startDateTime"]'),
            time_end = container.find('[name="endDateTime"]');
        if (taskData) {
            // 给开始结束时间添加默认值，结束时间
            time_begin.val(moment(taskData.calendarBeginDate).format('YYYY-MM-DD'));
            time_end.val(moment(taskData.calendarEndDate).format('YYYY-MM-DD'));
            common.calendarLimitPicker(time_begin, taskData.calendarBeginDate, taskData.calendarEndDate);
            common.calendarLimitPicker(time_end, taskData.calendarBeginDate, taskData.calendarEndDate);
            // 默认为协议业务期间
            container.find('[name="baseSalesPeriodId"]').val(taskData.periodID);
            container.find('[name="baseSalesPeriodIdName"]').val(taskData.periodName);
            container.find('[name="baseSalesPeriodIdName"]').addClass('disabled');
        } else {
            // 给开始结束时间添加默认值，当天
            time_begin.val( moment(new Date()).format('YYYY-MM-DD'));
            time_end.val( moment(new Date()).format('YYYY-MM-DD'));
            common.calendarPicker(time_begin);
            common.calendarPicker(time_end);
            // 添加当前业务区间默认值
            container.find('[name="baseSalesPeriodId"]').val(localStorage.getItem('currentPeriodId'));
            container.find('[name="baseSalesPeriodIdName"]').val(localStorage.getItem('currentPeriodName'));
            //业务期间
            require(['plugin/component/autocomplete'], function (autocomplete) {
                // 参数：操作对象，接口地址，查询的列表内容，回调方法（选填，如果需要根据选择的内容查询相关内容，则传此参数）
                autocomplete.initPopup('[name="baseSalesPeriodIdName"]', 'api/services/app/baseSalesPeriod/GetBaseSalesPeriodToSelect2', '业务期间');
            });
        }
        //展示问卷调研对象
        var researchSubjectsName = container.find('[name="researchSubjectsName"]');
        // 当有sprPlanDetailId的时候（从待办事项点击进入），可以选择调研对象
        if (sprPlanDetailId) {
            common.optionsPicker([{
                input: researchSubjectsName,
                type: '专项调研调研对象'
            }]);
        } else {
            researchSubjectsName.val(options['专项调研调研对象'].data[researchSubjects]);
            container.find('[name="researchSubjects"]').val(researchSubjects);
            researchSubjectsName.addClass('disabled');
        }
        // 调研方式
        var researchMethodsName = container.find('[name="researchMethodsName"]');
        common.optionsPicker([{
            input: researchMethodsName,
            type: '专项调研调研方式'
        }]);
        //选择产品
        container.find('[name="productIdName"]').on('click', function () {
            var currentView = app.getCurrentView();
            currentView.router.load({
                url: './marketing/questionnaire/select-product.html?CoopAgreementId=' + CoopAgreementId,
            });
        })
        //问卷调研主题
        container.find('[name="templeteIdName"]').on('click', function () {
            var productListid = container.find('[name="productList"]').val(),
                productFormatListid = container.find('[name="productFormatList"]').val();
            if (!productListid && !productFormatListid) {
                app.alert('请先选择产品!');
                return;
            }
            questionList(productListid, productFormatListid);
        })
        //提交表单
        navbarInnerContainer.find('.btn-submit').click(function () {
            validator.validateForm();
        });
        // 表单验证 
        var validator = new FormValidator('form-questionnaire-add', [{
            name: 'name',
            display: '调研项目名称',
            rules: 'required'
        }, {
            name: 'productIdName',
            display: '产品名称',
            rules: 'required'
        }, {
            name: 'templeteIdName',
            display: '问卷调研主题',
            rules: 'required'
        }, {
            name: 'baseSalesPeriodIdName',
            display: '业务期间',
            rules: 'required'
        }, {
            name: 'reportsNumber',
            display: '调研报告份数',
            rules: 'required|numeric'
        }], function (errors, event) {
            if (errors.length > 0) {
                $$.each(errors, function (index, value) {
                    common.notification('提示', value.message, 'warning');
                });
            } else {
                container.find('[name="startDateTime"]').val()
                container.find('[name="endDateTime"]').val()
                if (container.find('[name="endDateTime"]').val() < container.find('[name="startDateTime"]').val()) {
                    common.notification('提示', '结束日期不能早于开始日期', 'warning');
                    return;
                }
                navbarInnerContainer.find('.btn-submit').addClass('disabled');
                saveData();
            }
        });
    };
    // 问卷下拉列表
    function questionList(productListid, productFormatListid) {
        app.showIndicator();
        var values = {
            productFormatList: productFormatListid,//目录
            productList: productListid//品规
        }
        var param = {
            ajaxUrl: 'api/services/app/qSQuestionnaireTemplate/GetTemplateSelect2ById',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: questionListajaxCallback,
            ajaxAgainEvt: questionList,
            ajaxText: '获取调研问卷'
        }
        common.ajaxMethod(param);
    }
    function questionListajaxCallback(ret) {
        var optionData = {
            'data': []
        },
            eventData = ret.result;
        for (var i = 0; i < eventData.length; i++) {
            optionData.data[i] = {};
            optionData.data[i].id = eventData[i].id;
            optionData.data[i].name = eventData[i].text;
        }
        if (optionData.data.length == 0) {
            app.alert('请先创建问卷模板');
            app.hideIndicator();
            return;
        }
        require(['plugin/component/radio-common-option'], function (relationshipAdd) {
            relationshipAdd.init(optionData, '', selectQuestionCallback);
        });
    }
    // 选择主题后的回调
    function selectQuestionCallback(result) {
        container.find('[name="templeteIdName"]').val(result.name);
        container.find('[name="templeteId"]').val(result.id);
    }
    // 生成问卷
    function saveData() {
        app.showIndicator();
        var values = app.formToJSON('form[name="form-questionnaire-add"]');
        values.sprReportId = taskData ? taskData.sprReportId : '';
        values.sprPlanDetailId = taskData ? taskData.sprPlanDetailId : '';
        values.contractorId = contractorId; //服务商Id
        values.contractorEmployeeId = contractorEmployeeId; //服务商代表Id
        // app端
        values.isApp = true;
        var param = {
            ajaxUrl: 'api/services/app/reportResearchSummary/CreateOrUpdateReportResearchSummary',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: saveDataCallback,
            ajaxAgainEvt: saveData,
            ajaxText: '新增调研问卷'
        }
        common.ajaxMethod(param);
    };
    function saveDataCallback(ret) {
        navbarInnerContainer.find('.btn-submit').removeClass('disabled');
        if (ret.result.status == 'y') {
            common.notification('恭喜', '添加成功', 'success');
            //更新列表界面数据
            $$(document).trigger('after-active-change');
            // 返回上一个页面
            var currentView = app.getCurrentView();
            currentView.router.back();
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
})