/**
 * 营销-编辑问卷调研
 * @author :陈汝冰
 * @date 2018-05-15
 */
define(['plugin/validate', 'moment'], function (validate, moment) {
    var container = null,
        navbarInnerContainer = null,
        preloader = null,
        pid = '',
        pz = 20,
        id = '',
        pi = 0,
        keyword = '',
        data = '',
        pageContent = null,
        loading = false;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar');
                pageContent = container.find('.page-content');
                preloader = container.find('.list-preloader');
                data = page.query.editData;
                id = data.id;
                showData(data);
                if (data.productList) {
                    pid = data.productList;
                } else if (data.productFormatList) {
                    pid = data.productFormatList;
                } else {
                    pid = '';
                }
            }
        }
    };
    //展示数据
    function showData(data) {
        if (data.startDateTime) {
            data.startDateTime = moment(data.startDateTime).format('YYYY-MM-DD');
            data.startDate = moment(data.startDateTime).format('YYYY-MM-DD');
        }
        if (data.endDateTime) {
            data.endDateTime = moment(data.endDateTime).format('YYYY-MM-DD');
            data.endDate = moment(data.endDateTime).format('YYYY-MM-DD');
        }
        data.researchSubjectsName = options['专项调研调研对象'].data[data.researchSubjects];
        data.researchMethodsName = options['专项调研调研方式'].data[data.researchMethods];
        $$.each(data, function (key, value) {
            container.find('[name="' + key + '"]').val(value);
        })
        bindEvent();
    }
    //事件绑定
    function bindEvent() {
        // 监听选择产品
        api.addEventListener({
            name: 'questionnaireProductSelect'
        }, function (ret, err) {
            if (ret && ret.value) {
                if (ret.value.type == 'productFormatList') {
                    if (pid != ret.value.productFormatList) {
                        container.find('[name="templeteId"]').val('');
                        container.find('[name="templeteName"]').val('');
                    }
                    pid = ret.value.productFormatList;
                } else {
                    if (pid != ret.value.productList) {
                        container.find('[name="templeteId"]').val('');
                        container.find('[name="templeteName"]').val('');
                    }
                    pid = ret.value.productList;
                }
                // 产品名称赋值
                container.find('[name="productListName"]').val(ret.value.name);
                // 产品品规id
                container.find('[name="productList"]').val(ret.value.productList);
                // 产品目录id
                container.find('[name="productFormatList"]').val(ret.value.productFormatList);
            }
        });
        var time_begin = container.find('[name="startDateTime"]'),
            time_end = container.find('[name="endDateTime"]');
        if (data.sprPlanDetailId || data.sprCompleteDetailId) {// 判断是否有报告id
            // 给开始结束时间添加默认值，结束时间
            common.calendarLimitPicker(time_begin, data.filter.minDate, data.filter.maxDate);
            common.calendarLimitPicker(time_end, data.filter.minDate, data.filter.maxDate);
            // 默认为协议业务期间
            container.find('[name="baseSalesPeriodId"]').val(data.baseSalesPeriodId);
            container.find('[name="baseSalesPeriodName"]').val(data.baseSalesPeriodName);
            container.find('[name="baseSalesPeriodName"]').addClass('disabled');
        } else {
            // 给开始结束时间添加默认值，当天
            common.calendarPicker(time_begin);
            common.calendarPicker(time_end);
            // 添加当前业务区间默认值
            container.find('[name="baseSalesPeriodId"]').val(localStorage.getItem('currentPeriodId'));
            container.find('[name="baseSalesPeriodName"]').val(localStorage.getItem('currentPeriodName'));
            //业务期间
            require(['plugin/component/autocomplete'], function (autocomplete) {
                // 参数：操作对象，接口地址，查询的列表内容，回调方法（选填，如果需要根据选择的内容查询相关内容，则传此参数）
                autocomplete.initPopup('[name="baseSalesPeriodName"]', 'api/services/app/baseSalesPeriod/GetBaseSalesPeriodToSelect2', '业务期间');
            });
        }
        // 调研方式
        var researchMethodsName = container.find('[name="researchMethodsName"]');
        common.optionsPicker([{
            input: researchMethodsName,
            type: '专项调研调研方式'
        }]);
        //选择产品
        container.find('[name="productListName"]').on('click', function () {
            var currentView = app.getCurrentView();
            var CoopAgreementId = '';
            if (data.sprPlanDetailId || data.sprCompleteDetailId) {
                CoopAgreementId = data.filter.coopAgreementId
            }
            currentView.router.load({
                url: './marketing/questionnaire/select-product.html?CoopAgreementId=' + CoopAgreementId,
            });
        })
        // //问卷调研主题
        container.find('[name="templeteName"]').on('click', function () {
            var productListid = container.find('[name="productList"]').val(),
                productFormatListid = container.find('[name="productFormatList"]').val();
            if (!productListid && !productFormatListid) {
                app.alert('请先选择产品!');
                return;
            }
            questionList(productListid, productFormatListid);
        })
        //提交表单
        navbarInnerContainer.find('.btn-submit').click(function () {
            validator.validateForm();
        });
        // 表单验证 
        var validator = new FormValidator('form-questionnaire-edit', [{
            name: 'name',
            display: '调研项目名称',
            rules: 'required'
        }, {
            name: 'productIdName',
            display: '产品名称',
            rules: 'required'
        }, {
            name: 'templeteName',
            display: '问卷调研主题',
            rules: 'required'
        }, {
            name: 'reportsNumber',
            display: '调研报告份数',
            rules: 'required|numeric'
        }], function (errors, event) {
            if (errors.length > 0) {
                $$.each(errors, function (index, value) {
                    common.notification('提示', value.message, 'warning');
                });
            } else {
                if (container.find('[name="endDateTime"]').val() < container.find('[name="startDateTime"]').val()) {
                    common.notification('提示', '结束日期不能早于开始日期', 'warning');
                    return;
                }
                navbarInnerContainer.find('.btn-submit').addClass('disabled');
                saveData();
            }
        });
    };
    // 问卷下拉列表
    function questionList(productListid, productFormatListid) {
        app.showIndicator();
        var values = {
            productFormatList: productFormatListid,//目录
            productList: productListid//品规
        }
        var param = {
            ajaxUrl: 'api/services/app/qSQuestionnaireTemplate/GetTemplateSelect2ById',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: questionListajaxCallback,
            ajaxAgainEvt: questionList,
            ajaxText: '获取调研问卷'
        }
        common.ajaxMethod(param);
    }
    function questionListajaxCallback(ret) {
        var optionData = {
            'data': []
        },
            eventData = ret.result;
        for (var i = 0; i < eventData.length; i++) {
            optionData.data[i] = {};
            optionData.data[i].id = eventData[i].id;
            optionData.data[i].name = eventData[i].text;
        }
        if (optionData.data.length == 0) {
            app.alert('请先创建问卷模板');
            app.hideIndicator();
            return;
        }
        require(['plugin/component/radio-common-option'], function (relationshipAdd) {
            relationshipAdd.init(optionData, '', selectQuestionCallback);
        });
    }
    // 选择主题后的回调
    function selectQuestionCallback(result) {
        container.find('[name="templeteName"]').val(result.name);
        container.find('[name="templeteId"]').val(result.id);
    }
    // 保存
    function saveData() {
        app.showIndicator();
        var values = app.formToJSON('form[name="form-questionnaire-edit"]');
        values.researchSubjects = data.researchSubjects; //调研对象
        values.id = id;
        values.sprReportId = data.sprReportId;
        values.sprPlanDetailId = data.sprPlanDetailId;
        values.sprCompleteDetailId = data.sprCompleteDetailId;
        values.contractorId = contractorId; //服务商Id
        values.contractorEmployeeId = contractorEmployeeId; //服务商代表Id
        // app端
        values.isApp = true;
        var param = {
            ajaxUrl: 'api/services/app/reportResearchSummary/CreateOrUpdateReportResearchSummary',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: saveDataCallback,
            ajaxAgainEvt: saveData,
            ajaxText: '修改调研'
        }
        common.ajaxMethod(param);
    };
    function saveDataCallback(ret) {
        if (ret.result.status == 'y') {
            common.notification('恭喜', '修改成功', 'success');
            //更新问卷列表界面数据
            $$(document).trigger('after-active-change');
            $$(document).trigger('after-active-change-detail');
            //返回上一页 
            var currentView = app.getCurrentView();
            currentView.router.back();
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
        navbarInnerContainer.find('.btn-submit').removeClass('disabled');
    }
})