/*
 * 我的csp机构-开通签章
 * @author 韩慧
 * @date 2018.09.11
 * */
define(function () {
    var container = null,
        navbarInnerContainer = null,
        currentView = null,
        data = null;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                currentView = app.getCurrentView();
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                data = page.query.data;
                showData(); // 获取数据
                bindEvent();
            };
        }
    };
    //展示数据
    function showData() {
        if (data.esignStatus) {
            if (data.esignStatus == 1) {// 已开通
                data.esignStatusName = '已开通';
                navbarInnerContainer.find('.center').text('电子签章续费');
                container.find('.btn-open').text('电子签章续费');
            } else if (data.esignStatus == 2) {
                data.esignStatusName = '已到期';
            }
        } else {// 未开通
            data.esignStatusName = '未开通';
        }
        //遍历展示数据
        $$.each(data, function (key, value) {
            container.find('[data-name=' + key + ']').text(value);
        });
    };
    function bindEvent() {
        // 电子签章使用须知
        container.find('.signature-instructions').on('click', function () {
            currentView.router.load({
                url: './mine/cspagency/signature/signature-instructions.html',
            });
        });
        // 电话咨询
        container.find('.btn-tel').on('click', function () {
            common.authorizationRemind('phone', common.callPhone, '053188257769');
        });
        // 缴费功能
        container.find('.btn-open').on('click', function () {
            // 判断是否已经选中阅读，如果没有选择则提示
            if (container.find('[name="read"]').is(':checked')) {
                currentView.router.load({
                    url: './mine/cspagency/signature/pay-select.html',
                    query: {
                        id: data.id,
                        price: data.price
                    }
                });
            } else {
                common.notification('提示', '开通前请阅读并勾选电子签章使用须知', 'warning');
            }
        });
    }
});