/*
 * 我的csp机构-开通签章
 * @author 韩慧
 * @date 2018.09.11
 * */
define(['moment'], function (moment) {
    var container = null,
        navbarInnerContainer = null,
        currentView = null,
        wx = api.require('wx'),
        wxPay = api.require('wxPay'), //微信支付模块
        aliPayPlus = api.require('aliPayPlus'), //支付宝支付模块
        payOrderNumApp = '',// 订单编号
        payType = 1, // 支付方式，1微信，2支付宝
        money = null,//缴费金额
        id = '';
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                currentView = app.getCurrentView();
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                id = page.query.id;
                money = page.query.price;
                payOrderNumApp = '';
                payType = 1;
                bindEvent();
            };
        }
    };
    function bindEvent() {
        container.find('[data-name="price"]').text(money);
        // 支付按钮
        container.find('.btn-pay').on('click', function () {
            // 支付方式    1：微信；2：支付宝
            payType = container.find('[name="pay-radio"]:checked').val();
            // 判断是否是微信支付
            if (payType == 1 || payType == '1') {
                //检测微信
                wx.isInstalled(function (ret, err) {
                    if (ret && ret.installed) {
                        addOrder();
                    } else {
                        app.alert('您没有安装微信客户端，请安装之后再支付');
                    }
                });
            } else {
                addOrder();
            }
        });
    }
    // 电子签章创建订单
    function addOrder() {
        app.showIndicator();
        var values = {
            payType: payType,// 支付方式
            duration: 1,//
            status: 0,//
            money: money,// 缴费金额
            cspIds: id// csp机构id
        };
        var param = {
            ajaxUrl: 'api/services/app/eSealPaymentInfo/AddESealPaymentInfo',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: addOrderajaxCallback,
            ajaxAgainEvt: addOrder,
            ajaxText: '电子签章创建订单'
        }
        common.ajaxMethod(param);
    }
    function addOrderajaxCallback(ret) {
        if (ret.result.status == 'y') {
            payOrderNumApp = ret.result.data.payOrderNum;
            // 判断支付方式
            if (payType == 1) {
                // 微信
                wxPayConfig(); //直接下单配置项
            } else if (payType == 2) {
                // 支付宝
                getQianmin();
            }
        } else {
            app.alert('金额验证失败，请与客服联系，客服电话：0531-88257769', '电子签章创建订单');
            app.hideIndicator();
        }
    }
    /**
     * 微信下单配置项
     * 支付方式 二 
     * 第一步 配置模块内部处理签名时需要的参数，所需参数都从res目录下的key.xml读取
     */
    function wxPayConfig() {
        wxPay.config({
            notifyUrl: server + 'Mpa/PayMent/WeCharNotify'//支付结果回调页面
        }, function (ret, err) {
            if (ret.status) {
                wxPayEvt();//支付订单
            } else {
                //-1（未知错误）
                //1（apiKey 值非法）
                //2（mchId 值非法）
                //3（partnerKey 值非法）
                //4（notifyUrl 值非法）
                app.alert('配置商户支付参数失败' + err.code, '提示');//错误提示
                app.hideIndicator();
            }
        });
    }
    /*
    * 微信支付订单（适用于支付方案二）
    * @param {object} description 订单简要描述
    * @param {object} totalFee 订单总金额
    * @param {object} tradeNo 订单号
    * @param {object} feeType 货币类型
    */
    function wxPayEvt() {
        var param = {
            description: '药销通-电子签章开通',//订单简要描述
            totalFee: money * 100,//订单总金额，只能为整数，单位：分（￥）
            tradeNo: payOrderNumApp,//商户系统内部的订单号
            feeType: 'CNY',//货币类型
        };
        wxPay.pay(param, function (ret, err) {
            if (ret.status) {
                app.hideIndicator();
                //支付成功，开通电子签章
                openSignature();
            } else {
                //错误码：
                //-2（用户取消）
                //-1（可能的原因：签名错误、未注册APPID、项目设置APPID不正确、注册的APPID与设置的不匹配、其他异常等）
                //1（必传参数缺失）                
                if (err.code == -2) { //用户取消
                    common.notification('提示', '支付已取消', 'info');
                } else {
                    app.alert(err.msg, '支付失败'); //错误提示
                }
                app.hideIndicator();
            }
        });
    }
    // 支付宝生成签名
    function getQianmin() {
        var values = {
            payMentMsg: 'app_id=2018080360941057&biz_content={"subject": "签章购买","body": "药销通-电子签章开通","out_trade_no": "' + payOrderNumApp + '","total_amount": "' + money + '","product_code": "QUICK_MSECURITY_PAY"}&charset=utf-8&format=json&method=alipay.trade.app.pay&notify_url=' + server + 'Mpa/PayMent/AlipayNotify&sign_type=RSA2&timestamp=' + moment(new Date()).format("YYYY-MM-DD HH:mm:ss") + '&version=1.0'
        };
        var param = {
            ajaxUrl: 'api/services/app/agency/MakeEncodeForApp',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: aliPayPlusPayOrder,
            ajaxAgainEvt: getQianmin,
            ajaxText: '支付宝生成签名'
        }
        common.ajaxMethod(param);
    }
    /**
     * 调用支付宝客户端支付
     * 支付方式 一
     */
    function aliPayPlusPayOrder(ret) {
        var url = ret.result.data;
        aliPayPlus.payOrder({
            orderInfo: url
        }, function (ret, err) {
            //字符串类型；错误码，取值范围如下：
            //9000：支付成功
            //8000：正在处理中，支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态
            //4000：订单支付失败
            //5000：重复请求
            //6001：用户中途取消支付操作
            //6002：网络连接出错
            //6004：支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态
            if (ret) {
                switch (ret.code) {
                    case '9000':
                        // 支付成功
                        openSignature();
                        break;
                    case '8000':
                        app.alert('', '正在处理中，支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态');
                        break;
                    case '4000':
                        app.alert('', '订单支付失败');
                        break;
                    case '5000':
                        app.alert('', '重复请求');
                        break;
                    case '6001':
                        app.alert('', '用户中途取消支付操作');
                        break;
                    case '6002':
                        app.alert('', '网络连接出错');
                        break;
                    case '6004':
                        app.alert('', '支付结果未知（有可能已经支付成功），请查询商户订单列表中订单的支付状态');
                        break;
                }
            }
            app.hideIndicator();
        });
    }
    // 开通电子签章
    function openSignature() {
        app.showIndicator();
        var openSignatureValues = {
            "id": id,
            "payOrderNum": payOrderNumApp,// 后端生成的订单编号
            "transactionNum": 'App',// 支付宝流水单号，因为ac方法没有返回，所以传入App字符串，后端判断处理
            "isSuccess": true
        };
        var param = {
            ajaxUrl: 'api/services/app/agency/AfterPayForApp',
            ajaxMethod: 'post',
            ajaxValues: openSignatureValues,
            ajaxCallback: openSignatureajaxCallback,
            ajaxAgainEvt: openSignature,
            ajaxText: '开通电子签章'
        }
        common.ajaxMethod(param);
    }
    function openSignatureajaxCallback(ret) {
        if (ret.result.status == 'y') {
            common.notification('恭喜', '电子签章开通成功', 'success');
            $$(document).trigger('after-signature');
            // 返回详情页面
            common.closePage('cspagency-detail');
        } else {
            app.alert('开通失败，请与客服联系，客服电话：0531-88257769', '开通电子签章失败');
        }
    }
});