/**
 * 我的-首页
 * @author 吴小龙
 * @date 2017-12-12
 */
define(function () {
    var container = null,
        navbarInnerContainer = null,
        currentView = null,
        userInfoData = null;
    return {
        init: function (page) {
            container = $$(page.container);
            navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
            // 如果已经登录，则获取登录帐号的信息
            showData();
            bindEvent();
        }
    }
    // 获取登录帐号的信息
    function getData() {
        var param = {
            ajaxUrl: 'api/services/app/profile/GetCurrentUserProfile',
            ajaxMethod: 'post',
            ajaxValues: {},
            ajaxCallback: getDataajaxCallback,
            ajaxAgainEvt: getData,
            ajaxText: '获取登录帐号的信息'
        }
        common.ajaxMethod(param);
    }
    function getDataajaxCallback(ret){
        /**
         * 字段说明
         * surname：姓
         * name：名
         * accountPic：头像
         * userName：用户名
         * phoneNumber：手机号
         * emailAddress：邮箱
         * isPhoneNumberConfirmed、timezone：这两个字段用不到，暂时不用管
         */
        contractorId = ret.result.contractorsId; //服务商Id
        contractorEmployeeId = ret.result.contractorEmployeeId; //服务商代表Id
        userId = ret.result.userId; //用户id
        userInfoData = ret.result;
        tenantId = ret.result.tenantId; //租户id
        userType = ret.result.userType;//用户类型
        $$.each(ret.result, function (key, value) {
            localStorage.setItem(key, value);
        });
    }
    //展示数据
    function showData() {
        // 默认当前账户姓名、头像
        container.find('.nickname').text(localStorage.getItem('surname') + localStorage.getItem('name')); //姓+名
        if (localStorage.getItem('accountPic')) {
            container.find('.placeholder-avatar').html('<img src="data:image/png;base64,' + localStorage.getItem('accountPic') + '" width="44" height="44" class="avatar w44">');
        }
        //用户角色
        container.find('.roleIdName').text(localStorage.getItem('roleIdName'));
        //部门名称
        if(localStorage.getItem('baseDepartmentIDName') && localStorage.getItem('baseDepartmentIDName') != 'null'){
            container.find('.baseDepartmentIDName').text(localStorage.getItem('baseDepartmentIDName'));
        }else{
            container.find('.baseDepartmentIDName').text('');
        }
        //企业名称
        container.find('.enterpriseName').text(localStorage.getItem('enterpriseName'));
        app.hideIndicator();
        app.pullToRefreshDone();
    }
    //绑定事件
    function bindEvent() {
        container.find('.pull-to-refresh-content').on('refresh', function () {
            getData();
        });
        //点击跳转到个人信息详情
        container.find('.userinfo').on('click', function () {
            currentView = app.getCurrentView();
            currentView.router.load({
                url: './mine/user/index.html',
                // query: {
                //     userInfoData: userInfoData
                // }
            });
        });
        //展示权限数据
        // 遍历字段
        $$.each(permissions, function (key, value) {
            if (!value.read) {
                container.find('[name="' + key + '"]').addClass('hide');
            }
        });
        if(userType == 'ContractorEmployee'){
            // 服务商登录
            if(!permissions.contractorAgreementNPremises.read){
                container.find('[name="contractorAgreementPremises"]').addClass('hide');
            }
        }
    }
});