/*
 * @Autor: 赵辉
 * @Date: 2019-12-09 17:39:12
 * @LastEditors  : 赵辉
 * @Description: 在线考试详情
 * @LastEditTime : 2020-01-06 18:45:30
 * @FilePath: /widget/js/mine/learning-center/exams-and-surveys/detail.js
 */

define(function () {
    var container = null,
        navbarInnerContainer = null;
        examsindex = 0, //当前题目
        examsnum = 0, //总题数
        examsdata = '', //题目数据
        id = null,
        questionAndAnswers = [], //服务端提交list
        questionData = [], //本地暂存数据
        shareId = 0,
        examsTime = null, //考试时长
        startTime = '', //开始时间
        endTime = '', //结束时间
        OnlineExamId = null,
        autoSub = false,
        timer = null,
        noAnswer = [],
        notNum = null,//未作答题目
        indexes = false;//索引
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                pageContent = container.find('.page-content');
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                id = page.query.id;
                OnlineExamId = page.query.OnlineExamId;
                getitembank(); //请求题库数据
                bindEvent();
            }
        }
    }

    function bindEvent() {
        // 上一题下一题操作 begin
        // 上一题
        $$('.lastquestion').on('click', function () {
            formData = app.formToData('#surveys-form');
            if (examsindex == 0) {
                if (!questionData[examsindex]) {
                    questionData.push(formData);

                } else {
                    for (var p in formData) {
                        questionData[examsindex][p] = formData[p];
                    }
                }
                api.alert({
                    title: '提醒',
                    msg: '已经是第一题了'
                });
            } else {
                if (questionData[examsindex]) {
                    for (var p in formData) {
                        questionData[examsindex][p] = formData[p];
                    }
                } else {
                    questionData.push(formData);
                }
                examsindex--;
                cyclequestions();
                if (questionData[examsindex]) {
                    app.formFromData('#surveys-form', questionData[examsindex]);
                }
            }
        });
        // 下一题
        $$('.nextquestion').on('click', function () {
            formData = app.formToData('#surveys-form');
            if (examsindex == (examsnum - 1)) {
                if (!questionData[examsindex]) {
                    questionData.push(formData);

                } else {
                    for (var p in formData) {
                        questionData[examsindex][p] = formData[p];
                    }
                }
                pushData();
            } else {
                if (questionData[examsindex]) {
                    for (var p in formData) {
                        questionData[examsindex][p] = formData[p];
                    }
                } else {
                    questionData.push(formData);
                }
                formData = '';
                examsindex++;
                cyclequestions();
                
                if (questionData[examsindex]) {
                    app.formFromData('#surveys-form', questionData[examsindex]);
                }
            }
        });
        // 上一题下一题 end
        //索引初始化
        var answerHtml =  document.querySelector(".answer")
        $$('.popup-exams').on('popup:opened', function () {
            indexes = true;
            pushData();
          });
        $$('.popup-exams').on('popup:close', function () {
            answerHtml.innerHTML = '';
            indexes = false;
            questionAndAnswers = [];
        });
        //关闭本页面时的回调
        app.onPageBeforeRemove('exams-and-surveys-examsdetail', function () {
            clearInterval(timer);
        });
    }
    // 题库请求与方法
    function getitembank() {
        app.showPreloader('正在加载中...');
        var values = {
            id: Number(id),
            tenantId: Number(tenantId),
            shareId: shareId,
        };
        var param = {
            ajaxUrl: 'api/services/app/qSQuestionnaireTemplate/GetTemplateById',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: setData,
            ajaxAgainEvt: getitembank,
            ajaxText: '获取考题详情'
        }
        common.ajaxMethod(param);
    }

    function setData(ret) { //作为数据过渡层
        examsnum = ret.result.data.questionNum; //赋值题目数量
        examsdata = ret.result.data.questions //赋值题库数据用于操作
        questionSurveyId = ret.result.data.templateInstanceId;
        examsTime = ret.result.data.examDuration;
        cyclequestions();
        app.modal({
            title: '考前提醒',
            text: '<p class="decription">本次考试共' + examsnum + '个题目,考试时间' + examsTime + '分钟,超时自动提交！</p>',
            buttons: [{
                    text: '放弃考试',
                    onClick: function () {
                        var currentView = app.getCurrentView();
                        currentView.router.back();
                    }
                },
                {
                    text: '开始答题',
                    onClick: function () {
                        countDown(); //执行计时器
                    }
                }
            ]
        });
        app.hidePreloader();

    }
    // 计时器
    function countDown() {
        starttime = new Date();
        starttime.setDate(starttime.getDate());
        startTime = common.dateFormat(starttime, 'YYYY-MM-DD HH:mm:ss');
        var m = examsTime; //分
        var s = 0; //秒
        var countdown = document.querySelector(".righttime")
        getCountdown();
        var timeTost = false;
        timer = setInterval(function () {
            getCountdown()
        }, 1000);

        function getCountdown() {
            if (timeTost) {
                countdown.innerHTML = "<i class='icon icon-naozhong' style='color:#fff'></i><span class='examstime'><font size='3' color='red'>" + m + "分</font><font size='3' color='red'>" + s + "秒</font></span>";
            } else {
                var sysType = api.systemType;
                if (sysType == 'ios') {
                    countdown.innerHTML = "<i class='icon icon-naozhong' style='color:#1bbf9c'></i><span class='examstime'><font size='3' color='#1bbf9c'>" + m + "分</font><font size='3' color='#1bbf9c'>" + s + "秒</font></span>";
                } else {
                    countdown.innerHTML = "<i class='icon icon-naozhong' style='color:#fff'></i><span class='examstime'><font size='3' color='white'>" + m + "分</font><font size='3' color='white'>" + s + "秒</font></span>";
                }
            }
            app.sizeNavbars('.view');
            if (m == 0 && s == 0) {
                app.closeModal();
                app.showPreloader('考试结束，正在提交中')
                autoSub = true;
                setTimeout(function () {
                    pushData();
                }, 1000);
                clearInterval(timer);
            } else if (m == 0 && s >= 59 && !timeTost) {
                app.modal({
                    title: '最后一分钟',
                    text: '<i class="icon icon-error"></i>' + '<p class="decription">当前时间剩余一分钟</p>',
                    buttons: [{
                        text: '知道了'
                    }]
                });
                timeTost = true;
            } else if (m >= 0) {
                if (s > 0) {
                    s--;
                } else if (s == 0) {
                    m--;
                    s = 59;
                }
            }
        }
    }
    // 渲染
    function cyclequestions() {
        document.querySelector(".centernum").innerHTML = '<span>'+ (examsindex + 1) +'/'+examsnum+'</span>';
        // 只有一道题
        if (examsdata.length == 1) {
            document.querySelector(".nextquestion span").innerHTML = '提交';
            document.querySelector(".nextquestion i").classList.add("hide");
            document.querySelector(".nextquestion span").classList.add("subbut")
        }
        // 最后一题以及索引跳转
        if (examsindex == (examsnum - 1)) {
            document.querySelector(".nextquestion span").innerHTML = '提交';
            document.querySelector(".nextquestion i").classList.add("hide");
            document.querySelector(".nextquestion span").classList.add("subbut")

        }
        //点击上一题重置按钮为下一题
        if (examsindex < (examsnum - 1)) {
            document.querySelector(".nextquestion span").innerHTML = '下一题';
            document.querySelector(".nextquestion i").classList.remove("hide");
            document.querySelector(".nextquestion span").classList.remove("subbut")
        }
        var ullist = document.querySelector(".listblock ul");
        ullist.innerHTML = '';
        //根据题目数据下标渲染
        var examstype = document.querySelector(".examstype");
        var title = document.querySelector(".entrance-bottom-frame-line-title");
        examstype.innerHTML = examsdata[examsindex].type == 1 ? '单选题' : (examsdata[examsindex].type == 2 ? '多选题' : '简答题');
        title.innerHTML = examsdata[examsindex].question;
        //判断题型，渲染不同答题方式  
        // 单选题渲染
        if (examsdata[examsindex].type == 1) {
            for (var index = 0; index < examsdata[examsindex].answers.length; index++) {
                ullist.innerHTML += '<li><label class="label-radio item-content">' +
                    '<input type="radio" name="' + examsdata[examsindex].answers[index].questionId + '" value="' + [index] + '">' +
                    '<div class="item-media">' +
                    '<i class="icon icon-form-radio"></i>' +
                    '</div>' +
                    '<div class="item-inner">' +
                    '<div class="item-title">' + examsdata[examsindex].answers[index].answer + '</div>' +
                    '</div>' +
                    '</label>' +
                    '</li>';
            }
        }
        // 多选题渲染
        if (examsdata[examsindex].type == 2) {
            for (var index = 0; index < examsdata[examsindex].answers.length; index++) {
                ullist.innerHTML += '<li>' +
                    '<label class="label-checkbox item-content">' +
                    '<input type="checkbox" name="' + examsdata[examsindex].id + '" value="' + [index] + '">' +
                    '<div class="item-media">' +
                    '<i class="icon icon-form-checkbox"></i>' +
                    '</div>' +
                    '<div class="item-inner">' +
                    '<div class="item-title">' + examsdata[examsindex].answers[index].answer + '</div>' +
                    '</div>' +
                    '</label>' +
                    '</li>'
            }
        };
        // 简答题渲染
        if (examsdata[examsindex].type == 3) {
            ullist.innerHTML += '<li class="align-top">' +
                '<div class="item-content">' +
                '<div class="item-inner">' +
                '<div class="item-input">' +
                '<textarea name="' + examsdata[examsindex].id + '" placeholder="请简略阐述"></textarea>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '</li>';
        }
    }
    function pushData() {
        for (var i = 0; i < examsdata.length; i++) { //循环元数据
            questionAndAnswers.push({ //预填充外层
                "questionId": examsdata[i].id,
                "questionType": examsdata[i].type
            });

            for (var p in questionData[i]) { //循环本地暂存数据
                // 单选题
                if (examsdata[i].id == p && questionAndAnswers[i].questionType == 1) { //判断id 类型 本地数据和元数据
                    var selection = [];
                    selection.push({
                        "orderNum": examsdata[i].answers[questionData[i][p]].orderNum,
                        "answerId": examsdata[i].answers[questionData[i][p]].id
                    })
                    if(selection == ''){
                        questionAndAnswers[i].answers = [];
                    }
                    questionAndAnswers[i].answers = selection
                }
                //多选题
                if (examsdata[i].id == p && questionAndAnswers[i].questionType == 2 && questionAndAnswers[i].questionId == examsdata[i].id) {
                    var selectiongroup = [];
                    for (var h = 0; h < questionData[i][p].length; h++) {
                        selectiongroup.push({
                            "orderNum": examsdata[i].answers[questionData[i][p][h]].orderNum,
                            "answerId": examsdata[i].answers[questionData[i][p][h]].id,
                        })
                    }
                    questionAndAnswers[i].answers = selectiongroup
                }
                //简答题
                if (examsdata[i].id == p && questionAndAnswers[i].questionType == 3 && questionAndAnswers[i].questionId == examsdata[i].id) {
                    var answerContent = [];
                    answerContent.push({
                        "answerContent": questionData[i][p]
                    })
                    questionAndAnswers[i].answers = answerContent
                }
            }
        }
        var answerHtml =  document.querySelector(".answer")
        if(indexes){
            for(var z = 0; questionAndAnswers.length > z; z++){
                answerHtml.innerHTML += '<div class="col-20 numclick" data-num="'+z+'">第'+(z+1)+'题</div>';
                switch (questionAndAnswers[z].questionType){
                    case 1:
                    if(questionAndAnswers[z].answers != undefined){
                        $$(".col-20").eq([z]).addClass("red");
                    }
                    break;
                    case 2:
                    if(questionAndAnswers[z].answers != undefined){
                        if(questionAndAnswers[z].answers.length > 0){
                            $$(".col-20").eq([z]).addClass("red");
                        }
                        
                    }
                    break;  
                    case 3:
                    if(questionAndAnswers[z].answers != undefined){
                        if(questionAndAnswers[z].answers[0].answerContent != ""){
                            $$(".col-20").eq([z]).addClass("red");
                        }     
                    }
                    break;
                }
            }
            $$('.numclick').on('click', function () {
                examsindex = Number($$(this).attr('data-num'));
                cyclequestions();
                app.closeModal();
            });
            return;
        }
        if (!autoSub) {
            for(var h = 0; questionAndAnswers.length > h; h++){
                switch (questionAndAnswers[h].questionType){
                    case 1:
                    if(!questionAndAnswers[h].answers){
                        noAnswer.push([h]);
                    }
                    break;
                    case 2:
                    if(questionAndAnswers[h].answers == 0){
                        noAnswer.push([h])
                    }else{
                        if(!questionAndAnswers[h].answers){
                            noAnswer.push([h]);
                        }
                    }  
                    break;  
                    case 3:
                        if(questionAndAnswers[h].answers == undefined){
                            noAnswer.push([h])   
                        }else{
                            if(questionAndAnswers[h].answers[0].answerContent == ""){
                                noAnswer.push([h])
                            } 
                        } 
                }
            }
            noAnswer = noAnswer?noAnswer.length:''
            if(noAnswer > 0){
                app.modal({
                    title:  '提交考试',
                    text: '你还有'+noAnswer+'道题没答，确定要提交考试？',
                    buttons: [
                      {
                        text: '继续答题',
                        onClick: function() {
                            $$(".nextquestion").removeAttr('disabled','');
                            questionAndAnswers = [];
                            noAnswer = [];
                            app.closeModal();
                        }
                      },
                      {
                        text: '确认提交',
                        onClick: function() {
                            pushFrom();
                        }
                      },
                    ]
                  });
            }else{
                app.confirm('是否提交试卷？', '交卷提醒', function () {
                    pushFrom();
                });
            }
        } else {
            pushFrom();
        }
    }
    // 执行提交工作
    function pushFrom() {
        $$(".nextquestion").attr('disabled','disabled');
        endtime = new Date();
        endtime.setDate(endtime.getDate());
        endTime = common.dateFormat(endtime, 'YYYY-MM-DD HH:mm:ss')
        if (!autoSub) {
            app.showPreloader('正在提交...');
        }
        var values = {
            templeteId: Number(id), //模板ID
            StartDateTime: startTime,
            SubmitDateTime: endTime,
            tenantId: Number(tenantId), //租户Id
            weChatPetName:localStorage.getItem('surname') + localStorage.getItem('name'),
            OnlineExamId: OnlineExamId,
            questionSurveyId: questionSurveyId, //问卷id
            questionAndAnswers: questionAndAnswers //答案list
        };
        var param = {
            ajaxUrl: 'api/services/app/QSTemplateInstance/SubmitSurveyResult_App',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: pushFromCallback,
            ajaxAgainEvt: pushFrom,
            ajaxText: '提交答题'
        }
        common.ajaxMethod(param);
    }

    function pushFromCallback(ret) {
        app.hidePreloader();
        if (ret.result.status == 'y') {
            common.notification('恭喜', ret.result.msg, 'success');
            $$(document).trigger('exams-and-surveys-surveyslist');
            var currentView = app.getCurrentView();
            currentView.router.back();
        } else {
            common.notification('提示', ret.result.msg, 'warning');
            $$(".nextquestion").removeAttr('disabled','');
            questionAndAnswers = [];
            noAnswer = [];
        }
        api.sendEvent({
            name: 'upstatus',
            extra: {
                status: 'ok',
            }
        });

    }
})