/*
 * @Autor: 赵辉
 * @Date: 2019-12-10 17:28:46
 * @LastEditors  : 赵辉
 * @Description: 问卷详情
 * @LastEditTime : 2020-01-03 15:46:21
 * @FilePath: /widget/js/mine/learning-center/exams-and-surveys/surveys.js
 */
define(function () {
    var container = null,
        navbarInnerContainer = null;
        id = null,
        shareId = 0,
        formData = '',
        data = '',
        questionAndAnswers = [];
        questionSurveyId = null,
        startTime = '',
        endTime = '';
        OnlineExamId = null;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                pageContent = container.find('.page-content');
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                id = page.query.id;
                OnlineExamId = page.query.OnlineExamId;
                getDetail();
                bindEvent();
            }
        }
    }

    function getDetail() {
        app.showPreloader('加载中...');
        loading = true;
        var values = {
            id: id,
            tenantId: tenantId,
            shareId: shareId
        };
        var param = {
            ajaxUrl: 'api/services/app/qSQuestionnaireTemplate/GetTemplateById',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: showDetail,
            ajaxAgainEvt: getDetail,
            ajaxText: '获取调查问卷详情'
        }
        common.ajaxMethod(param);
    }
    // 渲染数据
    function showDetail(ret) {
        loading = false;
        data = ret.result.data;
        questionSurveyId = data.templateInstanceId;
        //编译模板数据
        var template = container.find('.tmp-list').html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        container.find('#surveys-form').html(html);
        app.hidePreloader();
        $$('.form-to-data').on('click', function () {
            formData = app.formToData('#surveys-form');
            pushData();
        });
    }
    // 整理填充数据
    function pushData() {
        for (var i = 0; i < data.questions.length; i++) { //循环元数据
            if(JSON.stringify(formData) == "{}"){
                app.alert('请填写所有问卷项目', '验证失败');
                questionAndAnswers = [];
                return; 
            }
            for (var p in formData) { //遍历json对象的每个key/value对,p为key
                if(formData[p].length == 0){
                    app.alert('请填写所有问卷项目', '验证失败');
                    questionAndAnswers = [];
                    return;
                }
                if (data.questions[i].id == p) { //判断元数据问题id和表单问题id是否相符相符循环执行外层数据填充
                    questionAndAnswers.push({
                        "questionId": data.questions[i].id,
                        "questionType": data.questions[i].type
                    }); //填充数据类型
                    // 单选题填充
                    if (data.questions[i].type == 1 && questionAndAnswers[i].questionType == 1) { //判断表单填充类型和元数据类型是否相符
                        var selection = [];
                        selection.push({
                            "orderNum": data.questions[i].answers[formData[p]].orderNum,
                            "answerId": data.questions[i].answers[formData[p]].id
                        })
                        for (var z = 0; z < questionAndAnswers.length; z++) { //循环已经填充的外层数据长度
                            if (questionAndAnswers[z].questionId == p) { //填充过程再次判断元数据问题id和表单问题id是否一致防止填充错误
                                questionAndAnswers[z].answers = selection
                            }
                        }
                    }
                    // 多选题填充
                    if (data.questions[i].type == 2 && questionAndAnswers[i].questionType == 2) {
                        var selectiongroup = [];
                        for (var h = 0; h < formData[p].length; h++) { //循环表单多选内容填充
                            selectiongroup.push({
                                "orderNum": data.questions[i].answers[formData[p][h]].orderNum,
                                "answerId": data.questions[i].answers[formData[p][h]].id,
                                "answerContent": data.questions[i].answerContent
                            })
                        }
                        for (var z = 0; z < questionAndAnswers.length; z++) { //循环已经填充的外层数据长度
                            if (questionAndAnswers[z].questionId == p) { //填充过程再次判断元数据问题id和表单问题id是否一致防止填充错误
                                questionAndAnswers[z].answers = selectiongroup
                            }
                        }
                    }
                    // 简答题填充
                    if (data.questions[i].type == 3 && questionAndAnswers[i].questionType == 3) {
                        var answerContent = [];
                        answerContent.push({
                            "answerContent": formData[p]
                        })
                        for (var z = 0; z < questionAndAnswers.length; z++) { //循环已经填充的外层数据长度
                            if (questionAndAnswers[z].questionId == p) { //填充过程再次判断元数据问题id和表单问题id是否一致防止填充错误
                                questionAndAnswers[z].answers = answerContent
                            }
                        }
                    }
                }
            }
        }
        app.modal({
                    title:  '提交提醒',
                    text: '是否提交问卷？',
                    buttons: [
                      {
                        text: '取消',
                        onClick: function() {
                            questionAndAnswers = [];
                        }
                      },
                      {
                        text: '确定',
                        onClick: function() {
                            pushFrom();
                        }
                      },
                    ]
                  });
    }

    function pushFrom() {
        var endtime;
        endtime = new Date();
        endtime.setDate(endtime.getDate());
        endTime = common.dateFormat(endtime, 'YYYY-MM-DD HH:mm:ss')
        app.showPreloader('正在提交...');
        
        var values = {
            templeteId: Number(id) , //模板ID
            StartDateTime:startTime,
            SubmitDateTime:endTime,
            tenantId: Number(tenantId), //租户Id
            weChatPetName:localStorage.getItem('surname') + localStorage.getItem('name'),
            OnlineExamId: OnlineExamId,
            questionSurveyId: questionSurveyId, //问卷id
            questionAndAnswers: questionAndAnswers //答案list
        };
        var param = {
            ajaxUrl: 'api/services/app/QSTemplateInstance/SubmitSurveyResult_App',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: pushFromCallback,
            ajaxAgainEvt: pushFrom,
            ajaxText: '提交问卷'
        }
        common.ajaxMethod(param);
    }
    function pushFromCallback(ret) {
        if(ret.result.status == 'y'){
            common.notification('恭喜', ret.result.msg, 'success');
            $$(document).trigger('exams-and-surveys-surveyslist');
            var currentView = app.getCurrentView();
            currentView.router.back();
        }else{
            common.notification('提示', ret.result.msg, 'warning');
        }
        app.hidePreloader();
        api.sendEvent({
            name: 'surveysUpstatus',
            extra: {
                status: 'ok',
            }
        });
    }

    function bindEvent() {
        var starttime;
        starttime = new Date();
        starttime.setDate(starttime.getDate());
        startTime = common.dateFormat(starttime, 'YYYY-MM-DD HH:mm:ss')
    }
})