/*
 * @Author: 赵辉
 * @Date: 2019-12-09 16:59:08
 * @LastEditTime : 2020-01-06 13:19:18
 * @LastEditors  : 赵辉
 * @Description: 只是学习详情页
 * @FilePath: /widget/js/mine/learning-center/knowledge/detail.js
 */
define(function () {
    var container = null,
        navbarInnerContainer = null;
        id = null,
        maxResultCount = 50, //获取的行数
        skipCount = 0, //跳过的行数
        cont = '', //评论内容
        commentbar = null,
        loading = false,
        startTime = null,
        endTime = null,
        recordBrowseStatus = false;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                pageContent = container.find('.page-content');
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                id = page.query.id;
                commentBtn = container.find('.messagebar .btn-send');
                getDetail();

            }
        }
    }
    //获取一条资讯详情
    function getDetail() {
        loading = true;
        app.showIndicator();
        var values = {
            id: id
        };
        var param = {
            ajaxUrl: 'api/services/app/knowledgeLearning/GetKnowledgeLearningByIdApp',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: showDetail,
            ajaxAgainEvt: getDetail,
            ajaxText: '获取知识学习详情'
        }
        common.ajaxMethod(param);
    }
    //展示资讯详情
    function showDetail(ret) {
        loading = false;
        recordBrowseStatus = true;
        container.find('.page-detail').removeClass('hide');
        container.find('.messagebar').removeClass('hide');
        var data = ret.result;
        //发布时间
        if (data.creationTime) {
            container.find('.creationtime').removeClass('hide');
            data.creationTime = common.dateFormat(data.creationTime, 'YYYY-MM-DD HH:mm');
        }
        //来源
        if (data.source) {
            container.find('.source').removeClass('hide');
        }
        //封面
        if (data.thumbnail) {
            data.displaypic = '<img src="' + mediaSrc + data.thumbnail + '?imageView2/0/format/png">';
        }
        //展示数据
        $$.each(data, function (key, value) {
            container.find('[data-name="' + key + '"]').html(value);
        });

        //附件
        if (data.filePath) {
            // data.filePath = 'https://img-blog.csdnimg.cn/20191225111311593.png'
            container.find('.enclosure').removeClass('hide');
            var adjunct = document.querySelector(".adjunct")
            var filePathone =  data.filePath.split(',');
            for (var x = 0; x < filePathone.length; x++) {
                var last_len = filePathone[x].lastIndexOf(".");
                var len = filePathone[x].length;
                var pathf = filePathone[x].substring(last_len, len);
                switch (pathf) {
                    case '.mp4':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-mp4 color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.doc':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-doc color-gray knowledge-icon-40'></i>&nbsp;&nbsp;:"
                        break;
                    case '.docx':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-docx color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.xls':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-xls color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.xlsx':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "'class='clicksa icon icon-xlsx color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.pdf':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-pdf color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.ppt':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-ppt color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.jpg':
                    case '.png':
                    case '.jpeg':
                    case '.jif':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-jpg color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    case '.jpeg':
                        adjunct.innerHTML += "<i data-filePath='" + filePathone[x] + "' class='clicksa icon icon-jpg color-gray knowledge-icon-40'></i>&nbsp;&nbsp;"
                        break;
                    default:
                        // adjunct.innerHTML = '<i data-filePath="" class="icon icon-video color-gray knowledge-icon-24"></i>&nbsp;&nbsp;'
                }
            }
        }

        //获取当前页面内所有图片添加到数组
        var arr = [];
        container.find("img").each(function () {
            var img_url = $$(this).attr("src");
            arr.push(img_url);
        });
        //点击图片查看大图
        container.find("img").on('click', function () {
            var img_url = $$(this).attr("src");
            var index = arr.indexOf(img_url);
            //最后一张图片不展示
            common.photoBrowser(arr, index); //data为图片数组
        });
        container.find('.page-content a').on('click', openframe);
        function openframe() {
            var url = $$(this).attr('href');
            common.openRemotePage(url);
        }

        $$('.clicksa').on('click', function () {
            var filePath = $$(this).attr('data-filePath');
            // var filePath = 'https://img-blog.csdnimg.cn/20191225111311593.png'
            var last_len = filePath.lastIndexOf(".");
            var len = filePath.length;
            var pathf = filePath.substring(last_len, len);
            var sysType = api.systemType;
            //如果是视频和jpg 走通用方法
            if(pathf == '.mp4' || pathf == '.jpg' || pathf == '.jpeg' || pathf == '.png' || pathf == '.pdf'){
                switch (pathf) {
                    case '.mp4':
                    var popupHTML = '<div class="popup tablet-fullscreen">' +
                        '<div class="content-block">' +
                        '<p class="close"><a href="#" class="close-popup"><font style="vertical-align: inherit;" color="black" size="3">X</font></a></p>' +
                        '<video class="video_play" x5-playsinline="" playsinline="" poster="" webkit-playsinline="true" width="100%" x-webkit-airplay="false" src="' + mediaSrc + filePath + '" controls="controls"></video>' +
                        '</div>' +
                        '</div>'
                        app.popup(popupHTML);
                        break;
                    case '.pdf':
                        var sysType = api.systemType;
                        if (sysType == 'ios') {
                            var pdfReader = api.require('pdfReader');
                        } else if (sysType == 'android') {
                            var pdfReader = api.require('androidPdfReader');
                        }
                        pdfReader.open({
                            path: mediaSrc + filePath
                        }, function (ret, err) {
                        });
                        break;
                    case '.jpg':
                    case '.png':
                    case '.jpeg':
                    case '.gif':
                        var imgUrl = mediaSrc + filePath;
                        var arr = [];
                        arr.push(imgUrl)
                        common.photoBrowser(arr, 0);
                    break;
                    default:
                }
            }else if(sysType == 'ios'){//ios所有文件预览走此方法
                common.openRemotePage(mediaSrc + filePath, '在线预览');
            } else if(sysType == 'android'){//安卓判断
                common.openRemotePage(mediaSrc + filePath, '文件下载');
                setTimeout(function(){
                    api.closeWin({
                        name: 'remote-page'
                    });
                    app.modal({
                        title: '下载提示',
                        text: '<p class="decription">已开始下载附件,请下拉状态栏查看进度</p>',
                        buttons: [{
                            text: '知道了'
                        }]
                    });
                }, 1000);
            }

        });
        bindEvent();
    }
    // 初始化评论
    function commentInit() {
        //初始化消息工具栏
        commentbar = app.messagebar('.messagebar', {
            maxHeight: 200
        });
        getComment();
        //评论按钮
        commentBtn.click(function () {
            //输入内容
            cont = commentbar.value().trim();
            if (cont.length === 0) {
                app.alert('请填写要评论的内容', '评论内容不能为空！');
                return;
            };
            if (cont.length < 3) {
                app.alert('请不要发表无意义内容');
                return;
            };
            submitComment();
        });
    }
    //提交评论
    function submitComment() {
        //禁用评论按钮
        commentBtn.addClass('disabled');
        loading = true;
        app.showPreloader('正在提交...');
        var values = {
            objectId: id,
            CommentContent: cont,
        };
        var param = {
            ajaxUrl: 'api/services/app/knowledgeLearning/CreateKnowledgeLearnComment',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: submitCommentCallback,
            ajaxAgainEvt: submitComment,
            ajaxText: '提交评论'
        }
        common.ajaxMethod(param);
    };
    // 提交评论回调
    function submitCommentCallback(ret) {
        loading = false;
        if (ret && ret.result.msg == "保存成功") {
            commentbar.clear();
            app.hidePreloader();
            common.notification('恭喜', '评论成功', 'success');
            commentBtn.removeClass('disabled');
            getComment();
        } else {
            commentBtn.removeClass('disabled');
        }
    }
    //拉取评论
    function getComment() {
        container.find('.comment-list .list-preloader').show();
        var values = {
            objectId: id,
            maxResultCount: maxResultCount, //取N条数据
            skipCount: skipCount * maxResultCount, //从x条数据开始取
        };
        var param = {
            ajaxUrl: 'api/services/app/knowledgeLearning/GetKnowledgeLearnCommentQuery',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: getCommentCallback,
            ajaxAgainEvt: getComment,
            ajaxText: '获取评论'
        }
        common.ajaxMethod(param);
    };
    // 拉取评论回调
    function getCommentCallback(ret) {
        var data = ret.result
        //展示评论
        //展示评论数
        container.find('.comment-title span').text('(' + data.totalCount + ')');
        // 格式化评论时间为相对时间
        for (var i = 0; i < data.items.length; i++) {
            data.items[i].creationTime = common.dateFormat(data.items[i].creationTime, 'YYYY-MM-DD HH:mm');
        }
        //编译模板数据
        var template = container.find('.tmp-comment').html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        container.find('.comment-list').html('<ul>' + html + '</ul>');
    }
    

    function bindEvent() {
        commentInit();
        common.dataTable();
        starttime = new Date();
        starttime.setDate(starttime.getDate());
        startTime = common.dateFormat(starttime, 'YYYY-MM-DD HH:mm:ss')
        //关闭本页面时的回调
        app.onPageBeforeRemove('knowledge-detail', function () {
            api.sendEvent({
                name: 'knowledgeUpstatus',
                extra: {
                    status: 'ok',
                }
            });
            if(recordBrowseStatus){
                recordBrowse();
                recordBrowseStatus = false;
            }
            
        });
    }
    // 记录浏览信息
    function recordBrowse() {
        var endtime;
        endtime = new Date();
        endtime.setDate(endtime.getDate());
        endTime = common.dateFormat(endtime, 'YYYY-MM-DD HH:mm:ss')
        var values = {
            objectId: id,
            startTime: startTime, //开始时间
            endTime: endTime, //结束时间
        };
        var param = {
            ajaxUrl: 'api/services/app/knowledgeLearning/AddBrowseLog',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: recordCallback,
            ajaxAgainEvt: recordBrowse,
            ajaxText: '记录浏览信息'
        }
        common.ajaxMethod(param);
    }
    function recordCallback(ret) {
    }
})