/**
 * 在线课堂-详情
 * @author 陈汝冰
 * @date 2019-12-9
 */
window.FETCHER_SERVER_URL = "ws://fetcher.mudu.tv:8088";
define(['require', 'exports', 'moment','mudufetcher', 'mudusdk'], function(require, exports, moment,mudufetcher, mudusdk) {
  var container = null,
    did = null,
    player = null,//MUDU播放器
    detailData = null,
    muduId = null,
    loading = false,
    tabindex = 0, //tab选项卡默认第一项
    muduSDK_init = false, //默认目睹初始化失败
    nickname = null, //昵称
    assignId = null, //用户标识id
    pptIsOpen = false,
    Playersub = null,//取消play播放器的消息订阅
    commentPage = null, //目睹-评论总数
    topicPage = 1, //目睹话题互动
    topicAllPage = null, //话题互动总页数
    pptCurrentPage = null, //当前控制台ppt所在页数
    pptTotalPage = null, //当前ppt总页数
    videoPath = null,//视频地址
    videoImg = null,//视频背景图片
    navbarInnerContainer = null,
    currView = null;
  return {
    init: function(page) {
      if (page.from == "right") {
        container = $$(page.container);
        pageContent = container.find(".page-content");
        currView = app.getCurrentView();
        navbarInnerContainer = $$(page.navbarInnerContainer).length? $$(page.navbarInnerContainer): container.find(".navbar .navbar-inner");
        did = page.query.id; //详情id
        muduId = page.query.muduid; //目睹直播间id
        videoImg = mediaSrc + page.query.coverPic;//封面图
        nickname =localStorage.getItem("surname") + localStorage.getItem("name"); //姓名昵称
        assignId = localStorage.getItem("userId"); //身份标志
        var videoHeight = $$(".video_view").height(); //视频窗口高度
        var psgeBodyHeight = $$(".views").height(); //屏幕窗口高度
        container.find(".live-content .list-block").css("height", psgeBodyHeight - videoHeight - 56 - 47 - 48 + "px");
        container.find(".video-poster").prop("src", videoImg);//背景图
        container.find(".video-poster").removeClass('hide');//隐藏封面图
        getDetailData(); //获取详情
        bindEvent();
      }
    }
  };
  //获取详情
  function getDetailData() {
    app.showIndicator();
    var param = {
      ajaxUrl: "api/services/app/onlineClassroom/GetOnlineClassroomById",
      ajaxMethod: "post",
      ajaxValues: { id: did },
      ajaxCallback: showData,
      ajaxAgainEvt: getDetailData,
      ajaxText: "获取直播详情数据"
    };
    common.ajaxMethod(param);
  }
  //展示数据
  function showData(ret) {
    detailData = ret.result;
    container.find(".introduction").html(detailData.briefContent); //简介
    navbarInnerContainer.find('.center').text(detailData.title);//标题
    app.sizeNavbars('.view');
    initMuduWebSDK(); //初始化目睹websdk
  }
  function bindEvent() {
    // navbarInnerContainer.find('.backs').off("click");
    // navbarInnerContainer.find('.backs').on("click", function() {
    //   player.remove();//移出播放器
    //   setTimeout(function () {
    //       Mudu.Destroy();
    //   }, 150);
    //   setTimeout(function () {
    //     currView.router.back();
    //   }, 150);
    // })
    app.onPageBeforeRemove('online-classroom-detail', function (page) {
      if(player){
        player.remove();//移出播放器
      }
      Mudu.Destroy();
    })
    //查看大图
    $$(".list-block").on("click", ".child-image", function() {
      var index = $$(this).attr("data-index");
      var imagesList = $$(this)
        .parent()
        .attr("data-images");
      imagesList = imagesList.split(",");
      common.photoBrowser(imagesList, index);
    });
    //ppt展开
    $$(".page-content").on("click", ".ppt-floating-button", function() {
      var psgeBodyHeight = $$(".views").height();
      var videoHeight = $$(".video_view").height() + 56 + 24;
      $$(".popup-ppt").css("top", videoHeight + "px"); //设置距离顶部位置
      $$(".popup-ppt").css(
        "height",
        psgeBodyHeight - ($$(".video_view").height() + 56 + 24) + "px"
      ); //设置距离顶部位置
      app.popup(".popup-ppt");
    });
    // 初始化消息工具栏
    messagebar = app.messagebar(".messagebar", {
      maxHeight: 200
    });
    //选线卡切换
    container.find(".flex-1").on("click", function() {
      tabindex = $$(this).index();
      $$(this).addClass("active");
      $$(this).siblings().removeClass("active");
      $$(".live-content .tab").eq($$(this).index()).addClass("show");
      $$(".live-content .tab").eq($$(this).index()).siblings().removeClass("show");
      //切换messagebar
      if (muduSDK_init) {
        container.find(".messagebar").show(); //消息框显示
        if (tabindex == 0) {
          $$("textarea").attr("placeholder", "我来说两句...");
        }
        if (tabindex == 2) {
          $$("textarea").attr("placeholder", "有疑问可以向老师发起提问");
        }
        if (tabindex == 1) {
          container.find(".messagebar").hide(); //消息框隐藏
        }
      } else {
        container.find(".messagebar").hide(); //消息框隐藏
      }
    });
    //加载更多评论
    $$(".infinite-scroll").on("infinite", function() {
      if (loading) {
        return;
      }
      //聊天互动
      if (tabindex == 0) {
        commentPage = commentPage - 1; //上一页-1
        if (commentPage < 1) {
          return;
        } else {
          if (muduSDK_init) {
            getMuduComment(commentPage);
          }
        }
      } else if (tabindex == 2) {
        topicPage = topicPage + 1; //上一页-1
        if (topicPage < 1 || topicPage > topicAllPage) {
          return;
        } else {
          if (muduSDK_init) {
            getTopicList(topicPage);
          }
        }
      }
    });
    //发送消息
    container.find(".messagebar .btn-send").click(function() {
      if (tabindex == 0) {
        sendCommentMessage(); //发送评论 互动
      } else if (tabindex == 2) {
        sendTopicMessage(); //发送话题互动
      }
    });
    //ppt窗口打开关闭事件
    $$(".popup-ppt").on("popup:open", function() {
      $$(".popup-overlay").css("background", "none");
    });
    $$(".popup-ppt").on("popup:closed", function() {
      $$(".popup-overlay").css("background", "rgba(0, 0, 0, 0.4)");
    });
    $$(".closeicon").on("click", function() {
      app.closeModal(".popup-ppt");
    });
  }
  //初始化目睹websdk
  function initMuduWebSDK() {
    app.showPreloader('加载中...');
    Mudu.Init(
      // 频道id
      muduId,
      // 初始化完成的回调函数，无参数
      function() {
        muduSDK_init = true; //设置目睹初始化成功
        app.hidePreloader();
        setUserAssign(); //同步用户信息到目睹
        initPlayer(); //播放器组件
        commentPage = Mudu.Room.Comment.GetPage(); // 返回评论页数，类型为int
        getNewMuduComment(); //获取最新的评论列表
        topicAllPage = Mudu.Room.Topic.GetPage(); //话题互动总页数
        getTopicList(); //获取最新的话题互动列表
        muduListenersEvent(); //目睹sdk监听
        pptShow(); //PPT组件
      }
    );
  }
  //目睹sdk监听
  function muduListenersEvent() {
    //Room.StreamEvent事件会在直播流状态改变时(通常是后台开始直播或者关闭直播)被触发
    Mudu.MsgBus.On(
      // 事件名，值为Room.StreamEvent
      'Room.StreamEvent',
      // 事件处理函数，参数类型为object
      function (data) {
          var data = JSON.parse(data);
          if(data.event == 1){
            //开始直播
            setTimeout(function(){
              var isChannelLiving = !!Mudu.Room.GetLiveStatus();
              if(player){
                player.load([
                  {
                    isLive: isChannelLiving,
                    file: Mudu.Room.GetPlayAddr(),
                    image: videoImg,
                  }
                ])
              }else{
                player = new Mudu.Player(
                  {
                    // 必须，播放器容器ID，播放器会被添加到该DOM元素中
                    containerId: 'video_view',
                    // 非必需 boolean 控制播放器的ui展示, 默认为false; 根据播放视频的实际情况填写
                    isLive: isChannelLiving,
                    // 必须，播放器视频播放地址
                    src: Mudu.Room.GetPlayAddr(),
                    // 非必须，播放器海报图 string
                    image: videoImg,
                    // 非必须，播放器是否自动播放，默认false
                    autoplay: false,
                    // 非必须，播放器是否显示控制条，默认true
                    controls: true,
                    // 非必须，播放器是否循环播放, 默认false
                    repeat: false,
                    // 以下x5Layer和x5Inline两个参数用于解决安卓微信、QQ、QQ浏览器的只能全屏播放的问题。参数仅对安装过tbs(腾讯浏览服务，一般安装过QQ浏览器后手机上会存在)手机生效(由于tbs的api限制，部分低版本的微信、QQ、QQ浏览器可能不会生效)，未安装tbs的安卓手机不会有只能全屏播放的问题。
                    // x5Layer和x5Inline只能有一个被设置为true
                    // 非必须，播放器在安卓微信、QQ、QQ浏览器中是否同层播放, 默认false  （注：同层播放时，页面document无法滚动(内部的dom元素可以)，如果播放器宽度小于浏览器宽度，两边将出现黑边）
                    x5Layer: false,
                    // 非必须，播放器在安卓微信、QQ、QQ浏览器中是否inline播放，默认false  （注：inline播放时，播放器始终处于z-index的最上层，因此无法在播放器上叠加元素）
                    x5Inline: false,
                  }
                );
              }
              container.find(".video-poster").addClass('hide');//隐藏封面图
            },18000)
          }else if(data.event == 0){
            //停止直播
            player.stop();//停止播放
            player.setControls(false);//设置控制条是否显示
            if(currView.activePage.name == 'online-classroom-detail'){
              app.alert('直播结束');
            }
          }
      }
    )
    //话题互动事件
    //Topic.New事件会在收到新的话题时被触发
    Mudu.MsgBus.On(
      // 事件名，值为Topic.New
      "Topic.New",
      // 事件处理函数，参数为新收到的topic
      function(topic) {
        var topics = JSON.parse(topic);
        // alert(topics.username+'发送了'+topics.message)
        if (topics.checked == 0) {
          return;
        }
        topics.updated_at = moment(topics.updated_at).format("MM-DD HH:mm:ss");
        var is_admin = topics.is_admin == 1 ? ' <div class="tag theme-blue">管理员</div>' : "";
        var imagesHtml = "";
        $$.each(topics.images, function(index, item) {
          imagesHtml +='<img class="child-image" data-index="' +index +'" src="' +item +'">';
        });
        var htmls =
          '<li><div class="item-content">' +
          '<div class="item-media"><img class="avatar" src="' +
          topics.avatar +
          '" width="44"></div>' +
          '<div class="item-inner">' +
          '<div class="item-title-row">' +
          '<div class="item-title">' +
          topics.username +
          is_admin +
          "</div>" +
          '<div class="item-after">' +
          topics.updated_at +
          "</div>" +
          "</div>" +
          '<div class="item-subtitle">' +
          topics.message +
          '<div class="topic-image" data-images="' +
          topics.images +
          '">' +
          imagesHtml +
          "</div>" +
          "</div>" +
          "</div>" +
          "</div>" +
          "</li>";
        if (container.find(".topiclist .list-block ul li").hasClass("nodata")) {
          container.find(".topiclist .list-block ul").html(htmls);
        } else {
          container.find(".topiclist .list-block ul").prepend(htmls);
        }
      }
    );
    //话题收到新的回复时被触发
    Mudu.MsgBus.On(
        'Topic.Reply.New',
        function (reply) {
            reply = JSON.parse(reply);
            var ReplyHtml = '<div class="topics-replies"><span class="color-blue">'+reply.username+'</span>'+reply.message+'</div>';
            container.find('.topiclist .list-block ul #belong_to_'+reply.belong_to).find('.item-subtitle').append(ReplyHtml);
        }
    )
    //评论新增触发事件
    //Comment.New事件会在评论新增的时候被触发
    Mudu.MsgBus.On(
      // 事件名，值为Comment.New
      "Comment.New",
      // 事件处理函数，参数为新的评论，类型为object
      function(newComment) {
        var newComment = JSON.parse(newComment);
        if (newComment.checked == 0) {
          return;
        }
        var is_admin = newComment.is_admin == 1 ? ' <div class="tag theme-blue">管理员</div>' : "";
        newComment.dateline = moment(newComment.dateline * 1000).format("MM-DD HH:mm:ss");
        var htmls =
          '<li><div class="item-content">' +
          '<div class="item-media"><img class="avatar" src="' +
          newComment.avatar +
          '" width="44"></div>' +
          '<div class="item-inner">' +
          '<div class="item-title-row">' +
          '<div class="item-title">' +
          newComment.username +
          is_admin +
          "</div>" +
          '<div class="item-after">' +
          newComment.dateline +
          "</div>" +
          "</div>" +
          '<div class="item-subtitle">' +
          newComment.message +
          "</div>" +
          "</div>" +
          "</div>" +
          "</li>";
        if (container.find(".msglist .list-block ul li").hasClass("nodata")) {
          container.find(".msglist .list-block ul").html(htmls);
        } else {
          container.find(".msglist .list-block ul").prepend(htmls);
        }
      }
    );

    //PPT.AllowTurnPage  事件会在控制台切换ppt“允许用户翻页”时被触发
    Mudu.MsgBus.On("PPT.AllowTurnPage", function(response) {
      var response = JSON.parse(response);
      //切换后是否允许用户翻页, 1为允许, 0为禁止
      if (response.is_turn_page == 1) {
        $$(".swiper-back").removeClass("hide"); //移出隐藏按钮
        $$(".swiper-next").removeClass("hide"); //移出隐藏按钮
      } else {
        $$(".swiper-back").toggleClass("hide"); //移出隐藏按钮
        $$(".swiper-next").toggleClass("hide"); //移出隐藏按钮
      }
    });
    //PPT.Changed 事件,会在控制台进行ppt翻页时触发
    Mudu.MsgBus.On("PPT.Changed", function(response) {
      var response = JSON.parse(response);
      //当前图片
      $$(".docs-wrap .ppt img").attr("src", response.url);
      //页数和总数
      $$(".pptCurrentPage").text(response.page);
      $$(".pptTotalPage").text(response.total_page);
    });

    //PPT.IsOpen事件会在控制台切换ppt“观看页显示”时被触发
    Mudu.MsgBus.On("PPT.IsOpen", function(response) {
      response = JSON.parse(response);
      if (response.open == 1) {
        // 1为显示, 0为不显示
        container.find(".ppt-floating-button").removeClass("hide");
      } else if (response.open == 0) {
        container.find(".ppt-floating-button").addClass("hide");
        app.closeModal(".popup-ppt"); //关闭ppt窗口
      }
    });
  }
  //同步用户信息到目睹
  function setUserAssign() {
    Mudu.Room.User.Assign(
      nickname,
      "https://cdn.yaodaitong.cn/logo.png", //默认头像
      assignId,
      function(newUserInfo) {}
    );
  }
  //播放器组件
  function initPlayer() {
    var roomLiveStatus = Mudu.Room.GetLiveStatus(); // 返回直播状态，类型为number: `1`为正在直播，`0`为不在直播
    if (roomLiveStatus == 0) {
      //如果 不在直播,状态为直播回放，则加载回放地址
      //判断是否有回放地址
      if(detailData.status == 0){//未直播
        return;
      }else if(detailData.status == 1){//直播中
        return;
      }else if(detailData.status == 2){//直播结束，回放
        if(detailData.playbackAddress){
          videoPath = detailData.playbackAddress;//回放视频地址
          player = new Mudu.Player(
            {
              // 必须，播放器容器ID，播放器会被添加到该DOM元素中
              containerId: 'video_view',
              // 非必需 boolean 控制播放器的ui展示, 默认为false; 根据播放视频的实际情况填写
              isLive: isChannelLiving,
              // 必须，播放器视频播放地址
              src: videoPath,
              // 非必须，播放器海报图 string
              image: videoImg,
              // 非必须，播放器是否自动播放，默认false
              autoplay: false,
              // 非必须，播放器是否显示控制条，默认true
              controls: true,
              // 非必须，播放器是否循环播放, 默认false
              repeat: false,
              // 以下x5Layer和x5Inline两个参数用于解决安卓微信、QQ、QQ浏览器的只能全屏播放的问题。参数仅对安装过tbs(腾讯浏览服务，一般安装过QQ浏览器后手机上会存在)手机生效(由于tbs的api限制，部分低版本的微信、QQ、QQ浏览器可能不会生效)，未安装tbs的安卓手机不会有只能全屏播放的问题。
              // x5Layer和x5Inline只能有一个被设置为true
              // 非必须，播放器在安卓微信、QQ、QQ浏览器中是否同层播放, 默认false  （注：同层播放时，页面document无法滚动(内部的dom元素可以)，如果播放器宽度小于浏览器宽度，两边将出现黑边）
              x5Layer: false,
              // 非必须，播放器在安卓微信、QQ、QQ浏览器中是否inline播放，默认false  （注：inline播放时，播放器始终处于z-index的最上层，因此无法在播放器上叠加元素）
              x5Inline: false,
            }
          );
        }
      }
    } else if (roomLiveStatus == 1) {
      //正在直播
      videoPath = Mudu.Room.GetPlayAddr();//回放视频地址
      var isChannelLiving = !!Mudu.Room.GetLiveStatus() // Mudu.Room.GetLiveStatus() 获取当前的直播状态 类型为number: `1`为正在直播，`0`为不在直播
      player = new Mudu.Player(
        {
          // 必须，播放器容器ID，播放器会被添加到该DOM元素中
          containerId: 'video_view',
          // 非必需 boolean 控制播放器的ui展示, 默认为false; 根据播放视频的实际情况填写
          isLive: isChannelLiving,
          // 必须，播放器视频播放地址
          src: videoPath,
          // 非必须，播放器海报图 string
          image: videoImg,
          // 非必须，播放器是否自动播放，默认false
          autoplay: false,
          // 非必须，播放器是否显示控制条，默认true
          controls: true,
          // 非必须，播放器是否循环播放, 默认false
          repeat: false,
          // 以下x5Layer和x5Inline两个参数用于解决安卓微信、QQ、QQ浏览器的只能全屏播放的问题。参数仅对安装过tbs(腾讯浏览服务，一般安装过QQ浏览器后手机上会存在)手机生效(由于tbs的api限制，部分低版本的微信、QQ、QQ浏览器可能不会生效)，未安装tbs的安卓手机不会有只能全屏播放的问题。
          // x5Layer和x5Inline只能有一个被设置为true
          // 非必须，播放器在安卓微信、QQ、QQ浏览器中是否同层播放, 默认false  （注：同层播放时，页面document无法滚动(内部的dom元素可以)，如果播放器宽度小于浏览器宽度，两边将出现黑边）
          x5Layer: false,
          // 非必须，播放器在安卓微信、QQ、QQ浏览器中是否inline播放，默认false  （注：inline播放时，播放器始终处于z-index的最上层，因此无法在播放器上叠加元素）
          x5Inline: false,
        }
      );
    }

    container.find(".video-poster").removeClass('hide');//移除占位背景图
    container.find(".video_view").css("width", "100%"); //手动设置播放器宽
    container.find(".video_view").css("height", "230px"); //手动设置播放器高
  }
  //获取最新的评论列表
  function getNewMuduComment() {
    Mudu.Room.Comment.Get(commentPage, function(response) {
      response = JSON.parse(response);
      if (response.status === "y") {
        var data = response.data;
        for (var i = 0; i < data.comments.length; i++) {
          data.comments[i].dateline = moment(
            data.comments[i].dateline * 1000
          ).format("MM-DD HH:mm:ss");
        }
        var template = container.find(".tmp-msglist").html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        container.find(".msglist .list-block ul").append(html);
      }
      if (response.status === "n") {
        app.alert(response.msg);
      }
      loading = false;
      app.hideIndicator();
    });
  }
  //获取评论列表
  function getMuduComment(page) {
    app.showIndicator();
    loading = true;
    Mudu.Room.Comment.Get(page, function(response) {
      response = JSON.parse(response);
      if (response.status === "y") {
        var data = response.data;
        for (var i = 0; i < data.comments.length; i++) {
          data.comments[i].dateline = moment(
            data.comments[i].dateline * 1000
          ).format("MM-DD HH:mm:ss");
        }
        var template = container.find(".tmp-msglist").html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        container.find(".msglist .list-block ul").append(html);
      }
      if (response.status === "n") {
        app.alert(response.msg);
      }
      loading = false;
      app.hideIndicator();
    });
  }
  //获取话题互动消息列表
  function getTopicList() {
    app.showIndicator();
    loading = true;
    Mudu.Room.Topic.Get(topicPage, function(response) {
      response = JSON.parse(response);
      if (response.status === "y") {
        var data = response;
        for (var i = 0; i < data.topics.length; i++) {
          data.topics[i].updated_at = moment(data.topics[i].updated_at).format(
            "MM-DD HH:mm:ss"
          );
        }
        var template = container.find(".tmp-topiclist").html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        container.find(".topiclist .list-block ul").append(html);
      }
      if (response.status === "n") {
        app.alert(response.msg);
      }
      loading = false;
      app.hideIndicator();
    });
  }

  //发送聊天互动消息
  function sendCommentMessage() {
    var messageText = messagebar.value().trim();
    if (messageText.length === 0) {
      app.alert("内容不能为空");
      return;
    }
    app.showIndicator();
    Mudu.Room.Comment.Send(messageText, function(res) {
      app.hideIndicator();
      var data = JSON.parse(res);
      if (data.status == "y") {
        messagebar.clear();
        // 发送内容是否需要审核 返回boolean, true为需要审核, false为不需要审核
        var isNeedsCheck = Mudu.Room.Comment.GetNeedsCheck();
        if (isNeedsCheck) {
          //弹出提示
          api.toast({
            msg: "管理员开启了内容审核，审核通过后显示",
            duration: 2000,
            location: "middle"
          });
          return;
        }
      } else if (data.status == "n") {
        console.log("发送失败，错误码为：" + data.flag);
        var errorCode = data.flag;
        var errText = "";
        switch (errorCode) {
          case 101:
            errText = "管理员禁止了聊天";
            break;
          case 102:
            errText = "您已被禁言";
            break;
          case 103:
            errText = "发送失败";
            break;
          case 104:
            errText = "禁止匿名聊天";
            break;
          default:
            errText = "禁止错误码为："+data.flag;
            break;
        }
        //弹出提示
        app.modal({
          title: "发送失败",
          text:
            '<i class="icon icon-warning"></i>' +
            '<p class="decription">' +
            errText +
            "</p>",
          buttons: [
            {
              text: "知道了"
            }
          ]
        });
      }
    });
  }
  //发送话题互动提问消息
  function sendTopicMessage() {
    // 返回boolean, true为允许, false为不允许
    var isAllowPublish = Mudu.Room.Topic.GetAllowPublish();
    if (!isAllowPublish) {
      //弹出提示
      app.modal({
        title: "提示",
        text: "管理员禁止了发起话题",
        buttons: [
          {
            text: "知道了"
          }
        ]
      });
      return;
    }
    var messageText = messagebar.value().trim();
    if (messageText.length === 0) {
      app.alert("内容不能为空");
      return;
    }
    app.showIndicator();
    Mudu.Room.Topic.SendTopic({ msg: messageText }, function(res) {
      app.hideIndicator();
      var data = JSON.parse(res);
      if (data.status == "y") {
        messagebar.clear();
        // 发送内容是否需要审核 返回boolean, true为需要审核, false为不需要审核
        var isNeedsCheck = Mudu.Room.Topic.GetNeedsCheck();
        if (isNeedsCheck) {
          //弹出提示
          api.toast({
            msg: "管理员开启了内容审核，审核通过后显示",
            duration: 2000,
            location: "middle"
          });
          return;
        }
      } else if (data.status == "n") {
        console.log("发送失败，错误码为：" + data.flag);
        var errorCode = data.flag;
        var errText = "";
        switch (errorCode) {
          case 101:
            errText = "参数错误";
            break;
          case 102:
            errText = "管理员禁止了发起话题";
            break;
          case 103:
            errText = "观众被禁言";
            break;
          case 104:
            errText = "不允许匿名聊天";
            break;
          case 105:
            errText = "发送失败";
            break;
          case 106:
            errText = "管理员禁止了回复";
            break;
          default:
            errText = "错误码为："+data.flag;
            break;
        }
        //弹出提示
        app.modal({
          title: "发送失败",
          text:
            '<i class="icon icon-warning"></i>' +
            '<p class="decription">' +
            errText +
            "</p>",
          buttons: [
            {
              text: "知道了"
            }
          ]
        });
      }
    });
  }

  function pptShow() {
    pptIsOpen = Mudu.Room.PPT.IsOpen(); //获取控制台是否开启显示PPT true为开启, false为关闭
    if (pptIsOpen) {
      container.find(".ppt-floating-button").removeClass("hide");
    }
    //IsOpen 获取控制台是否开启显示PPT
    var isOpen = Mudu.Room.PPT.IsOpen();
    if (isOpen) {
      container.find(".ppt-floating-button").removeClass("hide");
    }
    //GetUrl 获取当前控制台PPT图片地址
    $$(".docs-wrap .ppt img").attr("src", Mudu.Room.PPT.GetUrl());

    pptCurrentPage = Mudu.Room.PPT.GetCurrentPage(); //当前控制台ppt所在页数
    pptTotalPage = Mudu.Room.PPT.GetTotalPage(); //当前ppt总页数
    $$(".pptCurrentPage").text(pptCurrentPage);
    $$(".pptTotalPage").text(pptTotalPage);
    //GetAllowTurnPage 获取控制台是否允许用户翻页,返回boolean, true为允许, false为禁止
    var allowTurnPage = Mudu.Room.PPT.GetAllowTurnPage();
    if (allowTurnPage) {
      //允许翻页
      $$(".swiper-back").removeClass("hide"); //移出隐藏按钮
      $$(".swiper-next").removeClass("hide"); //移出隐藏按钮
    }
    //切换翻页    //ppt上一页
    $$(".popup-ppt").on("click", ".swiper-back", function() {
      if (pptCurrentPage <= 1) {
        api.toast({
          msg: "前面没有了",
          location: "middle"
        });
      } else {
        pptCurrentPage--;
        $$(".pptCurrentPage").text(pptCurrentPage);
        Mudu.Room.PPT.GetPageImgUrl(pptCurrentPage, function(url) {
          $$(".docs-wrap .ppt img").attr("src", url);
        });
      }
    });
    //ppt下一页
    $$(".popup-ppt").on("click", ".swiper-next", function() {
      if (pptCurrentPage >= pptTotalPage) {
        api.toast({
          msg: "最后一页了",
          location: "middle"
        });
      } else {
        pptCurrentPage++;
        $$(".pptCurrentPage").text(pptCurrentPage);
        Mudu.Room.PPT.GetPageImgUrl(pptCurrentPage, function(url) {
          $$(".docs-wrap .ppt img").attr("src", url);
        });
      }
    });
  }
});
