/*
 * 公共方法
 * @date 2017-12-07
 * @copyright 山东资略信息技术有限公司
 * @param {object} app framework7 初始化的实例
 * @param {object} params 插件全局配置参数（非必需）
 * */
// 媒体存储服务器地址
var mediaSrc = 'https://pspcdn.yaodaitong.cn/';
// 测试 -- dev
// var server = 'http://192.168.0.90/'; 

// 预上线环境
// var server = 'http://116.62.66.133/';
// 正式环境测试服务器
// var server = 'https://pspdev.yaodaitong.cn/';
// 正式环境0
var server = 'https://psp.yaodaitong.cn/';
// 正式环境ip地址
// var server = 'http://47.98.234.45/';
// var server = 'http://47.98.222.215/';
// var server = 'http://47.97.153.29/';
// 冯总对外演示环境
// var server = 'http://demo.psp.yaodaitong.cn/';
//模板全局变量
Template7.global = {
	mediaSrc: mediaSrc //媒体地址
};
var isInit = localStorage.getItem('isInit'),
	token = localStorage.getItem('token'),
	businessAgent = false, //是否是业务代表
	userId = localStorage.getItem('userId'), //用户id
	tenantId = localStorage.getItem('tenantId'), //租户id
	userType = localStorage.getItem('userType'), //用户类型
	headers = {
	 	'Content-Type': 'application/json',
		"Authorization": "Bearer" + ' ' + token
	},
    uploading = false, //图片上传状态
    iflyRecognitionType = false,//语音识别状态
	signing = false, //定位状态
	options = null,
	permissions = null, //用户权限数据
	signAndPhotoPermissions = null, // 营销签到拍照权限数据
	contractorId = localStorage.getItem('contractorsId'), //服务商Id
	contractorEmployeeId = localStorage.getItem('contractorEmployeeId'); //服务商代表Id;
//模块加载配置
require.config({
	baseUrl: '../js/', //配置根路径
	paths: {
		calendarWidget: 'plugin/component/calendar-new', //日历控件
		moment: 'plugin/moment.min', //时间日期格式化组件
		cropper: 'plugin/cropperjs/cropper', //图片裁切组件
		'mudufetcher': 'https://static.mudu.tv/fetcher/bundle.6d7aca164d2389e8bea6',
    'mudusdk': 'https://static.mudu.tv/static/websdk/sdk'
	},
	waitSeconds: 200
});
var index = {
	//初始化视图
	initView: function () {
		//主视图（首页）
		var mainView = app.addView('.view-main', {
			dynamicNavbar: true, //ios具有动态导航
			domCache: true
		});
		//营销视图
		var marketingView = app.addView('.view-marketing', {
			dynamicNavbar: true,
			domCache: true
		});
		//消息视图
		var messageView = app.addView('.view-message', {
			dynamicNavbar: true,
			domCache: true
		});
		//资源视图
		var resourceView = app.addView('.view-resource', {
			dynamicNavbar: true,
			domCache: true
		});
		//我的视图
		var mineView = app.addView('.view-mine', {
			dynamicNavbar: true,
			domCache: true
		});
		//绑定事件
		index.bindEvent();
		//默认展示首页
		app.showTab('#tab-home');
	},
	/*
	 * 绑定事件
	 * */
	bindEvent: function () {
		//监听登录后，加载模块
		$$(document).on('after-login', function () {
			require(['plugin/component/permissions'], function (permission) {
				permission.init();
            });
		});
		//首页
		$$('#tab-home').once('show', function () {
			//加载callback回调
			require(['plugin/component/callback']);
		});
		//资讯
		$$('#tab-news').once('show', function () {});
		//消息
		$$('#tab-IM').once('show', function () {});
		//工作
		$$('#tab-work').once('show', function () {});
		//我的
		$$('#tab-mine').once('show', function () {});
	},
	//启动加载模块
	requireModal: function () {
		// 加载每个视图模块
		require(['home/index', 'marketing/index', 'message/index', 'resource/index', 'mine/index'], function (home, marketing, message, resource, mine) {
			var mainView = app.views[0];
			home.init(mainView.activePage);
			var marketingView = app.views[1];
			marketing.init(marketingView.activePage);
			var messageView = app.views[2];
			message.init(messageView.activePage);
			var resourceView = app.views[3];
			resource.init(resourceView.activePage);
			var mineView = app.views[4];
			mine.init(mineView.activePage);
		});
	}
};

/**************/
Framework7.prototype.plugins.common = function (app, params) {
	'use strict';
	var self = this,
		constantData = null,
		optionsData = null,
		Common = null;
	/*
	 * 公共方法
	 * */
	Common = function () {
		/*
		 * 获取自定义常量
		 * @param {string} type 选项集类型
		 * @param {string} key  对应选项集data对象的索引
		 * @return
		 * */
		self.getConstantData = function (type, key) {
			//该文件太大，只读取一次，存在变量中
			if (!constantData) {
				//读区数据
				var ret = api.readFile({
					path: 'widget://js/plugin/data/constant.json',
					sync: true
				});
				if (ret) {
					constantData = JSON.parse(ret);
				} else {
					app.alert('constant数据读取异常', '糟糕, 出错了:(');
					console.log('读取文件异常: ' + JSON.stringify(ret));
					return;
				};
			};
			if (type) {
				if (key == undefined) {
					return constantData[type];
				} else {
					return constantData[type].data[key].name;
				}
			} else {
				app.alert('constant组件参数错误', '糟糕，错误了~');
				console.log('constant组件参数错误');
			};
		};
		/*
		 * 选项集单选选择器
		 * @param {array} param, 数组对象
		 * @param {HTMLElement} item.input, 绑定元素
		 * @param {string} item.type, 要选择的选项集类型
		 * */
		self.optionsPicker = function (param) {
			$$.each(param, function (index, item) {
				var input = item.input,
					type = item.type;
				//获取选项集
				var option = options[type],
					values = [],
					displayValues = [],
					inputHidden = input.parent().find('[type="hidden"]'),
                    defaultValue = inputHidden.val() == '' ? null : [inputHidden.val()];
				$$.each(option.data, function (key, value) {
					values.push(key);
					displayValues.push(value);
				});
				var newPicker = app.picker({
					input: input,
					value: defaultValue,
					rotateEffect: true,
					toolbarCloseText: '完成',
					cols: [{
						values: values,
						displayValues: displayValues,
						width: '100%',
						textAlign: 'center'
					}],
					formatValue: function (p, values, displayValues) {
						if (displayValues.length == 0) {
							displayValues.push(option.data[values[0]]);
						};
						return displayValues[0];
						//返回到input内的值
					},
					onChange: function (p, values, displayValues) {
						//返回选择的id
						inputHidden.val(values[0]);
					}
				});
			});
		};
		/*
		 * 格式化时间日期
		 * @param {Date or string} date 要格式化的日期对象
		 * @param {string} format 日期格式, yyyy/MM/dd HH:mm:ss
		 * @return {string} 返回格式化后的日期
		 * */
		self.dateFormat = function (date, format) {
			var moment = require('moment');
			return format = moment(date).format(format);
		};
		self.length = function () {
			return $$('picker-modal').length;
		}
		/*
		 * 时间日期选择器
		 * @param {HTMLElement} inputField 触发选择器的input
		 * */
		self.dateTimePicker = function (inputField) {
			//安卓平台打开有延迟
			if (app.device.os == 'android') {
				inputField.click(function () {
					app.closeModal('.picker-modal');
					api.showProgress();
				});
			};
			//处理默认值
			var dateObj = null,
				defaultVal = null;
            var inputVal = inputField.val();
            var nowDate = inputVal.split(' ');
            var moment = require('moment');
			//如果没有默认值，则用当前日期时间
			if (inputVal) {
				dateObj = new Date(moment(inputVal));
			} else {
				dateObj = new Date();
            };
			defaultVal = [dateObj.getFullYear(), dateObj.getMonth(), dateObj.getDate(), dateObj.getHours(), dateObj.getMinutes()];
			var dateTimePicker = app.picker({
				input: inputField,
				inputReadOnly: true,
				rotateEffect: true,
				value: defaultVal, // 默认打开picker选中的值
				toolbarCloseText: '完成',

				onChange: function (picker, values, displayValues) {
					// 切换月，同时切好日
					var daysInMonth = new Date(picker.value[0], picker.value[1] * 1 + 1, 0).getDate();
					if (values[2] > daysInMonth) {
						picker.cols[4].setValue(daysInMonth);
						//切好第四列（因为中间加了两个divider）
					}
				},
				onOpen: function (p) {
					api.hideProgress();
				},

				formatValue: function (p, values, displayValues) {
					var month = (parseInt(values[1]) + 1),
						day = parseInt(values[2]),
						hour = parseInt(values[3]),
						minute = parseInt(values[4]);
					month = month < 10 ? '0' + month : month;
					day = day < 10 ? '0' + day : day;
					hour = hour < 10 ? '0' + hour : hour;
					minute = minute < 10 ? '0' + minute : minute;
					return values[0] + '-' + month + '-' + day + ' ' + hour + ':' + minute;
				},

				cols: [
					// Years
					{
						values: (function () {
							var arr = [];
							for (var i = 1950; i <= 2030; i++) {
								arr.push(i);
							}
							return arr;
						})(),
						textAlign: 'center'
					},
					// Space divider
					{
						divider: true,
						content: '-',
						textAlign: 'center'
					},
					// Months
					{
						values: ('0 1 2 3 4 5 6 7 8 9 10 11').split(' '),
						displayValues: ('1 2 3 4 5 6 7 8 9 10 11 12').split(' '),
						textAlign: 'center'
					},
					// Space divider
					{
						divider: true,
						content: '-',
						textAlign: 'center'
					},
					// Days
					{
						values: (function () {
							var arr = [];
							for (var i = 1; i <= 31; i++) {
								arr.push(i);
							}
							return arr;
						})(),
						textAlign: 'right'
					},
					// Space divider
					{
						divider: true,
						content: '&nbsp;&nbsp;',
						textAlign: 'center'
					},
					// Hours
					{
						values: (function () {
							var arr = [];
							for (var i = 0; i <= 23; i++) {
								arr.push(i);
							}
							return arr;
						})(),
						textAlign: 'left'
					},
					// Divider
					{
						divider: true,
						content: ':',
						textAlign: 'center'
					},
					// Minutes
					{
						values: (function () {
							var arr = [];
							for (var i = 0; i <= 59; i++) {
								arr.push(i);
							}
							return arr;
						})(),
						textAlign: 'right'
					}
				]
			});
		};
		/*
		 * 日期选择器
		 * @param {string} inputField 触发选择器的input
		 * @param {array} defaultVal 默认显示的日期
		 * @param {string} dateFormat 日期格式
		 * */
		self.calendarPicker = function (inputField, defaultVal, dateFormat) {
            defaultVal = defaultVal || null;
            var dateFormat = dateFormat ? dateFormat : 'yyyy-mm-dd';
			var calendarPicker = app.calendar({
				input: inputField,
				toolbarCloseText: '完成', //for android
				headerPlaceholder: '选择日期', //for android
				monthNames: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
				dayNamesShort: ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'],
				value: defaultVal,
                dateFormat: dateFormat,
                closeOnSelect: true
			});
		};
		/*
		 * 日期限制范围选择器
		 * @param {string} inputField 触发选择器的input
		 * @param {string} calendarEndDate 日历控件结束日期
		 * */
		self.calendarLimitPicker = function (inputField, calendarBenginDate, calendarEndDate, dateFormat) {
            var starDate = self.dateFormat(new Date(calendarBenginDate).getTime() - (1000*60*60*24),'YYYY-MM-DD');
            var dateFormat = dateFormat ? dateFormat : 'yyyy-mm-dd';
            var calendarPicker = app.calendar({
                input: inputField,
                toolbarCloseText: '完成', //for android
                headerPlaceholder: '选择日期', //for android
                monthNames: ['一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月', '十月', '十一月', '十二月'],
                dayNamesShort: ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'],
                dateFormat: dateFormat,
                minDate:starDate,
                maxDate:calendarEndDate,
                closeOnSelect: true
            });
		};
		/*
		 * 时间选择器
		 * @param {string} inputField 触发选择器的input
		 * @param {array} defaultVal 默认显示的时间，[07, 12]
		 * */
		self.timePicker = function (inputField, defaultVal) {
			var today = new Date();
			defaultVal = defaultVal || [today.getHours(), today.getMinutes()];
			var timePicker = app.picker({
				input: inputField,
				inputReadOnly: true,
				rotateEffect: true,
				value: defaultVal, // 默认打开picker选中的值
				toolbarCloseText: '完成',
				formatValue: function (p, values, displayValues) {
					var hour = parseInt(values[0]),
						minute = parseInt(values[1]);
					hour = hour < 10 ? '0' + hour : hour, minute = minute < 10 ? '0' + minute : minute;
					return hour + ':' + minute;
				},
				cols: [
					// Hours
					{
						values: (function () {
							var arr = [];
							for (var i = 0; i <= 23; i++) {
								arr.push(i);
							}
							return arr;
						})(),
						textAlign: 'center'
					},
					// Divider
					{
						divider: true,
						content: ':',
						textAlign: 'center'
					},
					// Minutes
					{
						values: (function () {
							var arr = [];
							for (var i = 0; i <= 59; i++) {
								arr.push(i);
							}
							return arr;
						})(),
						textAlign: 'center'
					}
				]
			});
		};
		/*
		 * 通知
		 * @param {string} title
		 * @param {string} message
		 * @param {string} type
		 * @param {function} callback
		 * */
		self.notification = function (title, message, type, callback) {
			var iconType = type ? type : 'info';
			app.closeNotification('.notification-item');
			//颜色
			var color = '';
			switch (type) {
				case 'success':
					color = 'color-green';
					break;
				case 'warning':
					color = 'color-orange';
					break;
				case 'info':
					color = 'color-lightblue';
					break;
				case 'error':
					color = 'color-red';
					break;
			}
			var newNotification = app.addNotification({
				title: title,
				message: message,
				hold: 3000,
				closeOnClick: true,
				button: {
					text: '关闭'
				},
				media: '<i class="icon icon-' + iconType + ' ' + color + '"></i>',
				onClick: function () {
					if (callback) {
						callback()
					};
				}
			});
		};
		/*
		 * 关闭页面
		 * @param {string} pageName
		 * */
		self.closePage = function (pageName) {
			var currentView = app.getCurrentView();
			var page = currentView.activePage; //当前页面
			var n = 1; //变量，记录中间页面
			while (page.fromPage && page.fromPage.name != pageName) {
				page = page.fromPage;
				if (page.from == 'right') {
					n++; //前进
				} else if (page.from == 'left') {
					n--; //后退
				}
			}
			setTimeout(function () {
				for (var i = 0; i < n; i++) {
					currentView.router.back({
						animatePages: false
					});
				};
			}, 200);
		};
		/*
		 * ajax 错误提示
		 * @param {object} ret : 错误结果
		 * @param {object} err : 错误结果
		 * @param {function} callback: 回调
		 * @param {string} flag: 错误标识
		 * */
		self.ajaxError = function (ret, err, callback, flag) {
			var params = {};
			//判断错误类型
			if (ret) {
				params = {
					type: 'warning',
					title: flag,
					description: ret.msg ? ret.msg : ret.error.details
				};
				//先关闭已经打开的弹层
				// app.closeModal();
				//弹出提示
				app.modal({
					text: '<i class="color-orange icon icon-' + params.type + '"></i>' + '<h3>' + params.title + '</h3><p class="decription">' + params.description + '</p>',
					buttons: [{
						text: '知道了'
					}]
				});
			} else if (err) {
				//判断错误类型
				if (err.statusCode === 0) {
					switch (err.code) {
						case 0:
							//断网
							params = {
								type: 'offline',
								title: '网络无法连接',
								description: '请连接网络后再试'
							}
							break;
						case 1:
							//超时
							params = {
								type: 'timeout',
								title: '网络不给力',
								description: '网络连接超时：' + flag
							};
							break;
						case 2:
							//授权错误
							params = {
								type: 'error',
								title: '授权错误',
								description: '给您带来的不便，我们深表歉意'
							};
							break;
						case 3:
							//数据类型错误
							params = {
								type: 'error',
								title: '数据类型错误',
								description: '给您带来的不便，我们深表歉意'
							};
							break;
					}
				} else {
					//判断登录是否过期
					if (err.statusCode === 401 && err.body.unAuthorizedRequest) {
						//清除token
						localStorage.removeItem('token');
						//判断是否已打开登录屏
						if ($$('.login-screen').length == 0) {
							//打开登录页面再次登录
							require(['plugin/component/login'], function (login) {
                                // login.init();
                                app.showIndicator();
								login.againLogin();
							});
						}
						return;
                    }
					var errorCode = '';
					if (err.statusCode) {
						errorCode = 'statusCode:' + err.statusCode;
					} else {
						errorCode = 'status:' + err.status;
					}
					//判断错误信息，为了兼容server 500问题（其它业务处理也归为500）
					var title = '糟糕系统出错',
						description = flag + '<br>(' + errorCode + ')';
					if (err.body && err.body.error && err.body.error.message) {
						title = '操作失败';
						description = err.body.error.message;
					}
					params = {
						type: 'error',
						title: title,
						description: description
					}
				};
				var buttons = [{
					text: '知道了'
				}];
				if (callback) {
					buttons = [{
                        text: '取消',
                        onClick: function(){
                            if(flag == '获取用户权限'){
                                // 获取用户权限失败，重新登录
                                app.alert('请重新登录','获取用户权限失败', function(){
                                    require(['mine/setting/index'], function (mineLogout) {
                                        mineLogout.logout();
                                    });
                                });
                            }
                        }
					}, {
						text: '重试',
						bold: true,
						onClick: callback
					}];
				};
				//弹出提示
				app.modal({
					title: params.title,
					text: '<i class="icon icon-' + params.type + '"></i>' + '<p class="decription">' + params.description + '</p>',
					buttons: buttons
				});
				//输出错误，用于调试
				console.log(flag + ': ' + JSON.stringify(err));
			}
		};
		//目前仅用于安卓定位
		self.aMapLBS = function (callback) {
			//安卓平台也要返回经纬度和地址
            var aMapLBS = api.require('aMapLBS');

			aMapLBS.configManager({
				accuracy: 'best',
				filter: 1.0
			}, function (ret, err) {
				if (ret.status) {
                    // getLocation();
                    singleAddress()
				} else {
					console.log('请检查', '配置定位信息失败');
					callback(false);
				}
			});
			//地理定位
			function getLocation(result) {
				aMapLBS.startLocation(function (ret, err) {
					if (ret && ret.status) {
                        //返回经纬度
                        result.lon = ret.lon;
						result.lat = ret.lat;
                        callback(result)
					} else {
						callback(false);
                    }
                    aMapLBS.stopUpdatingLocation();
				});
			};
			//逆地理定位
			function singleAddress(locationResult) {
				aMapLBS.singleAddress({
					timeout: 10
				}, function (ret, err) {
					if (ret && ret.status) {
						var result = ret.address;
						//考勤地址（街道＋地点）
						result.attendanceAddr = result.street + result.AOIName + result.POIName;
                        //callback(result);
                        getLocation(result);
					} else {
						callback(false);
					}
					// aMapLBS.stopUpdatingLocation();
					// aMapLBS = null;
				});
			};
		};
        self.getNameFromCoords = function(longitude,latitude,callback){
            geocode(longitude, latitude, callback);
        }
		//ios 使用高德web服务，http://lbs.amap.com/api/webservice/guide/api/georegeo
		function geocode(lon, lat, callback) {
			var location = lon + ',' + lat;
			var url = 'http://restapi.amap.com/v3/geocode/regeo?location=' + location + '&key=0c8be3011cbc3c0a39697e5220fb7529&radius=10';
			api.ajax({
				url: url,
				method: 'get',
				dataType: 'json',
				cache: true
			}, function (ret, err) {
				if (ret && ret.status) {
					var result = {};
					result.attendanceAddr = ret.regeocode.formatted_address;
					result.lon = lon;
					result.lat = lat;
					result.province = ret.regeocode.addressComponent.province;
					result.city = ret.regeocode.addressComponent.city;
					callback(result);
				} else {
					common.ajaxError(ret, err, null, '定位失败');
				};
			});
		};
		/**
         * 文章内表格处理
         */
        self.dataTable = function() {
            //为表格添加父元素
            var wrapOuter = function(target, html) {
				var wrap = html;
                if (Object.prototype.toString.call(html) === "[object String]") {
                    if (document.createRange) {
                        var range = document.createRange();
                        range.selectNodeContents(target);
                        wrap = range.createContextualFragment(html).firstChild;
                    } else {
                        wrap = document.createElement(str);
                    }
                }
                target.parentNode.replaceChild(wrap, target);
                wrap.appendChild(target);
            }
            var table = document.querySelectorAll("table");
            if (table) {
                for (var i = 0; i < table.length; i++) {
                    wrapOuter(table[i], '<div class="data-table card"></div>');
                }
            }
        };
		/**
		 * 仅获取定位（获取地址和经纬度）
		 */
        self.getAddr = function (callback) {
            //判断平台
            var os = app.device.os,
                aMap = api.require('aMap');
            if (os == 'ios') {
                //先打开高德地图
                aMap.open({
                    rect: {
                        x: 0,
                        y: 0,
                        w: 0,
                        h: 0
                    },
                    showUserLocation: true,
                    zoomLevel: 11,
                    fixed: true
                }, function (ret, err) {
                    if (ret.status) {
                        common.aMapGetLocation(callback);
                    } else {
                        callback(false);
                    }
                });
            } else if (os == 'android') {
                common.aMapGetLocation(callback);
            };
        };
        // 获取当前位置信息
        self.aMapGetLocation = function (callback) {
            var aMap = api.require('aMap');
            aMap.getLocation(function (ret, err) {
                if (ret.status) {
                    common.aMapGetNameFromCoords(ret, callback);
                } else {
                    callback(false);
                }
            });
        }
        // 根据经纬度查找地址信息
        self.aMapGetNameFromCoords = function (data, callback) {
            var aMap = api.require('aMap');
            aMap.getNameFromCoords({
                lon: data.lon,
                lat: data.lat
            }, function (ret, err) {
                if (ret.status) {
                    aMap.close();
                    var result = {};
					result.attendanceAddr = ret.address;
					result.lon = data.lon;
					result.lat = data.lat;
					result.province = ret.state;
                    result.city = ret.city;
                    callback(result);
                } else {
                    aMap.close();
                    callback(false);
                }
            });
        }
		/*
		 * 图片浏览器
		 * @param {array} photos
		 * @param {number} initialSlide
		 * */
		self.photoBrowser = function (photos, initialSlide) {
			//判断是否已打开图片浏览器，防止双击报错
			if ($$('body > .photo-browser').length) {
				return;
			};
			var statusbarOverlay = $$('.statusbar-overlay');
			//初始图片索引
			if (initialSlide === null) {
				initialSlide = 0;
			};
			var newPhotoBrowser = app.photoBrowser({
				theme: 'dark',
				toolbar: false,
				lazyLoading: true,
				ofText: '/',
				backLinkText: '关闭',
				initialSlide: initialSlide,
				photos: photos,
				onOpen: function (photobrowser) {
					statusbarOverlay.css('background-color', '#000');
				},
				onClose: function (photobrowser) {
					statusbarOverlay.removeAttr('style');
				},
				onLazyImageLoad: function (swiper, slide, image) {
					//长按事件
					$$(image).on('taphold', function () {
						//保存图片
						app.actions([{
							text: '保存图片',
							onClick: function () {
								self.download($$(image).attr('src'), self.saveMediaToAlbum);
							}
						}, {
							text: '取消',
							color: 'red'
						}]);
					});
				}
			});
			newPhotoBrowser.open();
		};
		/*
		 * 保存媒体到相册
		 * @param {string} path
		 * */
		self.saveMediaToAlbum = function (path) {
			api.saveMediaToAlbum({
				path: path
			}, function (ret, err) {
				if (ret && ret.status) {
					self.notification('保存成功', '请到相册查看', 'success');
				} else {
					app.alert(err.msg, '保存失败');
					console.log('保存失败:' + err.msg);
				};
			});
		};
		/*
		 * 下载文件
		 * @private
		 * @param {string} src, 文件路径
		 * */
		self.download = function (src, callback) {
			//以时间戳为文件名
			var fileName = new Date().getTime();
			api.download({
				url: src,
				savePath: api.cacheDir + '/' + fileName + '.png',
				allowResume: true
			}, function (ret, err) {
				if (ret) {
					if (ret.state == 1) {
						callback(ret.savePath);
					} else if (ret.state == 2) {
						app.alert('请重试', '下载失败');
						console.log('下载失败');
					}
				} else {
					app.alert(err.msg, '下载失败');
					console.log('下载失败:' + err.msg);
				};
				app.hideIndicator();
			});
		};
		/*
		 * 获取照片方法，相机拍照默认返回png格式，选择照片返回原格式
		 * @param {string} target 触发元素
		 * @param {function} callback 选择后的回调函数
		 * */
		self.getPicture = function (target, callback, cutsqua, isSingle) {
			target.click(function () {
                //判断是否限制上传张数
                if (!isNaN(isSingle)) {
                    if (target.parents('.image-selector').find('.col-25').length >= isSingle) {
                        common.notification('提示', '最多上传' + isSingle + '张图片', 'warning');
                        return;
                    }
                }
				app.actions([
					[{
						text: '选择照片来源',
						label: true
					}, {
						text: '拍照',
						onClick: function () {
							var param = {
								camera: 'camera',
								callback: callback,
								cutsqua: cutsqua
							}
							common.authorizationRemind('camera', self.authorizationRemindStorage, param);
						}
					}, {
						text: '相册',
						onClick: function () {
							var param = {
								camera: 'library',
								callback: callback,
								cutsqua: cutsqua
							}
							common.authorizationRemind('camera', self.authorizationRemindStorage, param);
						}
					}],
					[{
						text: '取消',
						color: 'red'
					}]
				]);
			});
        };
		self.authorizationRemindStorage = function (data) {
            // 判断存储权限
            common.authorizationRemind('storage', self.selectPicture, data);
        }
		//选择图片
		self.selectPicture = function (data) {
			var sourceType = data.camera,
				callback = data.callback,
				cutsqua = data.cutsqua;
			//该方法无法精准压缩剪裁图片
			api.getPicture({
				sourceType: sourceType,
				allowEdit: false, //是否可以选择图片后进行编辑，支持iOS及部分安卓手机
				targetWidth: 1000, //压缩后的图片宽度，图片会按比例适配此宽度（注意不是精准压缩）
				targetHeight: 1000
			}, function (ret, err) {
				if (ret && ret.data) {
					var imgPath = ret.data;
					//判断cutsqua参数没有传值 则默认直接返回图片路径
					if (cutsqua == 'undefined' || cutsqua == undefined || cutsqua == '') {
						callback(imgPath);
						return;
					} else {
						//加载图片裁剪组件
						require(['plugin/component/imageclip'], function (imageclip) {
							/* 	参数说明
							 ** 第一个参数：相册返回的图片路径
							 ** 第二个参数：是否正方形裁切
							 ** 第三个参数：回调
							 */
							imageclip.init(imgPath, cutsqua, function (ret) {
								callback(ret);
							});
						});
					}
				}
			});
		};
		/*
		 * 图片选择组件
		 * @param {HTMLElement} 组件容器
		 * @param {string} isSingle 单选
		 * @param {function} callback 回调
		 * */
		self.imageSelector = function (wrapper, table, isSingle, callback) {
			var selectBtn = wrapper.find('.btn-select'), //图片选择按钮
				content = wrapper.find('.content'); //图片容器
			//为已存在的图片绑定删除事件
			content.find('.col-25 .icon-close').click(function () {
				delEvt($$(this));
			});
            self.getPicture(selectBtn, selectCallback, null, isSingle);
			//选择图片回调
			function selectCallback(url) {
				//判断是否为单图上传，则移除原图片
				if (isSingle == 'single') {
					content.find('.col-25').remove();
				}
				var item = '<div class="col-25 animated"><div class="img" style="background-image: url(' + url + ')" data-src="' + url + '"></div><i class="icon icon-close"></i><div class="indicator"><span>0</span>%</div></div>';
				content.append(item);
				uploading = true;
				//添加图片后触发回调
				if (callback) {
					callback('add', url);
				};
				//为新添加的图片绑定删除事件
				content.find('.col-25:last-child').find('.icon-close').click(function () {
					delEvt($$(this));
				});
				//获取上传图片凭证
				self.getUploadToken(url, table);
			};
			//删除事件
			function delEvt(thisItem) {
				//删除提醒
				var buttons1 = [{
						text: '确定要删除该图片?',
						label: true
					},
					{
						text: '删除',
						color: 'red',
						onClick: function () {
							$$(thisItem).parent('.col-25').addClass('zoomOut').animationEnd(function (e) {
								//如果图片带有id，则保留删除的图片id；
								var id = $$(e.target).find('.img').attr('data-id');
								if (id) {
									var delId = content.attr('data-del') ? [content.attr('data-del')] : [];
									delId.push(id);
									content.attr('data-del', delId);
									//删除图片后触发回调
									if (callback) {
										callback('del', id);
									}
								};
								//删除图片
								$$(e.target).removeClass('zoomIn').remove();
							});
						}
					}
				];
				var buttons2 = [{
					text: '取消'
				}];
				var groups = [buttons1, buttons2];
				app.actions(groups);
			};
		};
		//图片选择器预览功能
		imageSelectorPreview();

		function imageSelectorPreview() {
			//点击预览
			function preview() {
				var index = $$(this).parent('.col-25').index(),
					photos = [],
					imgs = $$(this).parents('.image-selector').find('.img');
				$$.each(imgs, function (index, item) {
					photos.push($$(item).attr('data-src'));
				});
				self.photoBrowser(photos, index);
			};
			$$(document).off('click', '.image-selector .img', preview);
			$$(document).on('click', '.image-selector .img', preview);
		};
		/*
		 * 更新多图选择器数据
		 * @param {HTMLElement} wrapper, 选择器容器
		 * @param {string} url, 图片字段
		 * @param {string} id, 图片id
		 * @param {booleen} readonly, 是否为只读
		 * @param {array} data, 图片数据，数组对象
		 * */
		self.imageSelectorUpdate = function (param) {
			var html = '',
				readonly = param.readonly ? ' readonly' : '';
			//多图展示
			$$.each(param.data, function (index, item) {
				var url = mediaSrc + item;
				html += '<div class="col-25' + readonly + ' animated"><div class="img" style="background-image: url(' + url + ')" data-src="' + url + '" data-upload="' + item + '"></div><i class="icon icon-close"></i></div>';
			});
			param.wrapper.find('.content').html(html);
		};
		//获取七牛上传凭证
		self.getUploadToken = function (url, table) {
			$$('.img[data-src="' + url + '"]').parent('.col-25').find('.indicator span').text('10');
			api.ajax({
				url: server + 'api/services/app/qiniu/GetToken',
				method: 'post',
				dataType: 'json',
				headers: headers
			}, function (ret, err) {
				if (ret && ret.success) {
                    self.compress(url, '', ret.result, table);
                    // self.uploadFile(url,url, ret.result, table);
				} else {
					self.ajaxError(ret, err, null, '获取图片上传凭证失败');
				};
			});
        }
        /**
         * 图片压缩，因为ios路径问题，所以多添加一个url用于保存压缩后的图片路径
         */
        //压缩图片
        self.compress = function (url, url2, uploadToken, table) {
            var path = url2 ? url2 : url,
                scale = '',
                cacheImgUrl = '';
            var imageFilter = api.require('imageFilter');
            imageFilter.getAttr({
                path: path
            }, function (ret, err) {
                //如果图片大小大于4M则执行压缩
                var newSize = 4 * 1024 * 1024;
                if (ret.size > newSize) {
                    scale = (ret.size - newSize) / ret.size;
                    imageFilter.compress({
                        img: path,
                        quality: 0.5,
                        scale: scale,
                        save: {
                            album: false,
                            imgPath: api.fsDir + '/picture',
                            imgName: url.split('/')[url.split('/').length-1]
                        }
                    }, function (ret, err) {
                        if (ret.status) {
                            self.compress(url, api.fsDir + '/picture/'+url.split('/')[url.split('/').length-1], uploadToken, table);
                        }
                    });
                } else {
                    self.uploadFile(url, path, uploadToken, table);
                }
            });
        };
		/**
		 * 上传文件方法
		 * https://developer.qiniu.com/kodo/manual/1272/form-upload
		 */
		self.uploadFile = function (url, path, uploadToken, table) {
			var img = $$('.img[data-src="' + url + '"]');
			var indicator = $$('.img[data-src="' + url + '"]').parent('.col-25').find('.indicator');
			//生成文件名
			var fileName = new Date().getTime();
			//获取后缀名
			var suffix = url.split('.').splice(-1);
			//企业编号（数据库编号）
            var tenancyName = localStorage.getItem('tenancyName');
			api.ajax({
				url: 'https://upload.qiniup.com/',// 更改上传图片地址
				// url: 'http://upload.qiniup.com/',
				method: 'post',
				timeout: 60,
				dataType: 'json',
				report: true, //实时返回上传文件进度
				// headers: { //注释掉就可以了，ajax上传文件默认采用这种类型
				// 	"Content-Type": "multipart/form-data" //必须指定该类型
				// },
				data: {
					values: {
						token: uploadToken,
						key: tenancyName + '/' + table + '/originalPath/' + fileName + '.' + suffix
					},
					files: {
						'file': path
					}
				}
			}, function (ret, err) {
				if (ret) {
					indicator.find('span').text(ret.progress);
					if (ret.progress == 100 && ret.status == 1) {
						//手写签名实用此事件 请勿删!!!!!
						if (table == 'handwritten-signature') {
							api.sendEvent({
								name: 'drawingBoardupload',
								extra: {
									key: ret.body.key,
								}
							});
							return;
                        }
						indicator.remove();
						img.attr('data-upload', ret.body.key); //赋值文件名
						uploading = false;
					} else if (ret.status == 2) {
						api.alert({
							title: '上传失败',
							msg: '请重试'
						});
						uploading = false;
					}
				} else {
					api.alert({
						title: '上传失败',
						msg: '请重试'
					});
					uploading = false;
				}
			});
		}
		/*
		 * 获取地区数据
		 * @param {string} type, 类型
		 * @param {string} code, 编码
		 * */
		self.getRegionData = function (type, code) {
			var regionData = null;
			//获取省市数据
			var ret = api.readFile({
				path: 'widget://js/plugin/component/data/region.json',
				sync: true
			});
			if (ret) {
				regionData = JSON.parse(ret);
			} else {
				app.alert('地区数据读取异常', '糟糕,打开选择器失败:(');
				console.log('读取文件异常: ' + JSON.stringify(ret));
				return;
			}
			//判断类型
			if (type == undefined) {
				//返回所有省市数据
				return regionData;
			} else if (type == 'province' && !code) {
				//返回所有省份数据
				return regionData.province;
			} else if (type == 'province' && code) {
				//返回一个省份的名称
				return regionData.province[code];
			} else if (type == 'city' && code) {
				//返回一个城市的名称
				return regionData.city[code];
			} else {
				console.log('参数错误');
			}
		};
		/*
		 * 省市关联选择器
		 * @param {HTMLElement} inputField 触发选择器的input
		 * */
		self.regionPicker = function (inputField) {
			//获取省市数据
			var data = self.getRegionData();
			var provinceDisplayValues = [],
				provinceValues = [],
				cityDisplayValues = [],
				cityValues = [],
				firstProvince = '',
				firstCity = '',
				defaultVal = null;
			//判断是否存在默认值
			var provinceInput = inputField.parent().find('.province'),
				cityInput = inputField.parent().find('.city');
			var pid = provinceInput.val(),
				cid = cityInput.val();
			if (pid && cid) {
				defaultVal = [pid, cid];
				firstProvince = pid;
			} else {
				defaultVal = null;
				// 注意此处第一个省份为手动固定，如数据调整，则需手动更改
				firstProvince = '110000';
				firstCity = '110100';
			}
			//获取省份的显示名称和值
			$$.each(data.province, function (key, value) {
				provinceValues.push(key);
				provinceDisplayValues.push(value);
			});
			//获取第一个省份下的显示城市名称和值
			cityValues = data.related[firstProvince];
			$$.each(cityValues, function (index, value) {
				cityDisplayValues.push(data.city[value]);
			});
			//初始化省市选择器
			var regionPicker = app.picker({
				input: inputField,
				rotateEffect: true,
				value: defaultVal, // 默认打开picker选中的值
				toolbarCloseText: '完成',
				formatValue: function (p, values, displayValues) {
					//这个判断赋值很有必要，否则无法显示默认值
					if (displayValues.length == 0) {
						displayValues[0] = data.province[values[0]];
						displayValues[1] = data.city[values[1]];
					};
					//返回到input内的值
					return displayValues[0] + ' ' + displayValues[1];
				},
				cols: [
					//第一列，省份
					{
						textAlign: 'center',
						width: '50%',
						values: provinceValues,
						displayValues: provinceDisplayValues,
						onChange: function (p, value, displayValue) {
							//切换省份时显示对应的城市数据
							if (p.cols[1].replaceValues) {
								var values = data.related[value],
									displayValues = [];
								$$.each(values, function (index, value) {
									displayValues.push(data.city[value]);
								});
								p.cols[1].replaceValues(values, displayValues);
							};
						}
					},
					//第二列，城市
					{
						textAlign: 'center',
						values: cityValues,
						displayValues: cityDisplayValues, //默认展示第一个省份下的城市
						width: '50%'
					}

				],
				onChange: function (p, values, displayValues) {
					//返回省份id和城市id
					provinceInput.val(values[0]);
					cityInput.val(values[1]);
				},
				onOpen: function (p) {
					//打开的时候如果没有默认值，则返回默认的省份id和城市id，第一个是北京，北京
					if (!defaultVal) {

						provinceInput.val(firstProvince);
						cityInput.val(firstCity);
					}
				}
			});
		};
		/*
		 * 省份选择器
		 * @param {HTMLElement} inputField 触发选择器的input
		 * */
		self.provincePicker = function (inputField) {
			//获取省市数据
			var data = self.getRegionData('province');
			var provinceValues = [],
				provinceDisplayValues = [];
			var provinceInput = inputField.parent().find('.province');
			var defaultVal = provinceInput.val() ? [provinceInput.val()] : null;
			//获取省份
			$$.each(data, function (key, value) {
				provinceValues.push(key);
				provinceDisplayValues.push(value);
			});
			//初始化省份选择器
			var provincePicker = app.picker({
				input: inputField,
				rotateEffect: true,
				value: defaultVal,
				headerPlaceholder: '选择日期',
				toolbarCloseText: '完成',
				cols: [
					//省份
					{
						textAlign: 'center',
						width: '100%',
						values: provinceValues,
						displayValues: provinceDisplayValues
					}
				],
				formatValue: function (p, values, displayValues) {
					//这个判断赋值很有必要，否则无法显示默认值
					if (displayValues.length == 0) {
						displayValues[0] = data[values[0]];
					};
					//返回到input内的值
					return displayValues[0];
				},
				onChange: function (p, values, displayValues) {
					//返回省份id
					provinceInput.val(values[0])
				}
			});
        };
        /**
         * 绑定极光设备
         * @param {string} registrationId, 设备id
         * 说明：当设备id没有值时，为退出帐号时操作，清空当前账户对应的设备id
         *      当设备Id有值时，后端需要判断当前帐号是否已经存在设备id，
         *          存在，判断两者是否一致，如果不一致，则给之前的设备id推送下线通知，然后将当前帐号与此设备id绑定
         *          不存在，将当前帐号与此设备id绑定
         */
        self.RegistrationIdByUserEvent = function(registrationId){
            api.ajax({
                url: server + 'api/services/app/dictionary/associateRegistrationIdByUserId',
                method: 'post',
                dataType: 'json',
                headers: headers,
                data: {
                    body: {
                        registrationId: registrationId //设备Id
                    }
                }
            }, function (ret, err) {
                if (ret && ret.success) {
                } else {
                    common.ajaxError(ret, err, self.RegistrationIdByUserEvent, '消息-极光推送-绑定极光设备');
                }
            });
        }
        /**
         * 拨打电话
         * @param {string} phone, 电话号码
         */
        self.callPhone = function(phone){
            // 拨打电话功能已授权，可直接拨打电话
            api.call({
                type: 'tel_prompt',
                number: phone
            });
        }
        /**
         * 授权提醒
         * @param {string} authorizationType, 授权类型
         * @param {object} callback, 回调
         * @param {string} data, 回调参数
         */
        self.authorizationRemind = function(authorizationType, callback, data){
            // 判断权限
            var phoneHasPermission = api.hasPermission({
                list: [authorizationType]
			});
            if (!phoneHasPermission || !phoneHasPermission[0] || !phoneHasPermission[0].granted) {
                // 未授权，先弹出提醒，授权
                api.requestPermission({
                    list:[authorizationType],
                    code:1
                }, function(ret, err){
                    if(callback){
                        callback(data);
                    }
                });
            }else{
                // 已授权，可直接调用回调
                if(callback){
                    callback(data);
                }
            }
        }
        /**
         * ajax模板
         * @param {string} ajaxUrl, 接口地址
         * @param {string} ajaxMethod, ajax类型
         * @param {object} ajaxValues, ajax传递参数
         * @param {object} ajaxCallback, ajax回调
         * @param {string} ajaxText, ajax描述
         */
        self.ajaxMethod = function(param){
            api.ajax({
                url: server + param.ajaxUrl,
                method: param.ajaxMethod,
                dataType: 'json',
                headers: headers,
                cache: true,
                data: {
                    body: param.ajaxValues
                }
            }, function (ret, err) {
                if (ret && ret.success) {
                    app.hideIndicator();
                    api.hideProgress();
                    param.ajaxCallback(ret, param);
                } else {
                    common.ajaxError(ret, err, param.ajaxAgainEvt, param.ajaxText);
                    app.hidePreloader();
                    //判断是否已打开登录屏
                    if (param.isAgainLogin && $$('.login-screen').length == 0) {
                        //打开登录页面再次登录
                        require(['plugin/component/login'], function (login) {
                            login.init();
                        });
                    }
                    app.hideIndicator();
                    api.hideProgress();
                };
            });
		}
		/*
         * 打开远程页面
         * @param {string} url
         * * @param {string} title   用于设置无标题页面标题
         */
        self.openRemotePage = function(url, type) {
            api.openWin({
                name: 'remote-page',
                url: api.wgtRootDir + '/html/component/open-page.html',
                bounces: false,
                slidBackEnabled: false,
                scrollToTop: true,
                bgColor: '#fff',
                pageParam: {
                    url: url,
                    type: type
                }
            });
        };
		//返回 common
		return self;
	};
	app.common = function () {
		return new Common();
	};
};