/**
 * 手写签名组件
 * author: 韩慧
 * date: 2018.08.27
 */
define(['moment'], function (moment) {
    var drawingBoard = null; //选择后回调函数
    var eventCallback = null;
    return {
        init: function (urlItem, imgItem, callback) { //id,状态，表名
            drawingBoard = api.require('drawingBoard'); //签名画板
            eventCallback = callback;
            DeawLodingEvent(urlItem, imgItem);
        }
    };
    //处理打开画板个按钮逻辑
    function DeawLodingEvent(urlItem, imgItem) {
        localStorage.setItem('DrawingBoard', true);
        //旋转屏幕
        api.setScreenOrientation({
            orientation: 'landscape_right'
        });
        api.openFrame({
            name: 'setdraw',
            url: api.wgtRootDir + '/html/component/drawing-set.html',
            bgColor: '#fff',
            rect: {
                x: 0,
                y: api.winWidth - 60,
                w: 'auto',
                h: 60
            }
        });
        drawingBoard.open({
            rect: {
                x: 0,
                y: 0,
                w: api.winHeight,
                h: api.winWidth - 60
            },
            styles: {
                brush: {
                    color: '#333',
                    width: 5
                },
                bgColor: '#fff'
            }
        });
        api.bringFrameToFront({
            from: 'setdraw',
        });
        //清空画布监听事件
        api.addEventListener({
            name: 'drawingBoardClear'
        }, function (ret, err) {
            drawingBoardClear();
        });
        //保存签名监听事件
        api.addEventListener({
            name: 'drawingBoardSave'
        }, function (ret, err) {
            drawingBoardSave();
        });
        //保存后七牛返回的文件路径
        api.addEventListener({
            name: 'drawingBoardupload'
        }, function (ret, err) {
            var value = ret.value.key; //回调
            urlItem.val(value);
            imgItem.css('background-image', 'url(' + mediaSrc + value + ')');
            imgItem.removeClass('hide');
            drawingBoardClose();
            api.hideProgress();
        });
    }
    //关闭画板和按钮
    function drawingBoardClose() {
        //关闭按钮
        api.closeFrame({
            name: 'setdraw'
        });
        //关闭画板
        drawingBoard.close();
        api.setScreenOrientation({
            orientation: 'portrait_up'
        });
        if(eventCallback){
            eventCallback();
        }
    }
    //清空画板上的所有笔画线条
    function drawingBoardClear() {
        drawingBoard.clear();
    }
    //保存签名画板截图
    function drawingBoardSave() {
        api.showProgress();
        var timestamp = new Date().getTime();
        drawingBoard.save({
            savePath: 'fs://drawingBoard/' + timestamp + '.png',
            copyToAlbum: false,
            overlay: true //类型：布尔类型   描述：（可选项）保存图片时，是否将背景一起保存
        }, function (ret) {
            //上传图片到七牛
            if (ret.absolutePath) {
                common.getUploadToken(ret.absolutePath, 'handwritten-signature');
            }
        });
    }
});