/**
 * 拖拽定位
 * author: 韩慧
 * date: 2019.07.16
 */
define(function () {
    var container = null,
        aMap = null,
        city = '', //所在城市
        address = '', //具体地址
        coor = null, //坐标
        isMapSign = false,
        amapdo = {},
        timer = null,
        lon = 0,
        lat = 0;
    return {
        init: function (mapSign, cityText, attendanceAddr, data) {
            // // 判断权限
            // var phoneHasPermission = api.hasPermission({
            //     list: ['location']
			// });
            // if (!phoneHasPermission || !phoneHasPermission[0] || !phoneHasPermission[0].granted) {
            //     // 未授权，先弹出提醒，授权
            //     api.requestPermission({
            //         list:[authorizationType],
            //         code:1
            //     }, function(ret, err){
            //         if(callback){
            //             callback(data);
            //         }
            //     });
            // }
            if (mapSign == true || mapSign == 'true') {
                isMapSign = true;
            } else {
                isMapSign = false;
            }
            city = cityText;
            address = attendanceAddr;
            coor = data;
            openPopup();
        }
    }
    //打开页面
    function openPopup() {
        if (isMapSign) {
            var popupHTML = '<div class="popup popup-map-sign"><div class="view navbar-fixed"><div class="pages"><div data-page="popup-map-sign" class="page toolbar-fixed"><div class="navbar"><div class="navbar-inner"><div class="left"><a href="#" class="close-popup link" data-popup=".popup-map-sign"><i class="icon icon-close"></i><span>关闭</span></a></div><div class="center">查看地点</div><div class="right"><a href="javascript:void(0);" class="link btn-done"><i class="icon icon-submit"></i></a></div></div></div>' +
                '<form class="searchbar searchbar-init"><div class="searchbar-input"><input type="search" placeholder="请输入完整地址进行搜索"><a href="#" class="searchbar-clear"></a></div><a href="#" class="searchbar-cancel">取消</a></form>' +
                '<div class="page-content"></div></div></div></div></div>';
        } else {
            var popupHTML = '<div class="popup popup-map-sign"><div class="view navbar-fixed"><div class="pages"><div data-page="popup-map-sign" class="page toolbar-fixed"><div class="navbar"><div class="navbar-inner"><div class="left"><a href="#" class="close-popup link" data-popup=".popup-map-sign"><i class="icon icon-close"></i><span>关闭</span></a></div><div class="center">查看地点</div></div></div><div class="page-content"></div></div></div></div></div>';
        }
        app.popup(popupHTML);
        $$('.popup-map-sign').on('opened', function () {
            container = $$('.popup-map-sign');
            navbarInnerContainer = container.find('.navbar');
            aMap = api.require('aMap');
            app.showIndicator();
            // 如果isMapSign = true，并且coor、address、city都为空，则调用打开地图，自动定位功能
            if (isMapSign == true || isMapSign == 'true') {
                if (!coor && !address && !city || (coor == null && address == '' && city == '')) {
                    var aMapLBS = api.require('aMapLBS');
                    amapdo.address = '';
                    amapdo.center = {
                        lon: '',
                        lat: '',
                    }
                    var os = app.device.os;
                    if (os == 'ios') {
                        aMapLBS.configManager({
                            accuracy: 'best',
                            filter: 1.0
                        }, function (ret, err) {
                            if (ret.status) {
                                // 地理定位
                                aMapLBS.singleLocation({
                                    timeout: 10
                                }, function (ret, err) {
                                    if (ret.status) {
                                        //返回经纬度
                                        amapdo.center = {
                                            lon: ret.lon,
                                            lat: ret.lat,
                                        }
                                        lon = ret.lon;
                                        lat = ret.lat;
                                        openMap();
                                    } else {
                                        console.log('请检查', '地理定位失败');
                                    }
                                    aMapLBS.stopUpdatingLocation();
                                });
                            } else {
                                console.log('请检查', '配置定位信息失败');
                            }
                        });
                    } else if (os == 'android') {
                        // 获取当前经纬度
                        aMap.getLocation(function (ret, err) {
                            if (ret.status) {
                                amapdo.center = {
                                    lon: ret.lon,
                                    lat: ret.lat,
                                }
                                lon = ret.lon;
                                lat = ret.lat;
                                openMap();
                            } else {
                            }
                        });
                    };
                } else {
                    amapdo.address = address;
                    //判断是否传了坐标
                    if (coor) {
                        lon = coor.lon;
                        lat = coor.lat;
                        amapdo.center = {
                            lon: coor.lon,
                            lat: coor.lat,
                        }
                        openMap();
                    } else {
                        getCoordsFromName();
                    }
                }
            } else {
                amapdo.address = address;
                //判断是否传了坐标
                if (coor) {
                    lon = coor.lon;
                    lat = coor.lat;
                    amapdo.center = {
                        lon: coor.lon,
                        lat: coor.lat,
                    }
                    openMap();
                } else {
                    getCoordsFromName();
                }
            }
            bindEvent();
        });
        $$('.popup-map-sign').on('close', function () {
            if (aMap) {
                aMap.close();
                aMap = null;
            }
        });
    };
    function bindEvent() {
        //完成
        navbarInnerContainer.find('.btn-done').click(function () {
            $$(document).trigger('after-map-sign', {
                "attendanceAddr": amapdo.address,
                "lon": amapdo.center.lon,
                "lat": amapdo.center.lat
            });
            app.closeModal('.popup-map-sign');
            if (aMap) {
                aMap.close();
                aMap = null;
            }
        });
        // 搜索功能
        container.find('.searchbar-cancel').on('click', function () {
        });
        //实时监控input输入情况,存在手动清空输入框的情况,单独列出
        container.find('input[type="search"]').on('input propertychange', function () {
            var addressKey = $$(this).val().replace(/\'/g, '').trim();
            clearTimeout(timer);
            timer = setTimeout(function () {
                if (addressKey && addressKey != '') {
                    // 根据关键词定位
                    getCoordsFromName(addressKey);
                }
            }, 3000);
        });
    }
    //根据地址查询经纬度
    function getCoordsFromName(addressKey) {
        if (!aMap) {
            return;
        }
        if (addressKey) {
            city = '';
            address = addressKey;
        }
        aMap.getCoordsFromName({
            city: city,
            address: address
        }, function (ret, err) {
            if (ret && ret.status) {
                amapdo.address = address;
                amapdo.center = {
                    lon: ret.lon,
                    lat: ret.lat,
                }
                lon = ret.lon;
                lat = ret.lat;
                if (!isMapSign) {
                    // 打开地图
                    openMap();
                } else {
                    // 重新设置地图中心点
                    aMap.setCenter({
                        coords: {
                            lon: lon,
                            lat: lat
                        },
                        animation: false
                    });
                    //在地图上添加标注信息
                    addAnnotations();
                }
            } else {
                var message = '';
                if (addressKey) {
                    message = '请输入正确的地址查询';
                }
                api.alert({
                    title: '获取地址坐标失败',
                    msg: message,
                }, function(ret, err) {
                
                });
            }
        });
    };
    //打开地图
    function openMap() {
        if (!aMap) {
            return;
        }
        //判断平台
        var os = app.device.os,
            y = 0;
        if (isMapSign) {
            //判断平台
            if (os == 'ios') {
                y = 108;
                //判断是否为x
                if (api.safeArea.top == 44) {
                    y = 132;//IOS主题
                }
            } else if (os == 'android') {
                y = 125;
            }
        } else {
            if (os == 'ios') {
                y = 64;
                //判断是否为x
                if (api.safeArea.top == 44) {
                    y = 88;//IOS主题
                }
            } else if (os == 'android') {
                y = 80;
            }
        }
        aMap.open({
            rect: {
                x: 0,
                y: y,
                w: 'auto',
                h: 'auto'
            },
            center: {
                lon: lon,
                lat: lat
            },
            zoomLevel: 15
        }, function (ret, err) {
            if (ret && ret.status) {
                // 在地图上添加标注信息
                addAnnotations();
                if (isMapSign) {
                    // 添加监听事件
                    addlistener();
                }
            } else {
                app.alert('打开地图失败');
            }
        });
        app.hideIndicator();
    };
    //在地图上添加标注信息
    function addAnnotations() {
        if (!aMap) {
            return;
        }
        // 移除指定 id 的标注（可移动、不可移动）或布告牌
        aMap.removeAnnotations({
            ids: [1]
        });
        aMap.addAnnotations({
            annotations: [{
                id: 1,
                lon: lon,
                lat: lat
            }]
        }, function (ret, err) {
        });
        // 设置点击标注时弹出的气泡信息
        aMap.setBubble({
            id: 1,
            content: {
                title: amapdo.address,
            },
            styles: {
                titleColor: '#666',
                titleSize: 12,
                w: 300,
                h: 60
            }
        }, function (ret) {
            if (ret) {
            }
        });
        // 有地址信息时，弹出标注
        if (amapdo.address) {
            // 弹出指定标注的气泡
            aMap.popupBubble({
                id: 1
            }, function (ret) {
            });
        }
        // 当isMapSign为true时，搜索input的值更改
        if (isMapSign) {
            container.find('input[type="search"]').val(amapdo.address);
        }
    }
    // 添加地图监听事件
    function addlistener() {
        if (!aMap) {
            return;
        }
        // 视角改变事件
        aMap.addEventListener({
            name: 'viewChange'
        }, function (ret, err) {
            if (ret.status) {
                // 获取地图中心位置  经纬度
                amapdo.center = {
                    lon: ret.lon,
                    lat: ret.lat,
                }
                lon = ret.lon;
                lat = ret.lat;
                if (lon && lat && aMap) {
                    // 根据经纬度获取地址名称
                    aMap.getNameFromCoords({
                        lon: lon,
                        lat: lat,
                    }, function (ret, err) {
                        if (ret.status) {
                            amapdo.address = ret.address;
                            addAnnotations();
                        }
                    });
                }
            }
        });
    };
});