/**
 * 展示地图
 * author: 吴小龙
 * date: 2017.12.14
 */
define(function () {
    var container = null,
        navbarInnerContainer = null,
        aMap = null,
        isSave = false,
        amapdo = null,
        mapCallback = null;
    return {
        init: function (callback) {
            // 加载loading
            api.showProgress();
            isSave = false
            mapCallback = callback;
            eventSign();
        }
    }
    // 开始定位签到
    function eventSign() {
        // 获取经纬度
        common.getAddr(function (addr) {
            if (addr) {
                //经纬度
                amapdo = addr;
                openPopup();
            } else {
                //定位失败返回false
                api.alert({
                    title: '定位失败',
                    msg: '是否重新定位?',
                }, function (ret, err) {
                    eventSign();
                    console.log(buttonIndex);
                    // //点击取消，关闭地图
                    // app.closeModal('.popup-map');
                    // if (aMap) {
                    //     aMap.close();
                    //     aMap = null;
                    // }
                });
            }
            api.hideProgress();
        });
    }
    //打开页面
    function openPopup() {
        var popupHTML = '<div class="popup popup-map"><div class="view navbar-fixed"><div class="pages"><div data-page="popup-map" class="page"><div class="navbar"><div class="navbar-inner"><div class="left"><a href="#" class="close-popup link" data-popup=".popup-map"><i class="icon icon-close"></i><span>关闭</span></a></div><div class="center">定位</div><div class="right"><a href="javascript:void(0);" class="link btn-submit"><i class="icon icon-submit"></i></a></div></div></div><div class="page-content"></div></div></div></div></div>';
        app.popup(popupHTML);
        $$('.popup-map').on('opened', function () {
            container = $$('.popup-map');
            navbarInnerContainer = container.find('.navbar');
            aMap = api.require('aMap');
            // 打开地图
            openMap();
            bindEvent();
        });
        $$('.popup-map').on('close', function () {
            if (aMap) {
                aMap.close();
                aMap = null;
            }
        });
    };

    function bindEvent() {
        //完成
        navbarInnerContainer.find('.btn-submit').click(function () {
            $$(document).trigger('after-map', {
                amapdo: amapdo
            });
            app.closeModal('.popup-map');
        });
        navbarInnerContainer.find('.close-popup').click(function () {
            $$(document).trigger('after-map', {
                amapdo: null
            });
        });
    }
    //打开地图
    function openMap() {
        if (!aMap) {
            return;
        }
        //判断平台
        var os = app.device.os,
            y = 0;
        if (os == 'ios') {
            y = 64;
            //判断是否为x
            if (api.safeArea.top == 44) {
                y = 88;//IOS主题
            }
        } else if (os == 'android') {
            y = 80;
        }
        aMap.open({
            rect: {
                x: 0,
                y: y,
                w: 'auto',
                h: 'auto'
            },
            center: {
                lon: amapdo.lon,
                lat: amapdo.lat
            },
            zoomLevel: 15
        }, function (ret, err) {
            if (ret && ret.status) {
                addAnnotations();
            } else {
                app.alert('打开地图失败');
            }
        });
    };
    //在地图上添加标注信息
    function addAnnotations() {
        if (!aMap) {
            return;
        }
        aMap.addAnnotations({
            annotations: [{
                id: 1,
                lon: amapdo.lon,
                lat: amapdo.lat
            }]
        }, function (ret, err) {
            if (ret.eventType == 'click') { }
        });
        // 设置点击标注时弹出的气泡信息
        aMap.setBubble({
            id: 1,
            content: {
                title: amapdo.attendanceAddr,
            },
            styles: {
                titleColor: '#666',
                titleSize: 12,
                w: 300,
                h: 60
            }
        }, function (ret) {
            if (ret) {
            }
        });
        // 有地址信息时，弹出标注
        if (amapdo.attendanceAddr) {
            // 弹出指定标注的气泡
            aMap.popupBubble({
                id: 1
            }, function (ret) {
            });
        }
    }
});