/**
 * 拍照定位组件
 * author: 韩慧
 * date: 2017.12.18
 */
define(['moment'], function (moment) {
    var container = null,
        navbarInnerContainer = null,
        isMapSign = true,
        eventId = '', //活动id
        eventStatus = '', //活动状态
        eventTb = '', // 表名
        readonly = false, //是否为只读状态，根据状态判断页面按钮的显示
        longitude = '', //定位经度
        latitude = '', //定位纬度
        locationTime = '', //定位时间
        addr = null, //定位信息
        eventType = '', //需要定位的类别
        eventData = '', //传递过来的数据
        eventURL = '', //传递过来的接口Url
        callback = null; //选择后回调函数
    return {
        init: function (id, status, tb, type, data, url) { //id,状态，表名, 类型, 数据, 接口url
            readonly = false;
            isMapSign = true;
            eventId = id;
            eventStatus = status;
            eventTb = tb;
            eventType = type;
            eventData = data;
            eventURL = url;
            //如果是完成状态，设置图片为只读
            if (eventType == 'knowledgeMetting' || eventType == 'actives') {
                eventStatus = data.status;
                // 如果从会议页面点击进来
                if (data.status == '2') {
                    readonly = true;
                    isMapSign = false;
                }
            } else if (eventStatus === 2) {
                // 其他情况
                readonly = true;
                isMapSign = false;
            }
            openPopup();
        }
    };
    //打开选择器
    function openPopup() {
        var popupHTML = '<div class="popup popup-photo-sign"><div class="view navbar-fixed"><div class="pages"><div data-page="popup-common-option" class="page"><div class="navbar"><div class="navbar-inner"><div class="left"><a href="#" class="close-popup link"><i class="icon icon-close"></i><span>关闭</span></a></div><div class="center">拍照定位</div><div class="right"><a href="javascript:void(0);" class="link btn-done hide"><i class="icon icon-submit"></i></a></div></div></div>' +
            '<div class="page-content">' +
            '<!-- 签到列表 --><div class="list-block signInPicPath hide"><dl class="image-selector signInPicPath_image"><dt class="item-content"><div class="item-inner"><div class="item-title">签到图片(限5张)</div><div class="item-after"><a href="#" class="link btn-select hide"><i class="icon icon-camera-fill"></i></a></div></div></dt><dd class="content row no-gutter"></dd></dl></div>' +
            '<!-- 拍照 --><div class="list-block"><dl class="image-selector call_image"><dt class="item-content"><div class="item-inner"><div class="item-title">照片(限5张)</div><div class="item-after"><a href="#" class="link btn-select hide"><i class="icon icon-camera-fill"></i></a></div></div></dt><dd class="content row no-gutter"></dd></dl></div>' +
            '<!-- 定位 --><div class="list-block"><ul><li><a href="#" class="item-link item-content sign-addr"><div class="item-media"><i class="icon color-green icon-sign-fill"></i></div><div class="item-inner"><input type="hidden" name="longitude" /><input type="hidden" name="latitude" /><div class="item-sub-title" name="addressName">获取定位信息</div><div class="item-after"><button class="button button-fill color-green btn-relocation hide" type="button">重新定位</button></div></div></a></li></ul></div>' +
            '</div>';
        app.popup(popupHTML);
        $$('.popup-photo-sign').on('opened', function () {
            container = $$('.popup-photo-sign');
            navbarInnerContainer = container.find('.navbar');
            if (eventType == 'knowledgeMetting' || eventType == 'actives') {
                knowledgeMettingShowPhotoSign();
            } else {
                getPhotoSign();
            }
        });
    };
    //获取照片定位信息
    function getPhotoSign() {
        // 加载loading
        app.showIndicator();
        var param = {
            ajaxUrl: 'api/services/app/sFEActivitiesPhoto/GetSFEActivitiesPhotoSignQueryList?sfeEventsId=' + eventId,
            ajaxMethod: 'get',
            ajaxValues: {},
            ajaxCallback: showPhotoSign,
            ajaxAgainEvt: getPhotoSign,
            ajaxText: '获取照片定位信息'
        }
        common.ajaxMethod(param);
    };
    //展示内容
    function showPhotoSign(ret) {
        var data = ret.result;
        // 判断显示按钮，如果不是完成状态，则显示按钮
        if (eventStatus != '2') {
            navbarInnerContainer.find('.btn-done').removeClass('hide'); //保存
            navbarInnerContainer.find('.btn-done').css('display', 'inline-flex');
            app.sizeNavbars('.view'); //iOS only
            container.find('.btn-select').removeClass('hide'); //拍照
            container.find('.btn-relocation').removeClass('hide'); //重新定位
        }
        // 判断是否有图片
        if (data.originalPath && data.originalPath.length > 0) {
            //遍历照片
            common.imageSelectorUpdate({
                wrapper: container.find('.call_image'), //选择器容器
                data: data.originalPath, //图片数据，数组对象
                readonly: readonly //是否为只读 
            });
        }
        // 判断是否有定位信息
        if (data.sfeActivitiesSignDto) { //有定位信息
            addr = {
                attendanceAddr: data.sfeActivitiesSignDto.addressName,
                city: '',
                lon: data.sfeActivitiesSignDto.longitude,
                lat: data.sfeActivitiesSignDto.latitude
            };
            // 显示定位信息
            longitude = data.sfeActivitiesSignDto.longitude; //定位经度
            latitude = data.sfeActivitiesSignDto.latitude; //定位纬度
            // locationTime = data.sfeActivitiesSignDto.locationTime;//定位时间
            container.find('[name="longitude"]').val(data.sfeActivitiesSignDto.longitude); //定位经度
            container.find('[name="latitude"]').val(data.sfeActivitiesSignDto.latitude); //定位纬度
            container.find('.sign-addr .item-sub-title').text(data.sfeActivitiesSignDto.addressName); //定位位置
            app.hideIndicator();
        } else { //没有定位信息
            // 判断是否已经是完成状态
            if (readonly) { //如果是完成状态，则显示没有定位
                container.find('.sign-addr .item-sub-title').text("没有定位信息"); //定位位置
                container.find('.sign-addr').addClass("disabled");
                app.hideIndicator();
            } else {
                container.find('.sign-addr').removeClass("disabled");
                // 自动获取当前定位信息
                common.authorizationRemind('location', startSign, '');
            }
        }
        bindEvent();
    };
    // 开始定位
    function startSign() {
        // 获取经纬度
        common.getAddr(function (addrObj) {
            addr = addrObj;
            if (addr) {
                //经纬度
                container.find('[name="longitude"]').val(addr.lon); //经度
                container.find('[name="latitude"]').val(addr.lat); //纬度
                //详细地址
                container.find('.sign-addr .item-sub-title').text(addr.attendanceAddr);
                // 定位时间
                // locationTime = moment(new Date()).format();
                app.hideIndicator();
            } else {
                //定位失败返回false
                container.find('[name="longitude"]').val(''); //经度
                container.find('[name="latitude"]').val(''); //纬度
                container.find('.sign-addr .item-sub-title').text('定位失败');
                app.confirm('是否重新定位?', '定位失败', function () {
                    // 重新定位
                    startSign();
                }, function () {
                    //点击取消
                    app.hideIndicator();
                });
            }
        });
    }
    //绑定事件
    function bindEvent() {
        // 监听地图完成
        $$(document).off('after-map-sign');
        $$(document).on('after-map-sign', function (e) {
            addr = e.detail;
            //经纬度
            container.find('[name="longitude"]').val(addr.lon); //经度
            container.find('[name="latitude"]').val(addr.lat); //纬度
            container.find('.sign-addr .item-sub-title').text(addr.attendanceAddr);
        });
        //完成
        navbarInnerContainer.find('.btn-done').click(function () {
            if (uploading) { // 判断图片是否已经上传完成
                common.notification('图片上传中', '请稍候再试', 'warning');
                return;
            }
            if (eventType == 'knowledgeMetting') {
                // 学术会议保存
                knowledgeMettingSavePhotoSign();
            } else if (eventType == 'actives') {
                // 活动
                activesSavePhotoSign();
            } else {
                savePhotoSign();
            }
        });
        // 重新定位
        container.find('.btn-relocation').on('click', function () {
            container.find('.sign-addr .item-sub-title').text('正在定位');
            common.authorizationRemind('location', startSign, '');
        });
        //点击进入地图(地址)        
        container.find('.sign-addr .item-sub-title').off('click');
        container.find('.sign-addr .item-sub-title').on('click', function () {
            if (addr) {
                //加载地图定位
                require(['plugin/component/map-sign'], function (map) {
                    map.init(isMapSign, addr.city, addr.attendanceAddr, addr);
                });
            }
        });
        //选择图片----选择之后需要添加七牛上传的功能,不需要后端上传图片，只在后端保存一个图片路径就可以了
        var call_image = container.find('.call_image');
        common.imageSelector(call_image, eventTb, 5);

        //选择图片（签到照片）
        var signInPicPath_image = container.find('.signInPicPath_image');
        common.imageSelector(signInPicPath_image, eventTb, 5);
    };
    // 保存
    function savePhotoSign() {
        // 加载loading
        app.showIndicator();
        var originalPathArr = [], //图片信息
            signObj = null; //定位信息
        // 定位时间
        locationTime = moment(new Date()).format();
        var values = {
            "sfeEventsId": eventId, //活动id
            "sfeActivitiesSignDto": { //定位信息
                "sfeEventsId": eventId, //关联活动ID
                "longitude": container.find('[name="longitude"]').val(), //定位经度
                "latitude": container.find('[name="latitude"]').val(), //定位纬度
                "addressName": container.find('[name="addressName"]').text(), //定位位置
                "locationTime": locationTime //定位时间
            }
        }
        // 获取图片信息
        var call_image = container.find('.call_image .img');
        $$.each(call_image, function (index, item) {
            originalPathArr.push($$(item).attr('data-upload'));
        });
        values.originalPath = originalPathArr; //图片地址【 传多少图，存多少，数据库会先删再增】
        var param = {
            ajaxUrl: 'api/services/app/sFEActivitiesPhoto/CreateOrUpdateSFEPhotoSign',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: savePhotoSignCallback,
            ajaxAgainEvt: savePhotoSign,
            ajaxText: '保存照片定位信息'
        }
        common.ajaxMethod(param);
    }
    function savePhotoSignCallback(ret) {
        if (ret.result && ret.result.status === 'y') { //保存成功
            common.notification('恭喜', '保存成功！', 'success');
            app.closeModal('.popup-photo-sign');
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
    // 学术会议   展示内容
    function knowledgeMettingShowPhotoSign() {
        // 判断是否显示签到照片
        if (signAndPhotoPermissions && signAndPhotoPermissions.developmentDrugstore.isConferenceSignPicture && eventType == 'knowledgeMetting') {
            container.find('.signInPicPath').removeClass('hide'); //签到照片
        }
        // 判断显示按钮，如果不是完成状态，则显示按钮
        if (eventData.status != '2') {
            navbarInnerContainer.find('.btn-done').removeClass('hide'); //保存
            navbarInnerContainer.find('.btn-done').css('display', 'inline-flex');
            app.sizeNavbars('.view'); //iOS only
            container.find('.btn-select-signInPicPath').removeClass('hide'); //签到照片
            container.find('.btn-select').removeClass('hide'); //拍照
            container.find('.btn-relocation').removeClass('hide'); //重新定位
        }
        if (eventType == 'knowledgeMetting') {
            // 判断是否有图片
            if (eventData.meetingImg && eventData.meetingImg.split(',').length > 0) {
                //遍历照片
                common.imageSelectorUpdate({
                    wrapper: container.find('.call_image'), //选择器容器
                    data: eventData.meetingImg.split(','), //图片数据，数组对象
                    readonly: readonly //是否为只读 
                });
            }
            // 判断是否有签到图片
            if (eventData.signInPicPath && eventData.signInPicPath.split(',').length > 0) {
                //遍历照片
                common.imageSelectorUpdate({
                    wrapper: container.find('.signInPicPath_image'), //选择器容器
                    data: eventData.signInPicPath.split(','), //图片数据，数组对象
                    readonly: readonly //是否为只读 
                });
            }
        } else if (eventType == 'actives') {
            // 判断是否有图片
            if (eventData.photoInfoes && eventData.photoInfoes.length > 0) {
                var imgdata = [];
                $$.each(eventData.photoInfoes, function (index, item) {
                    if (item.filePath) {
                        imgdata.push(item.filePath);
                    }
                });
                if (imgdata.length > 0) {
                    //遍历照片
                    common.imageSelectorUpdate({
                        wrapper: container.find('.call_image'), //选择器容器
                        data: imgdata, //图片数据，数组对象
                        readonly: readonly //是否为只读 
                    });
                }
            }
        }

        // 判断是否有定位信息
        if (eventData.locationInfos && eventData.locationInfos.length > 0) { //有定位信息
            longitude = eventData.locationInfos[0].axisX; //定位经度
            latitude = eventData.locationInfos[0].axisY; //定位纬度
            addr = {
                attendanceAddr: '',
                city: '',
                lon: longitude,
                lat: latitude
            };
            // 显示定位信息
            // 显示位置
            common.getNameFromCoords(longitude, latitude, showaddress);
            container.find('[name="longitude"]').val(longitude); //定位经度
            container.find('[name="latitude"]').val(latitude); //定位纬度
            app.hideIndicator();
        } else { //没有定位信息
            // 判断是否已经是完成状态
            if (readonly) { //如果是完成状态，则显示没有定位
                container.find('.sign-addr .item-sub-title').text("没有定位信息"); //定位位置
                container.find('.sign-addr').addClass("disabled");
                app.hideIndicator();
            } else {
                container.find('.sign-addr').removeClass("disabled");
                // 自动获取当前定位信息
                common.authorizationRemind('location', startSign, '');
            }
        }
        bindEvent();
    };
    // 显示定位信息
    function showaddress(data) {
        if (data) {
            container.find('.sign-addr .item-sub-title').text(data.attendanceAddr);
        } else {
            container.find('.sign-addr .item-sub-title').text('暂无定位信息');
        }
    }
    // 学术会议   保存信息
    function knowledgeMettingSavePhotoSign() {
        // 加载loading
        app.showIndicator();
        var values = {
            "id": eventId, //活动id
        },
            originalPathArr = [], //图片信息
            signInPicPathArr = []; //签到图片信息
        // 定位信息
        if (container.find('[name="longitude"]').val()) {
            values.locationInfos = [{
                "columnName": "locationInfos",
                "axisX": container.find('[name="longitude"]').val(),
                "axisY": container.find('[name="latitude"]').val()
            }];
        }
        // 获取图片信息
        var call_image = container.find('.call_image .img');
        $$.each(call_image, function (index, item) {
            originalPathArr.push($$(item).attr('data-upload'));
        });
        values.meetingImg = originalPathArr.join(',');
        // 判断是否显示签到照片
        if (signAndPhotoPermissions && signAndPhotoPermissions.developmentDrugstore.isConferenceSignPicture) {
            // 获取图片信息
            var signInPicPath_image = container.find('.signInPicPath_image .img');
            $$.each(signInPicPath_image, function (index, item) {
                signInPicPathArr.push($$(item).attr('data-upload'));
            });
            values.signInPicPath = signInPicPathArr.join(',');
        }
        var param = {
            ajaxUrl: eventURL,
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: knowledgeMettingSavePhotoSignCallback,
            ajaxAgainEvt: knowledgeMettingSavePhotoSign,
            ajaxText: '保存照片定位信息'
        }
        common.ajaxMethod(param);
    }
    function knowledgeMettingSavePhotoSignCallback(ret) {
        if (ret.result && ret.result.status === 'y') { //保存成功
            $$(document).trigger('after-photo-sign');
            common.notification('恭喜', '保存成功！', 'success');
            app.closeModal('.popup-photo-sign');
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }

    // 活动   保存信息
    function activesSavePhotoSign() {
        // 加载loading
        app.showIndicator();
        var values = {
            "id": eventId, //活动id
        },
            originalPathArr = []; //图片信息
        values.locationInfos = [{// 定位信息
            "columnName": "locationInfos",
            "axisX": container.find('[name="longitude"]').val(),
            "axisY": container.find('[name="latitude"]').val()
        }];
        // 获取图片信息
        var photoInfoes = container.find('.call_image .img');
        if (photoInfoes.length > 0) {
            $$.each(photoInfoes, function (index, item) {
                var imgObg = {
                    "columnName": "photoInfoes",
                    "filePath": $$(item).attr('data-upload')
                };
                originalPathArr.push(imgObg);
            });
            values.photoInfoes = originalPathArr;
        }
        var param = {
            ajaxUrl: eventURL,
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: activesSavePhotoSignCallback,
            ajaxAgainEvt: activesSavePhotoSign,
            ajaxText: '保存照片定位信息'
        }
        common.ajaxMethod(param);
    }
    function activesSavePhotoSignCallback(ret) {
        if (ret.result && ret.result.status === 'y') { //保存成功
            $$(document).trigger('after-photo-sign');
            common.notification('恭喜', '保存成功！', 'success');
            app.closeModal('.popup-photo-sign');
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
});