/**
 * 扫一扫
 * author: 陈汝冰
 * date: 2017.09.13
 */
define(function (require, exports) {
    var height_h = null,//模块展示y坐标
        privacy = null,//判断权限模块
        status = 'off',
        scannerCallback = null,
        FNScanner = null;//扫码模块
    exports.init = function (callback) {
        scannerCallback = callback;
        //判断是否有访问摄像头的权限(privacy仅支持ios)
        if (api.systemType == 'ios') {
            privacy = api.require('privacy');
            privacy.camera(function (ret, err) {
                if (ret.status && ret.details == 'authorized') {
                    //正常打开
                    openPopup();
                } else if (ret.details == 'notDetermined') {
                    //用户从未选择过权限，提示授权
                    openPopup();
                } else if (ret.details == 'denied') {
                    //拒绝授权提示
                    app.alert('请在手机权限设置中，允许药销通访问您的相机');
                }
            });
        } else {
            //安卓系统下，正常打开
            common.authorizationRemind('camera', openPopup, '');
        }

    }
    //打开选择器
    function openPopup() {
        app.showIndicator();
        //判断系统类型区分主题nav高度
        if (api.systemType == 'ios') {
            height_h = 64;//IOS主题
            //判断是否为x
            if (api.safeArea.top == 44) {
                height_h = 88;//IOS主题
            }
        } else {
            height_h = 76;//安卓material主题
        }
        FNScanner = api.require('FNScanner');
        var popupHTML = '<div class="popup popup-scanner"><div class="view navbar-fixed">' +
            '<div class="pages">' +
            '<div data-page="popup-common-option" class="page">' +
            '<div class="navbar">' +
            '<div class="navbar-inner">' +
            '<div class="left"><a href="#" class="closepopup link"><i class="icon icon-back"></i><span>关闭</span></a></div>' +
            '<div class="center">扫一扫</div>' +
            '<div class="right"><a href="#" class="link icon-only btn-lightswitch"><i class="icon">&#xe6fa;</i></a><a href="#" class="link icon-only btn-album">相册</a></div>' +
            '</div>' +
            '</div>' +
            '<div class="searchbar-overlay"></div>' +
            '<div class="page-content"></div>' +
            '</div></div></div></div>';
        app.popup(popupHTML);
        bindEvent();
        $$('.popup-scanner').on('opened', function () {
            openScanner();
        });
    }
    function bindEvent() {
        $$('.closepopup').on('click', function () {
            closeScanner();
        });
        //访问相册
        $$('.btn-album').on('click', function () {
            FNScanner.decodeImg(function (ret, err) {
                if (ret && ret.status) {
                    closeScanner();
                    scannerCallback(ret.content);
                } else {
                    // 安卓识别二维码有时可能会走两次，并且一次ret.status为true,一次没有ret，加上下面的alert之后，页面上的遮罩层没有关闭
                    // app.alert('未识别到二维码','提示');
                }
            });
        });
        //开闪光灯
        $$('.btn-lightswitch').on('click', function () {
            if (status == 'on') {
                FNScanner.switchLight({
                    status: 'off'
                });
                status = 'off';
                $$('.btn-lightswitch .icon').html('&#xe6fa;');
            } else {
                FNScanner.switchLight({
                    status: 'on'
                });
                status = 'on';
                $$('.btn-lightswitch .icon').html('&#xe6f8;');
            }
        });
    }
    //打开FNScanner模块
    function openScanner() {
        FNScanner.openView({
            rect: {
                x: 0,
                y: height_h,
                w: api.winWidth,
                h: api.winHeight
            }
        }, function (ret, err) {
            if (ret.eventType == "show") {//模块显示				
                openScannerLine();//打开的扫码模块只能用frame覆盖扫码线
                if (privacy) {
                    privacy.camera(function (ret, err) {
                        if (ret.status && ret.details == 'authorized') {

                        } else if (ret.details == 'denied') {
                            //拒绝授权提示
                            api.alert({
                                title: '访问摄像头失败',
                                msg: '请在手机权限设置中，允许药销通访问您的相机',
                            }, function(ret, err) {
                            });
                        }
                    });
                }
            } else if (ret.eventType == 'success') {//扫码成功
                closeScanner();
                scannerCallback(ret.content);
            } else if (ret.eventType == 'cameraError') {//访问摄像头失败
                api.alert({
                    title: '访问摄像头失败',
                    msg: '请在手机权限设置中，允许药销通访问你的相机',
                }, function(ret, err) {
                    closeScanner();
                });
            } else if (ret.eventType == 'albumError') {//访问相册失败
                api.alert({
                    title: '访问相册失败',
                    msg: '请在手机权限设置中，允许药销通访问你的手机相册',
                }, function(ret, err) {
                    closeScanner();
                });
            } else if (ret.eventType == 'fail') {//扫码失败
                common.notification('提示', '扫码失败，请重试', 'warning');
            }
            app.hideIndicator();
        });
    }
    //展示扫码线
    function openScannerLine() {
        api.openFrame({
            name: 'scannerView',
            url: './component/scanner_view.html',
            bounces: false,
            reload: true,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            rect: {
                x: 0,
                y: height_h,
                w: 'auto',
                h: 'auto'
            }
        });
    }
    //关闭扫码模块、扫码线
    function closeScanner() {
        FNScanner.closeView();//关闭FNScanner模块
        api.closeFrame({
            name: 'scannerView'
        });
        app.closeModal();//关闭扫码页面
    }
});