/**
 * 分享组件
 * author: 韩慧
 * date: 2018.009.03
 */
define(function () {
    var wx = api.require('wx'),
        values = {},
        loader = false;
    return {
        init: function (param) {
            if(!loader){
                loader = true;
                values = param;
                // 判断存储权限
                common.authorizationRemind('storage', getAQRCode, '');
            }
        }
    }
    //获取小程序码
    function getAQRCode() {
        app.showIndicator();
        var param = {
            ajaxUrl: 'api/services/app/wXAQRCode/GetAQRCodeImg',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: getAQRCodeajaxCallback,
            ajaxAgainEvt: getAQRCode,
            ajaxText: '获取小程序二维码'
        }
        common.ajaxMethod(param);
    }
    function getAQRCodeajaxCallback(ret){
        if (ret.result.status == 'y') {
            common.download(ret.result.data, showQRcode);
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
        loader = false;
    }
    /*
     * 显示数推宝小程序码
     * */
    function showQRcode(imgPath) {
        app.modal({
            title: '数推宝小程序',
            afterText: '<img src=' + imgPath + ' style="height:232px;width:98%;display:block; margin:2% 1%">',
            buttons: [{
                text: '关闭'
            }, {
                text: '分享',
                onClick: function () {
                    isInstalled(imgPath);
                }
                // text: '保存',
                // onClick: function () {
                //     // 保存图片
                //     common.saveMediaToAlbum(imgPath);
                // }
            }]
        });
        app.hideIndicator();
        loader = false;
    };
    //分享图片到微信
    function isInstalled(imgPath) {
        wx.isInstalled(function (ret) {
            if (ret.installed) {
                shareImage(imgPath);
            } else {
                common.notification('提示', '当前设备未安装微信客户端!', 'info');
            }
        });
    };
    // 图片分享
    function shareImage(imgPath){
        wx.shareImage({
            scene: 'session', //session（会话） timeline（朋友圈）
            contentUrl: imgPath,
        }, function (ret, err) {
            if (ret.status) {
                common.notification('恭喜', '分享成功', 'success');
            } else {
                switch (err.code) {
                    case 0:
                        common.notification('恭喜', '分享成功', 'success');
                        break;
                    case 2:
                        common.notification('取消', '分享已取消', 'warning');
                        break;
                    default:
                        app.alert('错误码：' + err.code, '微信分享失败');
                }
            }
        });        
    }
});