/**
 * 拜访性质对应的接口
 * author: 韩慧
 * date: 2017.12.20
 */
define(function () {
    var container = null,
        navbarInnerContainer = null,
        values = {}, //参数
        key = '', //搜索关键字
        optionData = {
            "data": []
        }, //组合数据
        interfaceType = '', //对应接口：医院-hospital、医生-doctor、医院产品-hospitalProduct、药店-pharmacies、终端-terminals、商业渠道-commercialChannel、商业产品-commercialProduct
        pageNameJson = {
            "hospital": "医院", //医院
            "doctor": "医生", //医生
            "hospitalProduct": "产品", //医院产品
            "pharmacies": "药店", //药店
            "terminals": "终端", //终端
            "commercialChannel": "商业渠道", //商业渠道
            "commercialProduct": "产品" //商业产品
        }, //popup标题
        urlJson = {
            "hospital": "api/services/app/Hospital/getHospitalToSelect2ByTargetHospital", //医院
            "doctor": "api/services/app/hospitalDoctor/GetDoctorToSelect2ByTargetHospital", //医生
            "hospitalProduct": "api/services/app/dictionary/GetProductFormatForSelect2ByHId", //医院产品
            "pharmacies": "api/services/app/dictionary/GetDrugStoreByTargetIdForSelect2", //药店
            "terminals": "api/services/app/dictionary/GetMedicalToSelect2ByTarget", //终端
            "commercialChannel": "api/services/app/bizCustomers/GetBizCustomersToSelect2", //商业渠道
            "commercialProduct": "api/services/app/bizCustomers/GetBizCustomerProductToSelect2" //商业产品
        }, //url地址
        callback = null; //选择后回调函数
    return {
        init: function (interface, selectCallback, id) {
            interfaceType = interface;
            callback = selectCallback;
            values = {
                "hospitalId": id, //医生、医院产品使用
                "id": id //商业产品使用
            };
            optionData = {
                "data": []
            };
            openPopup();
        },
    };
    //打开选择器
    function openPopup() {
        var popupHTML = '<div class="popup popup-nature-selector"><div class="view navbar-fixed"><div class="pages"><div data-page="popup-common-option" class="page toolbar-fixed"><div class="navbar"><div class="navbar-inner"><div class="left"><a href="#" class="close-popup link"><i class="icon icon-close"></i><span>关闭</span></a></div><div class="center">选择' + pageNameJson[interfaceType] + '</div></div></div>' +
            '<form class="searchbar searchbar-init"><div class="searchbar-input"><input type="search" placeholder="搜索' + pageNameJson[interfaceType] + '"><a href="#" class="searchbar-clear"></a></div><a href="#" class="searchbar-cancel">取消</a></form>' +
            '<div class="page-content"><div class="list-block list-block-search searchbar-found"></div><div class="content-block searchbar-not-found">没有找到相关内容</div></div></div></div></div></div>';
        app.popup(popupHTML);
        $$('.popup-nature-selector').on('opened', function () {
            container = $$('.popup-nature-selector');
            navbarInnerContainer = container.find('.navbar');
            bindEvent();
        });
    };
    //绑定事件
    function bindEvent() {
        //按条件查找
        container.find('input[type="search"]').keyup(function (e) {
            if (e.keyCode === 13) {
                key = $$(this).val().replace(/\'/g, '');
                values.q = key;
                optionData = {
                    "data": []
                } //清空组合数据
                getData();
            }
        });
        //实时监控input输入情况,存在手动清空输入框的情况,单独列出
        container.find('input[type="search"]').on('input propertychange', function () {
            key = $$(this).val().replace(/\'/g, '');
            if (key == '') {
                //清空列表
                container.find('.list-block').html('');
            }
        });
        //清空按钮点击事件
        $$('.searchbar-clear').on('click', function () {
            //清空列表
            container.find('.list-block').html('');
        });
    };
    //获取医院数据
    function getData() {
        app.showIndicator();
        var param = {
            ajaxUrl: urlJson[interfaceType],
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: showData,
            ajaxAgainEvt: getData,
            ajaxText: '获取'+pageNameJson[interfaceType]+'数据'
        }
        common.ajaxMethod(param);
    };
    //展示选项
    function showData() {
        for (var i = 0; i < ret.result.length; i++) {
            optionData.data[i] = {};
            optionData.data[i].id = ret.result[i].id;
            optionData.data[i].name = ret.result[i].text;
        }
        var template = '<ul>{{#if data.length}}{{#each data}}<li><label class="label-radio item-content"><input type="radio" name="item" value="{{id}}""><div class="item-media"><i class="icon icon-form-radio"></i></div><div class="item-inner"><div class="item-title">{{name}}</div></div></label></li>{{/each}}{{else}}<li class="no-message"><div class="color-gray flex-center no-data">没有找到相关信息</div></li>{{/if}}</ul>';
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(optionData);
        container.find('.list-block').html(html);
        //完成
        container.find('li:not(.no-message)').click(function () {
            var id = $$(this).find('input').val(),
                name = $$(this).find('.item-title').text();
            result = {
                id: id,
                name: name
            };
            callback(result);
            app.closeModal('.popup-nature-selector');
        });
    };
});