/**
 * 资源-学术资源-学术资料
 * @author 韩慧
 * @date 2018.11.07
 */
define(function () {
    var container = null,
        keyword = '',
        timer = null,
        pi = 0,
        pz = 20,
        loading = false,
        pageContent = null,
        preloader = null;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                pageContent = container.find('.page-content');
                preloader = container.find('.list-preloader');
                pi = 0;
                keyword = '';
                loading = false;
                getData();
                bindEvent();
            }
        }
    }

    function bindEvent() {
        $$('.searchbar-cancel,.searchbar-clear').on('click', function () {
            //清空列表
            container.find('.list-block').html('');
            preloader.show();
            pi = 0;
            keyword = '';
            getData();
        });
        //实时监控input输入情况,存在手动清空输入框的情况,单独列出
        container.find('input[type="search"]').on('input propertychange', function () {
            var key = $$(this).val().replace(/\'/g, '');
            if (key == '') {
                pi = 0;
                keyword = '';
                getData();
            } else {
                clearTimeout(timer);
                timer = setTimeout(function () {
                    //清空列表
                    container.find('.list-block').html('');
                    keyword = key;
                    preloader.show();
                    pi = 0;
                    getData();
                }, 1000);
            }
        });
        //下拉刷新
        pageContent.on('refresh', function () {
            if (loading) {
                return;
            }
            pi = 0;
            getData();
            //如果解绑过无限滚动，下拉刷新后重新初始化
            app.attachInfiniteScroll(pageContent);
        });
        //无限滚动
        pageContent.on('infinite', function () {
            if (loading) {
                return;
            }
            preloader.show();
            getData();
        });
    };
    // 获取学术资料列表
    function getData() {
        loading = true;
        var values = {
            name: keyword,
            maxResultCount: pz,
            skipCount: pi * pz
        };
        var param = {
            ajaxUrl: 'api/services/app/dicClinicalLearningData/GetDICClinicalLearningDataList',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: showData,
            ajaxAgainEvt: getData,
            ajaxText: '获取学术资料'
        }
        common.ajaxMethod(param);
    }
    //展示学术资料列表
    function showData(ret) {
        loading = false;
        preloader.hide();
        app.pullToRefreshDone(pageContent);
        var data = ret.result;
        //编译模板数据
        var template = container.find('.tmp-list').html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        if (pi === 0) {
            container.find('.list-block').html('<ul>' + html + '</ul>');
        } else {
            container.find('.list-block ul').append(html);
        }
        //如果没有数据, 则解绑无限滚动事件
        if (data.items.length === 0) {
            app.detachInfiniteScroll(pageContent);
        } else {
            pi++;
        }
        // 点击列表打开pdf文件
        container.find('li').off('click');
        container.find('li:not(.no-message)').on('click', function () {
            var fileArr = $$(this).attr('data-filePath').split(','),
                fileType = $$(this).attr('data-filePath') ? $$(this).attr('data-filePath').split('.')[$$(this).attr('data-filePath').split('.').length - 1] : '';
            // 根据不同的平台使用不同的pdf阅读模块
            var sysType = api.systemType;
            if (sysType == 'ios') {
                var pdfReader = api.require('pdfReader');
            } else if (sysType == 'android') {
                var pdfReader = api.require('androidPdfReader');
            }
            if (fileType) {
                // 判断是否有附件
                if (fileType == 'pdf') {
                    // 文件为pdf格式时，只会有一个附件，采用打开pdf的方法打开
                    pdfReader.open({
                        path: mediaSrc + fileArr[0],
                    }, function (ret, err) {
                    });
                } else {
                    // 当文件格式为图片时，则调用查看大图的方法查看图片
                    var photos = [];
                    $$.each(fileArr, function (index, value) {
                        photos.push(mediaSrc + value);
                    });
                    common.photoBrowser(photos, 0);
                }
            } else { }
        });
    };
})