/**
 * 资源-服务费发票-添加
 * @author 韩慧
 * @date 2018.10.22
 */
define(['plugin/validate', 'moment'], function (validator, moment) {
    var container = null,
        navbarInnerContainer = null,
        pageContent = null,
        loading = false,
        containerPopup = null,
        navbarInnerContainerPopup = null,
        pageContentPopup = null,
        preloaderPopup = null,
        invoiceData = [],//查询出来的发票数据
        invoiceAmount = 0, // 发票总金额
        coopPartyA = '', // 清单甲方(coopPartyA)
        coopPartyB = '',// 清单乙方(coopPartyB)
        pi = 0,
        pz = 20;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                pageContent = container.find('.page-content');
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                invoiceData = [];
                pi = 0;
                bindEvent();
            }
        }
    };
    // 事件绑定
    function bindEvent() {
        //选择服务工作清单
        container.find('.chargeAccount').on('click', function () {
            openPopup('chargeAccount');
        })
        //扫描二维码
        container.find('.btn-scanner').on('click', function () {
            if (!container.find('[name="chargeAccountId"]').val()) {
                app.alert('请先选择工作清单!');
                return;
            }
            // 加载扫码模块
            require(['plugin/component/scanner'], function (scanner) {
                scanner.init(scannerCallback);
            });
        });
        //手动录入
        container.find('.btn-search').on('click', function () {
            if (!container.find('[name="chargeAccountId"]').val()) {
                app.alert('请先选择工作清单!');
                return;
            }
            // 打开popup
            openPopup('search');
        });
        navbarInnerContainer.find('.btn-submit').on('click', function () {
            if (container.find('[name="chargeAccountName"]').text() == '') {
                common.notification('提示', '请选择服务工作清单', 'warning');
            } else if (invoiceData && invoiceData.length == 0) {
                common.notification('提示', '请至少添加一张发票信息', 'warning');
            } else {
                if (container.find('[name="realCharge"]').text() != container.find('.invoiceAmount').text()) {
                    app.confirm('清单金额与发票总金额不一致，是否继续保存', '温馨提醒', function () {
                        saveInvoiceData();
                    });
                } else {
                    saveInvoiceData();
                }
            }
        });
    }
    // 打开popup
    function openPopup(type) {
        var typeName = '', btnDone = '', infinite = '';
        if (type == 'chargeAccount') {
            typeName = '选择服务工作清单';
            infinite = ' infinite-scroll';
        }
        //popup
        var popupHTML = '<div class="popup popup-group-option"><div class="view navbar-fixed"><div class="pages"><div data-page="popup-common-option" class="page"><div class="navbar"><div class="navbar-inner"><div class="left"><a href="#" class="close-popup link"><i class="icon icon-back"></i><span>关闭</span></a></div><div class="center">' + typeName + '</div><div class="right">' + btnDone + '</div></div></div>' +
            '<div class="page-content' + infinite + '"><div class="list-block media-list"></div><div class="list-preloader"><span class="preloader"></span></div></div></div></div></div></div>';
        var popupSearchHTML = '<div class="popup popup-group-option"><div class="view navbar-fixed"><div class="pages"><div data-page="service-iovoice-add-search" class="page"><div class="navbar"><div class="navbar-inner"><div class="left sliding"><a href="#" class="close-popup link"><i class="icon icon-back"></i><span>关闭</span></a></div><div class="center sliding">查询发票信息</div><div class="right"></div></div></div><div class="page-content"><form name="form-server-invoice-search"><div class="list-block"><ul><li class="item-content"><div class="item-inner"><div class="item-title label">发票代码<span class="color-red">*</span></div><div class="item-input"><input type="number" name="fpdm" placeholder="请输入10或12位发票代码" oninput="if(value.length>12)value=value.slice(0,12)"></div></div></li><li class="item-content"><div class="item-inner"><div class="item-title label">发票号码<span class="color-red">*</span></div><div class="item-input"><input type="number" name="fphm" placeholder="请输入8位发票号码" oninput="if(value.length>8)value=value.slice(0,8)"></div></div></li><li class="item-content"><div class="item-inner"><div class="item-title label">开票日期<span class="color-red">*</span></div><div class="item-input"><input type="text" name="kprq" placeholder="请选择开票日期" readonly="readonly"></div></div></li><!-- 专票时显示   2 --><li class="item-content zp hide"><div class="item-inner"><div class="item-title label">不含税金额<span class="color-red">*</span></div><div class="item-input"><input type="number" name="noTaxAmount" placeholder="请输入不含税金额"></div></div></li><!-- 普票时显示   1 --><li class="item-content pp"><div class="item-inner"><div class="item-title label">校验码(后6位)<span class="color-red">*</span></div><div class="item-input"><input type="number" name="checkCode" placeholder="请输入校验码(后6位)" oninput="if(value.length>6)value=value.slice(0,6)"></div></div></li></ul></div></form><div class="content-block"><a href="#" class="button button-big button-round color-blue button-fill btn-done">查询</a></div></div></div></div></div></div>';
        if (type == 'search') {
            app.popup(popupSearchHTML);
        } else {
            app.popup(popupHTML);
        }
        $$('.popup-group-option').on('opened', function () {
            containerPopup = $$('.popup-group-option');
            navbarInnerContainerPopup = containerPopup.find('.navbar');
            pageContentPopup = containerPopup.find('.page-content');
            pi = 0;
            if (type == 'chargeAccount') {
                preloaderPopup = containerPopup.find('.list-preloader');
                // 选择服务工作清单
                getSPRComplete();
                // 无限滚动
                pageContentPopup.on('infinite', function () {
                    if (loading) {
                        return;
                    }
                    preloaderPopup.show();
                    // if (type == 'chargeAccount') {
                    // 选择服务工作清单
                    getSPRComplete();
                    // }
                });
            } else if (type == 'search') {
                searchEvent();
            }
        });
    }
    // 获取服务工作清单下拉列表
    function getSPRComplete() {
        loading = true;
        var values = {
            maxResultCount: pz,
            skipCount: pi * pz,
            isApproved: true
        };
        var param = {
            ajaxUrl: 'api/services/app/SPRComplete/getSPRCompleteListApp',
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: getSPRCompleteajaxCallback,
            ajaxAgainEvt: getSPRComplete,
            ajaxText: '获取服务工作清单'
        }
        common.ajaxMethod(param);
    }
    // 获取服务工作清单
    function getSPRCompleteajaxCallback(ret) {
        if (ret.result.items) {
            showSPRComplete(ret.result);
        } else {
            if (containerPopup.find('li').length == 0) {
                app.alert('您还没有添加服务工作清单，请先到web端添加', '温馨提示', function () {
                    app.closeModal('.popup-group-option');
                });
            }
        }
        loading = false;
        preloaderPopup.hide();
        app.pullToRefreshDone(pageContentPopup);
    }
    // 展示服务清单列表
    function showSPRComplete(data) {
        var template = '{{#if items.length}} {{#items}}<li id="{{id}}" data-invoiceRelationFlag="{{invoiceRelationFlag}}" data-coopPartyA="{{coopPartyA}}" data-coopPartyB="{{coopPartyB}}"><a class="item-content item-link"><div class="item-inner"><div class="item-title-row"><div class="item-title">{{periodName}}</div><div class="item-after">￥<span class="realCharge">{{realCharge}}</span></div></div><div class="item-text">清单类型: <span class="serviceTypeName">{{serviceTypeName}}</span></div><div class="item-text">服务商: <span class="contractorsName">{{contractorsName}}</span></div><div class="item-text">CSP机构: <span class="cspName">{{cspName}}</span></div><div class="item-text">清单编号: <span class="listCode">{{listCode}}</span></div></div></a></li>{{/items}}{{else}}<li><div class="item-content color-gray flex-center">没有找到相关信息</div></li>{{/if}}';
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        if (pi === 0) {
            containerPopup.find('.list-block').html('<ul>' + html + '</ul>');
        } else {
            containerPopup.find('.list-block ul').append(html);
        }
        //如果没有数据, 则解绑无限滚动事件
        if (data.items.length === 0) {
            app.detachInfiniteScroll(pageContentPopup);
        } else {
            pi++;
        }
        // 点击选择
        containerPopup.find('li').off('click');
        containerPopup.find('li').on('click', function () {
            var that = $$(this);
            // 判断此清单是否已经添加过发票
            if (that.attr('data-invoiceRelationFlag') == true || that.attr('data-invoiceRelationFlag') == 'true') {
                app.modal({
                    title: '温馨提醒',
                    text: '该清单已经关联了发票，是否需要替换？',
                    buttons: [
                        {
                            text: '否',
                            onClick: function () {
                                var param = {
                                    chargeAccountId: that.attr('id'),
                                    chargeAccountName: that.find('.listCode').text(),
                                    contractors: that.find('.contractorsName').text(),
                                    serviceTypeName: that.find('.serviceTypeName').text(),
                                    cSP: that.find('.cspName').text(),
                                    period: that.find('.item-title').text(),
                                    realCharge: that.find('.realCharge').text(),
                                    coopPartyA: that.attr('data-coopPartyA'),
                                    coopPartyB: that.attr('data-coopPartyB')
                                }
                                // 判断发票列表是否有值
                                if (invoiceData.length > 0) {
                                    // 判断更换的清单与发票信息是否一致
                                    // 测协议的甲方乙方与发票的购买方销售方名称是否一致  购买方==甲方(coopPartyA) 、销售方==乙方(coopPartyB)
                                    if (that.attr('data-coopPartyA') != data.purchaserName || that.attr('data-coopPartyB') != data.salesName) {
                                        app.confirm('发票的购买方销售方名称与清单的甲方乙方名称不一致，是否继续？', '温馨提醒', function () {
                                            SPRCompleteClickAfter(param);
                                        });
                                    } else {
                                        SPRCompleteClickAfter(param);
                                    }
                                } else {
                                    SPRCompleteClickAfter(param);
                                }

                            }
                        },
                        {
                            text: '是',
                            onClick: function () {
                            }
                        }
                    ]
                });
            } else {
                // 显示信息
                container.find('[name="chargeAccountId"]').val(that.attr('id'));
                container.find('[name="chargeAccountName"]').text(that.find('.listCode').text());
                container.find('[name="contractors"]').text(that.find('.contractorsName').text());
                container.find('[name="serviceTypeName"]').text(that.find('.serviceTypeName').text());
                container.find('[name="cSP"]').text(that.find('.cspName').text());
                container.find('[name="period"]').text(that.find('.item-title').text());
                container.find('[name="realCharge"]').text(that.find('.realCharge').text());
                container.find('.chargeAccount-content').removeClass('hide');
                coopPartyA = that.attr('data-coopPartyA'); // 清单甲方(coopPartyA)
                coopPartyB = that.attr('data-coopPartyB');// 清单乙方(coopPartyB)
                // 更改invoiceData中服务清单的数据
                if (invoiceData.length > 0) {
                    $$.each(invoiceData, function (index, val) {
                        val.chargeAccountId = that.attr('id'); //服务工作清单Id
                        val.chargeAccountName = that.find('.serviceTypeName').text(); //服务工作清单
                    });
                }
                // 关闭popup
                app.closeModal('.popup-group-option');
            }
        });
    }
    function SPRCompleteClickAfter(param) {
        // 显示信息
        container.find('[name="chargeAccountId"]').val(param.chargeAccountId);
        container.find('[name="chargeAccountName"]').text(param.chargeAccountName);
        container.find('[name="contractors"]').text(param.contractors);
        container.find('[name="serviceTypeName"]').text(param.serviceTypeName);
        container.find('[name="cSP"]').text(param.cSP);
        container.find('[name="period"]').text(param.period);
        container.find('[name="realCharge"]').text(param.realCharge);
        coopPartyA = param.coopPartyA; // 清单甲方(coopPartyA)
        coopPartyB = param.coopPartyB; // 清单乙方(coopPartyB)
        container.find('.chargeAccount-content').removeClass('hide');
        // 更改invoiceData中服务清单的数据
        if (invoiceData.length > 0) {
            $$.each(invoiceData, function (index, val) {
                val.chargeAccountId = that.attr('id'); //服务工作清单Id
                val.chargeAccountName = that.find('.serviceTypeName').text(); //服务工作清单
            });
        }
        // 关闭popup
        app.closeModal('.popup-group-option');
    }
    // 手动录入事件
    function searchEvent() {
        // 发票代码字段失去焦点时，根据发票代码去判断发票类型
        containerPopup.find('[name="fpdm"]').blur(function (e) {
            // 获取发票代码
            var invoiceDataCode = $$(this).val(),
                b = '',
                code = new Array('144031539110', '131001570151', '133011501118', '111001571071'),
                invoiceType = '99';
            if (invoiceDataCode == '') {
                return;
            }
            // 12位时判断
            if (invoiceDataCode.length == 12) {
                b = invoiceDataCode.substring(7, 8);
                for (var i = 0; i < code.length; i++) {
                    if (invoiceDataCode == code[i]) {
                        invoiceType = "10";
                        break
                    }
                }
                if (invoiceType == "99") {
                    if (invoiceDataCode.charAt(0) == '0' && invoiceDataCode.substring(10, 12) == '11') {
                        invoiceType = "10"
                    }
                    if (invoiceDataCode.charAt(0) == '0' && (invoiceDataCode.substring(10, 12) == '04' || invoiceDataCode.substring(10, 12) == '05')) {
                        invoiceType = "04"
                    }
                    if (invoiceDataCode.charAt(0) == '0' && (invoiceDataCode.substring(10, 12) == '06' || invoiceDataCode.substring(10, 12) == '07')) {
                        invoiceType = "11"
                    }
                    if (invoiceDataCode.charAt(0) == '0' && invoiceDataCode.substring(10, 12) == '12') {
                        invoiceType = "14"
                    }
                }
                if (invoiceType == "99") {
                    if (invoiceDataCode.substring(10, 12) == '17' && invoiceDataCode.charAt(0) == '0') {
                        invoiceType = "15"
                    }
                    if (invoiceType == "99" && b == 2 && invoiceDataCode.charAt(0) != '0') {
                        invoiceType = "03"
                    }
                }
            } else if (invoiceDataCode.length == 10) {
                b = invoiceDataCode.substring(7, 8);
                if (b == 1 || b == 5) {
                    invoiceType = "01";
                } else if (b == 6 || b == 3) {
                    invoiceType = "04";
                } else if (b == 7 || b == 2) {
                    invoiceType = "02";
                }
            }
            if (invoiceType == '04' || invoiceType == '01' || invoiceType == '10') {
                if (invoiceType == '04' || invoiceType == '10') {
                    // 普票
                    containerPopup.find('.pp').removeClass('hide');
                    containerPopup.find('.zp').addClass('hide');
                } else if (invoiceType == '01') {
                    // 专票
                    containerPopup.find('.zp').removeClass('hide');
                    containerPopup.find('.pp').addClass('hide');
                }
            } else {
                app.alert('请输入正确的增值税专用发票或增值税普通发票的代码进行查询', '发票代码错误');
            }
        })
        // 日期选择器
        var kprqDate = containerPopup.find('[name="kprq"]'),
            // 添加默认值，当天
            defaultDate = moment(new Date()).format('YYYY-MM-DD');
        kprqDate.val(defaultDate);
        common.calendarPicker(kprqDate, [defaultDate]);
        //提交表单
        containerPopup.find('.btn-done').click(function () {
            validator.validateForm();
        });
        // 表单验证 
        var validator = new FormValidator('form-server-invoice-search', [{
            name: 'fpdm',
            display: '发票代码',
            rules: 'required'
        }, {
            name: 'fphm',
            display: '发票号码',
            rules: 'required'
        }, {
            name: 'kprq',
            display: '开票日期',
            rules: 'required'
        }], function (errors, event) {
            if (errors.length > 0) {
                $$.each(errors, function (index, value) {
                    common.notification('提示', value.message, 'warning');
                });
            } else {
                if (containerPopup.find('[name="InvoiceType"]').val() == '1' && containerPopup.find('.checkCode').val() == '') {
                    // 普票
                    common.notification('提示', '请填写校验码', 'warning');
                } else if (containerPopup.find('[name="InvoiceType"]').val() == '2' && containerPopup.find('.noTaxAmount').val() == '') {
                    // 专票
                    common.notification('提示', '不含税金额', 'warning');
                } else {
                    var values = {
                        'fpdm': containerPopup.find('[name="fpdm"]').val(),
                        'fphm': containerPopup.find('[name="fphm"]').val(),
                        'kprq': containerPopup.find('[name="kprq"]').val(),
                        'noTaxAmount': containerPopup.find('[name="noTaxAmount"]').val(),
                        'checkCode': containerPopup.find('[name="checkCode"]').val()
                    };
                    getInvoice('api/services/app/speInvoice/VerifyingInvoice', values);
                }
            }
        });
    }
    //扫描回调
    function scannerCallback(data) {
        getInvoice('api/services/app/speInvoice/VerifyingInvoiceOCR', [data]);
    }
    //获取发票信息
    function getInvoice(url, values) {
        app.showIndicator();
        var param = {
            ajaxUrl: url,
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: getInvoiceajaxCallback,
            ajaxAgainEvt: getInvoice,
            ajaxText: '获取发票信息'
        }
        common.ajaxMethod(param);
    }
    function getInvoiceajaxCallback(ret) {
        if (ret.result.status == 'y') {
            invoiceRepeatJudgeEvt(ret.result.data);
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
    // 发票去重判断
    function invoiceRepeatJudgeEvt(data) {
        if (invoiceData.length > 0) {
            var invoiceNum = 0;
            $$.each(invoiceData, function (index, val) {
                // 判断发票号码是否已经存在
                if (data.invoiceNumber == val.invoiceNumber) {
                    invoiceNum++;
                }
            });
            // 如果发票已存在存在表示则不进行保存
            if (invoiceNum > 0) {
                app.alert('已添加此发票，请重新选择', '发票重复');
            } else {
                showInvoiceEvt(data);
            }
        } else {
            showInvoiceEvt(data);
        }
    }
    // 判断发票信息与协议信息是否一致
    function showInvoiceEvt(data) {
        // 测协议的甲方乙方与发票的购买方销售方名称是否一致  购买方==甲方(coopPartyA) 、销售方==乙方(coopPartyB)
        if (coopPartyA != data.purchaserName || coopPartyB != data.salesName) {
            app.confirm('发票的购买方销售方名称与清单的甲方乙方名称不一致，是否继续？', '温馨提醒', function () {
                showInvoice(data);
            });
        } else {
            showInvoice(data);
        }
    }
    // 展示发票数据
    function showInvoice(data) {
        api.showProgress();
        invoiceAmount += parseFloat(data.totalTaxSum);
        container.find('.invoiceAmount').text(invoiceAmount);
        // 将新查询的发票数据添加到invoiceData
        var newInvoiceJson = {//临时数据
            chargeAccountId: container.find('[name="chargeAccountId"]').val(), //服务工作清单Id
            chargeAccountName: container.find('[name="serviceTypeName"]').text(),//服务工作清单
            invoiceType: data.invoiceTypeCode, //发票类型
            invoiceTypeName: data.invoiceTypeName, //发票类型名称

            money: parseFloat(data.totalAmount) ? parseFloat(data.totalAmount) : 0, //金额合计
            taxlMoney: parseFloat(data.totalTaxNum) ? parseFloat(data.totalTaxNum) : 0, //税额合计
            totalMoney: parseFloat(data.totalTaxSum) ? parseFloat(data.totalTaxSum) : 0, //价税合计

            invoiceCode: data.invoiceDataCode, //发票代码
            invoiceNumber: data.invoiceNumber, //发票号码
            invoiceDate: data.billingTime, //开票日期
            checkCode: data.checkCode, //校验码

            machineNumber: data.taxDiskCode, //机器编号
            note: data.invoiceRemarks, //备注

            byerName: data.purchaserName, //购买方名称
            byerTel: data.taxpayerAddressOrId, //购买方地址电话
            byerTaxpayerIdentity: data.taxpayerNumber, //购买方纳税人识别号
            byerBankAccount: data.taxpayerBankAccount, //购买方开户行及账号

            saler: data.salesName, //销售方名称
            salerTel: data.salesTaxpayerAddress, //销售方地址电话
            salerTaxplayerIdentity: data.salesTaxpayerNum, //销售方纳税人识别号
            salerBankAccount: data.salesTaxpayerBankAccount, //销售方开户行及账号

            isBillLine: data.isBillMark == 'Y' ? true : false, //是否为清单票
        }
        newInvoiceJson.arrayList = [];//发票明细
        $$.each(data.invoiceDetailData, function (index, val) {
            newInvoiceJson.arrayList[index] = {};
            newInvoiceJson.arrayList[index].chargeReceiptId = val.goodserviceName;// 应税劳务服务
            newInvoiceJson.arrayList[index].detailType = val.model;// 规格型号
            newInvoiceJson.arrayList[index].unit = val.unit;// 单位
            newInvoiceJson.arrayList[index].amount = parseInt(val.number) ? parseInt(val.number) : 0;// 数量
            newInvoiceJson.arrayList[index].price = parseFloat(val.price) ? parseFloat(val.price) : 0;// 单价
            newInvoiceJson.arrayList[index].money = parseFloat(val.sum) ? parseFloat(val.sum) : 0;// 金额
            newInvoiceJson.arrayList[index].taxRate = val.taxRate;// 税率
            newInvoiceJson.arrayList[index].taxLimit = parseFloat(val.tax) ? parseFloat(val.tax) : 0;// 税额
        });
        invoiceData.push(newInvoiceJson);
        // 将查询的数据追加到页面中
        var invoiceLiHtml = '<li id="' + data.invoiceNumber + '" class="accordion-item swipeout"><a href="#" class="item-content item-link"><div class="item-inner"><div class="item-title">' + data.invoiceTypeName + '</div><div class="item-after">￥' + data.totalTaxSum + '</div></div></a><div class="accordion-item-content"><div class="content-block">' +
            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">金额合计</div><div class="col-65 text-right">' + data.totalAmount + '</div><div class="col-30">税额合计</div><div class="col-65 text-right">' + data.totalTaxNum + '</div></div></div>' +
            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">发票代码</div><div class="col-65 text-right">' + data.invoiceDataCode + '</div><div class="col-30">发票号码</div><div class="col-65 text-right">' + data.invoiceNumber + '</div><div class="col-30">开票日期</div><div class="col-65 text-right">' + data.billingTime + '</div><div class="col-30">校验码</div><div class="col-65 text-right">' + data.checkCode + '</div></div></div>' +

            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">机器码</div><div class="col-65 text-right">' + data.taxDiskCode + '</div><div class="col-30">备注</div><div class="col-65 text-right">' + data.invoiceRemarks + '</div></div></div>' +

            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">购买方</div><div class="col-65 text-right">' + data.purchaserName + '</div><div class="col-30">地址电话</div><div class="col-65 text-right">' + data.taxpayerAddressOrId + '</div><div class="col-30">纳税人识别号</div><div class="col-65 text-right">' + data.taxpayerNumber + '</div><div class="col-30">开户行及账号</div><div class="col-65 text-right">' + data.taxpayerBankAccount + '</div></div></div>' +

            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">销售方</div><div class="col-65 text-right">' + data.salesName + '</div><div class="col-30">地址电话</div><div class="col-65 text-right">' + data.salesTaxpayerAddress + '</div><div class="col-30">纳税人识别号</div><div class="col-65 text-right">' + data.salesTaxpayerNum + '</div><div class="col-30">开户行及账号</div><div class="col-65 text-right">' + data.salesTaxpayerBankAccount + '</div></div></div>';

        if (data.invoiceDetailData && data.invoiceDetailData.length > 0) {
            invoiceLiHtml += '<div class="content-block-inner"><div class="row no-gutter"><div class="col-40 text-center">货物或应税劳务服务</div><div class="col-20 text-center">金额</div><div class="col-20 text-center">税率</div><div class="col-20 text-center">税额</div>';
            for (var i = 0; i < data.invoiceDetailData.length; i++) {
                invoiceLiHtml += '<div class="col-40 text-center">' + data.invoiceDetailData[i].goodserviceName + '</div><div class="col-20 text-center">' + data.invoiceDetailData[i].sum + '</div><div class="col-20 text-center">' + data.invoiceDetailData[i].taxRate + '</div><div class="col-20 text-center">' + data.invoiceDetailData[i].tax + '</div>';

            }
            invoiceLiHtml += '</div></div>';
        }
        invoiceLiHtml += '<div data-id="' + data.invoiceNumber + '" data-totalTaxSum="' + data.totalTaxSum + '" class="content-block-inner color-red flex-center btn-del-invoice">删除此发票</div></div></div></li>';
        // 判断是否是添加第一张发票
        if (container.find('.invoice-detail ul').length == 0) {
            container.find('.invoice-detail').html('<ul></ul>');
        }
        container.find('.invoice-detail ul').append(invoiceLiHtml);
        container.find('.no-invoice-data').hide();
        app.closeModal('.popup-group-option');
        api.hideProgress();
        //删除先解除绑定，再绑定，防止重复加载
        container.find('.btn-del-invoice').off('click', delEvent);
        container.find('.btn-del-invoice').on('click', delEvent);
    }
    // 删除发票
    function delEvent() {
        var that = $$(this);
        app.confirm('确认删除此发票？', '温馨提醒', function () {
            app.showIndicator();
            var id = that.attr('data-id'),
                dataTotalTaxSum = that.attr('data-totalTaxSum'),
                item = that.parent().parent().parent();
            // 调整发票总金额
            invoiceAmount = invoiceAmount - parseFloat(dataTotalTaxSum);
            container.find('.invoiceAmount').text(invoiceAmount);
            // 先收起li，然后在删除dom(主要用在ios中)
            app.accordionToggle(item);
            // 删除dom中对应的数据,做一个延迟处理，用于收起li，否则没有效果
            setTimeout(function () {
                item.remove();
            }, 200);
            if (container.find('.invoice-detail ul li').length == 0) {
                container.find('.invoice-detail').html('');
                container.find('.no-invoice-data').show();
            }
            // 删除数组中对应的数据
            for (var i = 0; i < invoiceData.length; i++) {
                if (invoiceData[i].invoiceNumber == id) {
                    invoiceData.splice(i, 1); //删除下标为i的元素
                }
            }
            app.hideIndicator();
        });
    }
    // 保存发票信息
    function saveInvoiceData() {
        app.showIndicator();
        var param = {
            ajaxUrl: 'api/services/app/speInvoice/BatchCreateSpeInvoice',
            ajaxMethod: 'post',
            ajaxValues: invoiceData,
            ajaxCallback: saveDataCallback,
            ajaxAgainEvt: saveInvoiceData,
            ajaxText: '新增费用发票'
        }
        common.ajaxMethod(param);
    }
    function saveDataCallback(ret) {
        if (ret.result.status == 'y') {
            common.notification('恭喜', '保存成功', 'success');
            //更新列表
            $$(document).trigger('after-updata-invoice');
            //返回详情   (返回上一个页面)
            var currentView = app.getCurrentView();
            currentView.router.back();
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
});