/**
 * 资源-服务费发票-添加-信息页面
 * @author 韩慧
 * @date 2018.10.17
 */
define(['plugin/validate', 'moment'], function (validator, moment) {
    var container = null,
        navbarInnerContainer = null,
        pageContent = null,
        loading = false,
        containerPopup = null,
        navbarInnerContainerPopup = null,
        pageContentPopup = null,
        preloaderPopup = null,
        invoiceData = [],//查询出来的发票数据
        chargeAccountId = '', //清单id
        serviceTypeName = '', //清单类型
        invoiceAmount = 0, // 发票总金额
        coopPartyA = '', // 清单甲方(coopPartyA)
        coopPartyB = '',// 清单乙方(coopPartyB)
        detailData = null;
    return {
        init: function (page) {
            if (page.from == 'right') {
                container = $$(page.container);
                navbarInnerContainer = $$(page.navbarInnerContainer).length ? $$(page.navbarInnerContainer) : container.find('.navbar .navbar-inner');
                detailData = page.query.detailData;
                chargeAccountId = ''; //清单id
                serviceTypeName = ''; //清单类型
                showData(detailData);
            }
        }
    };
    // 展示数据
    function showData(data) {
        // 根据第一条发票信息，显示清单内容
        container.find('[data-name="chargeAccountCode"]').text(data.result[0].listCode);//服务工作清单编号
        container.find('[data-name="serviceTypeName"]').text(data.result[0].serviceTypeName);//清单类型
        container.find('[data-name="contractors"]').text(data.result[0].conName);//服务商
        container.find('[data-name="period"]').text(data.result[0].salesPeriodName);//业务期间
        container.find('[data-name="realCharge"]').text(data.result[0].listMoney);//金额(元)
        chargeAccountId = data.result[0].chargeAccountId;//清单id
        serviceTypeName = data.result[0].serviceTypeName;//清单类型
        coopPartyA = data.result[0].coopPartyA;//清单甲方(coopPartyA)
        coopPartyB = data.result[0].coopPartyB;//清单乙方(coopPartyB)
        // 循环获取发票总金额
        for (var i = 0; i < data.result.length; i++) {
            invoiceAmount = data.result[i].totalTaxSum ? invoiceAmount + parseFloat(data.result[i].totalTaxSum) : invoiceAmount;
            invoiceData[i] = {}
            // 将新查询的发票数据添加到invoiceData
            invoiceData[i] = {
                chargeAccountId: chargeAccountId, //服务工作清单Id
                chargeAccountName: serviceTypeName,//服务工作清单
                invoiceType: data.result[i].invoiceTypeCode, //发票类型
                invoiceTypeName: data.result[i].invoiceTypeName, //发票类型名称

                money: data.result[i].totalAmount, //金额合计
                taxlMoney: data.result[i].totalTaxNum, //税额合计
                totalMoney: data.result[i].totalTaxSum, //价税合计

                invoiceCode: data.result[i].invoiceDataCode, //发票代码
                invoiceNumber: data.result[i].invoiceNumber, //发票号码
                invoiceDate: data.result[i].billingTime, //开票日期
                checkCode: data.result[i].checkCode, //校验码

                machineNumber: data.result[i].taxDiskCode, //机器编号
                note: data.result[i].invoiceRemarks, //备注

                byerName: data.result[i].purchaserName, //购买方名称
                byerTel: data.result[i].taxpayerAddressOrId, //购买方地址电话
                byerTaxpayerIdentity: data.result[i].taxpayerNumber, //购买方纳税人识别号
                byerBankAccount: data.result[i].taxpayerBankAccount, //购买方开户行及账号

                saler: data.result[i].salesName, //销售方名称
                salerTel: data.result[i].salesTaxpayerAddress, //销售方地址电话
                salerTaxplayerIdentity: data.result[i].salesTaxpayerNum, //销售方纳税人识别号
                salerBankAccount: data.result[i].salesTaxpayerBankAccount, //销售方开户行及账号

                isBillLine: data.result[i].isBillMark == 'Y' ? true : false, //是否为清单票
            }
            invoiceData[i].arrayList = [];//发票明细
            $$.each(data.result[i].invoiceDetailData, function (index, val) {
                invoiceData[i].arrayList[index] = {};
                invoiceData[i].arrayList[index].chargeReceiptId = val.goodserviceName;// 应税劳务服务
                invoiceData[i].arrayList[index].detailType = val.model;// 规格型号
                invoiceData[i].arrayList[index].unit = val.unit;// 单位
                invoiceData[i].arrayList[index].amount = parseInt(val.number);// 数量
                invoiceData[i].arrayList[index].price = parseFloat(val.price);// 单价
                invoiceData[i].arrayList[index].money = val.sum;// 金额
                invoiceData[i].arrayList[index].taxRate = val.taxRate;// 税率
                invoiceData[i].arrayList[index].taxLimit = parseFloat(val.tax);// 税额
            });
        }
        container.find('.invoiceAmount').text(invoiceAmount);
        // 编译模板--发票明细列表
        var template = container.find('.tmp-detail').html();
        var compiledTemplate = Template7.compile(template);
        var html = compiledTemplate(data);
        container.find('.invoice-detail').html('<ul>' + html + '</ul>');
        container.find('.no-invoice-data').hide();
        //删除先解除绑定，再绑定，防止重复加载
        container.find('.btn-del-invoice').off('click', delEvent);
        container.find('.btn-del-invoice').on('click', delEvent);
        bindEvent();
    }
    //绑定事件
    function bindEvent() {
        //扫描二维码
        container.find('.btn-scanner').on('click', function () {
            // 加载扫码模块
            require(['plugin/component/scanner'], function (scanner) {
                scanner.init(scannerCallback);
            });
        });
        //手动录入
        container.find('.btn-search').on('click', function () {
            // 打开popup
            openPopup('search');
        });
        navbarInnerContainer.find('.btn-submit').on('click', function () {
            if (invoiceData && invoiceData.length == 0) {
                common.notification('提示', '请至少添加一张发票信息', 'warning');
            } else {
                if (container.find('[data-name="realCharge"]').text() != container.find('.invoiceAmount').text()) {
                    app.confirm('清单金额与发票总金额不一致，是否继续保存', '温馨提醒', function () {
                        saveInvoiceData();
                    });
                } else {
                    saveInvoiceData();
                }
            }
        });
    };
    // 打开popup
    function openPopup(type) {
        var typeName = '', btnDone = '', infinite = '';
        //popup
        var popupSearchHTML = '<div class="popup popup-group-option"><div class="view navbar-fixed"><div class="pages"><div data-page="service-iovoice-add-search" class="page"><div class="navbar"><div class="navbar-inner"><div class="left sliding"><a href="#" class="close-popup link"><i class="icon icon-back"></i><span>关闭</span></a></div><div class="center sliding">查询发票信息</div><div class="right"></div></div></div><div class="page-content"><form name="form-server-invoice-search"><div class="list-block"><ul><li class="item-content"><div class="item-inner"><div class="item-title label">发票代码<span class="color-red">*</span></div><div class="item-input"><input type="number" name="fpdm" placeholder="请输入10或12位发票代码" oninput="if(value.length>12)value=value.slice(0,12)"></div></div></li><li class="item-content"><div class="item-inner"><div class="item-title label">发票号码<span class="color-red">*</span></div><div class="item-input"><input type="number" name="fphm" placeholder="请输入8位发票号码" oninput="if(value.length>8)value=value.slice(0,8)"></div></div></li><li class="item-content"><div class="item-inner"><div class="item-title label">开票日期<span class="color-red">*</span></div><div class="item-input"><input type="text" name="kprq" placeholder="请选择开票日期" readonly="readonly"></div></div></li><!-- 专票时显示   2 --><li class="item-content zp hide"><div class="item-inner"><div class="item-title label">不含税金额<span class="color-red">*</span></div><div class="item-input"><input type="number" name="noTaxAmount" placeholder="请输入不含税金额"></div></div></li><!-- 普票时显示   1 --><li class="item-content pp"><div class="item-inner"><div class="item-title label">校验码(后6位)<span class="color-red">*</span></div><div class="item-input"><input type="number" name="checkCode" placeholder="请输入校验码(后6位)" oninput="if(value.length>6)value=value.slice(0,6)"></div></div></li></ul></div></form><div class="content-block"><a href="#" class="button button-big button-round color-blue button-fill btn-done">查询</a></div></div></div></div></div></div>';
        app.popup(popupSearchHTML);
        $$('.popup-group-option').on('opened', function () {
            containerPopup = $$('.popup-group-option');
            navbarInnerContainerPopup = containerPopup.find('.navbar');
            pageContentPopup = containerPopup.find('.page-content');
            searchEvent();
        });
    }
    // 手动录入事件
    function searchEvent() {
        // 发票代码字段失去焦点时，根据发票代码去判断发票类型
        containerPopup.find('[name="fpdm"]').blur(function (e) {
            // 获取发票代码
            var invoiceDataCode = $$(this).val(),
                b = '',
                code = new Array('144031539110', '131001570151', '133011501118', '111001571071'),
                invoiceType = '99';
            if (invoiceDataCode == '') {
                return;
            }
            // 12位时判断
            if (invoiceDataCode.length == 12) {
                b = invoiceDataCode.substring(7, 8);
                for (var i = 0; i < code.length; i++) {
                    if (invoiceDataCode == code[i]) {
                        invoiceType = "10";
                        break
                    }
                }
                if (invoiceType == "99") {
                    if (invoiceDataCode.charAt(0) == '0' && invoiceDataCode.substring(10, 12) == '11') {
                        invoiceType = "10"
                    }
                    if (invoiceDataCode.charAt(0) == '0' && (invoiceDataCode.substring(10, 12) == '04' || invoiceDataCode.substring(10, 12) == '05')) {
                        invoiceType = "04"
                    }
                    if (invoiceDataCode.charAt(0) == '0' && (invoiceDataCode.substring(10, 12) == '06' || invoiceDataCode.substring(10, 12) == '07')) {
                        invoiceType = "11"
                    }
                    if (invoiceDataCode.charAt(0) == '0' && invoiceDataCode.substring(10, 12) == '12') {
                        invoiceType = "14"
                    }
                }
                if (invoiceType == "99") {
                    if (invoiceDataCode.substring(10, 12) == '17' && invoiceDataCode.charAt(0) == '0') {
                        invoiceType = "15"
                    }
                    if (invoiceType == "99" && b == 2 && invoiceDataCode.charAt(0) != '0') {
                        invoiceType = "03"
                    }
                }
            } else if (invoiceDataCode.length == 10) {
                b = invoiceDataCode.substring(7, 8);
                if (b == 1 || b == 5) {
                    invoiceType = "01";
                } else if (b == 6 || b == 3) {
                    invoiceType = "04";
                } else if (b == 7 || b == 2) {
                    invoiceType = "02";
                }
            }
            if (invoiceType == '04' || invoiceType == '01' || invoiceType == '10') {
                if (invoiceType == '04' || invoiceType == '10') {
                    // 普票
                    containerPopup.find('.pp').removeClass('hide');
                    containerPopup.find('.zp').addClass('hide');
                } else if (invoiceType == '01') {
                    // 专票
                    containerPopup.find('.zp').removeClass('hide');
                    containerPopup.find('.pp').addClass('hide');
                }
            } else {
                app.alert('请输入正确的增值税专用发票或增值税普通发票的代码进行查询', '发票代码错误');
            }
        })
        // 日期选择器
        var kprqDate = containerPopup.find('[name="kprq"]'),
            // 添加默认值，当天
            defaultDate = moment(new Date()).format('YYYY-MM-DD');
        kprqDate.val(defaultDate);
        common.calendarPicker(kprqDate, [defaultDate]);
        //提交表单
        containerPopup.find('.btn-done').click(function () {
            validator.validateForm();
        });
        // 表单验证 
        var validator = new FormValidator('form-server-invoice-search', [{
            name: 'fpdm',
            display: '发票代码',
            rules: 'required'
        }, {
            name: 'fphm',
            display: '发票号码',
            rules: 'required'
        }, {
            name: 'kprq',
            display: '开票日期',
            rules: 'required'
        }], function (errors, event) {
            if (errors.length > 0) {
                $$.each(errors, function (index, value) {
                    common.notification('提示', value.message, 'warning');
                });
            } else {
                if (containerPopup.find('[name="InvoiceType"]').val() == '1' && containerPopup.find('.checkCode').val() == '') {
                    // 普票
                    common.notification('提示', '请填写校验码', 'warning');
                } else if (containerPopup.find('[name="InvoiceType"]').val() == '2' && containerPopup.find('.noTaxAmount').val() == '') {
                    // 专票
                    common.notification('提示', '不含税金额', 'warning');
                } else {
                    var values = {
                        'fpdm': containerPopup.find('[name="fpdm"]').val(),
                        'fphm': containerPopup.find('[name="fphm"]').val(),
                        'kprq': containerPopup.find('[name="kprq"]').val(),
                        'noTaxAmount': containerPopup.find('[name="noTaxAmount"]').val(),
                        'checkCode': containerPopup.find('[name="checkCode"]').val()
                    };
                    getInvoice('api/services/app/speInvoice/VerifyingInvoice', values);
                }
            }
        });
    }
    //扫描回调
    function scannerCallback(data) {
        getInvoice('api/services/app/speInvoice/VerifyingInvoiceOCR', [data]);
    }
    //获取发票信息
    function getInvoice(url, values) {
        app.showIndicator();
        var param = {
            ajaxUrl: url,
            ajaxMethod: 'post',
            ajaxValues: values,
            ajaxCallback: getInvoiceajaxCallback,
            ajaxAgainEvt: getInvoice,
            ajaxText: '获取发票信息'
        }
        common.ajaxMethod(param);
    }
    function getInvoiceajaxCallback(ret) {
        if (ret.result.status == 'y') {
            invoiceRepeatJudgeEvt(ret.result.data);
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
    // 发票去重判断
    function invoiceRepeatJudgeEvt(data){
        if (invoiceData.length > 0) {
            var invoiceNum = 0;
            $$.each(invoiceData, function (index, val) {
                // 判断发票号码是否已经存在
                if(data.invoiceNumber == val.invoiceNumber){
                    invoiceNum ++;
                }
            });
            // 如果发票已存在存在表示则不进行保存
            if(invoiceNum > 0){
                app.alert('已添加此发票，请重新选择', '发票重复');
            }else{
                showInvoiceEvt(data);
            }
        }else{
            showInvoiceEvt(data);
        }
    }
    // 判断发票信息与协议信息是否一致
    function showInvoiceEvt(data) {
        // 测协议的甲方乙方与发票的购买方销售方名称是否一致  购买方==甲方(coopPartyA) 、销售方==乙方(coopPartyB)
        if (coopPartyA != data.purchaserName || coopPartyB != data.salesName) {
            app.confirm('发票的购买方销售方名称与清单的甲方乙方名称不一致，是否继续？', '温馨提醒', function () {
                showInvoice(data);
            });
        } else {
            showInvoice(data);
        }
    }
    // 展示发票数据
    function showInvoice(data) {
        api.showProgress();
        invoiceAmount += parseFloat(data.totalTaxSum);
        container.find('.invoiceAmount').text(invoiceAmount);
        // 将新查询的发票数据添加到invoiceData
        var newInvoiceJson = {//临时数据
            chargeAccountId: chargeAccountId, //服务工作清单Id
            chargeAccountName: serviceTypeName,//服务工作清单
            invoiceType: data.invoiceTypeCode, //发票类型
            invoiceTypeName: data.invoiceTypeName, //发票类型名称

            money: parseFloat(data.totalAmount) ? parseFloat(data.totalAmount) : 0, //金额合计
            taxlMoney: parseFloat(data.totalTaxNum) ? parseFloat(data.totalTaxNum) : 0, //税额合计
            totalMoney: parseFloat(data.totalTaxSum) ? parseFloat(data.totalTaxSum) : 0, //价税合计

            invoiceCode: data.invoiceDataCode, //发票代码
            invoiceNumber: data.invoiceNumber, //发票号码
            invoiceDate: data.billingTime, //开票日期
            checkCode: data.checkCode, //校验码

            machineNumber: data.taxDiskCode, //机器编号
            note: data.invoiceRemarks, //备注

            byerName: data.purchaserName, //购买方名称
            byerTel: data.taxpayerAddressOrId, //购买方地址电话
            byerTaxpayerIdentity: data.taxpayerNumber, //购买方纳税人识别号
            byerBankAccount: data.taxpayerBankAccount, //购买方开户行及账号

            saler: data.salesName, //销售方名称
            salerTel: data.salesTaxpayerAddress, //销售方地址电话
            salerTaxplayerIdentity: data.salesTaxpayerNum, //销售方纳税人识别号
            salerBankAccount: data.salesTaxpayerBankAccount, //销售方开户行及账号

            isBillLine: data.isBillMark == 'Y' ? true : false, //是否为清单票
        }
        newInvoiceJson.arrayList = [];//发票明细
        $$.each(data.invoiceDetailData, function (index, val) {
            newInvoiceJson.arrayList[index] = {};
            newInvoiceJson.arrayList[index].chargeReceiptId = val.goodserviceName;// 应税劳务服务
            newInvoiceJson.arrayList[index].detailType = val.model;// 规格型号
            newInvoiceJson.arrayList[index].unit = val.unit;// 单位
            newInvoiceJson.arrayList[index].amount = parseInt(val.number) ? parseInt(val.number) : 0;// 数量
            newInvoiceJson.arrayList[index].price = parseFloat(val.price) ? parseFloat(val.price) : 0;// 单价
            newInvoiceJson.arrayList[index].money = parseFloat(val.sum) ? parseFloat(val.sum) : 0;// 金额
            newInvoiceJson.arrayList[index].taxRate = val.taxRate;// 税率
            newInvoiceJson.arrayList[index].taxLimit = parseFloat(val.tax) ? parseFloat(val.tax) : 0;// 税额
        });
        invoiceData.push(newInvoiceJson);
        // 将查询的数据追加到页面中
        var invoiceLiHtml = '<li id="' + data.invoiceNumber + '" class="accordion-item swipeout"><a href="#" class="item-content item-link"><div class="item-inner"><div class="item-title">' + data.invoiceTypeName + '</div><div class="item-after">￥' + data.totalTaxSum + '</div></div></a><div class="accordion-item-content"><div class="content-block">' +
            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">金额合计</div><div class="col-65 text-right">' + data.totalAmount + '</div><div class="col-30">税额合计</div><div class="col-65 text-right">' + data.totalTaxNum + '</div></div></div>' +
            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">发票代码</div><div class="col-65 text-right">' + data.invoiceDataCode + '</div><div class="col-30">发票号码</div><div class="col-65 text-right">' + data.invoiceNumber + '</div><div class="col-30">开票日期</div><div class="col-65 text-right">' + data.billingTime + '</div><div class="col-30">校验码</div><div class="col-65 text-right">' + data.checkCode + '</div></div></div>' +

            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">机器码</div><div class="col-65 text-right">' + data.taxDiskCode + '</div><div class="col-30">备注</div><div class="col-65 text-right">' + data.invoiceRemarks + '</div></div></div>' +

            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">购买方</div><div class="col-65 text-right">' + data.purchaserName + '</div><div class="col-30">地址电话</div><div class="col-65 text-right">' + data.taxpayerAddressOrId + '</div><div class="col-30">纳税人识别号</div><div class="col-65 text-right">' + data.taxpayerNumber + '</div><div class="col-30">开户行及账号</div><div class="col-65 text-right">' + data.taxpayerBankAccount + '</div></div></div>' +

            '<div class="content-block-inner"><div class="row no-gutter"><div class="col-30">销售方</div><div class="col-65 text-right">' + data.salesName + '</div><div class="col-30">地址电话</div><div class="col-65 text-right">' + data.salesTaxpayerAddress + '</div><div class="col-30">纳税人识别号</div><div class="col-65 text-right">' + data.salesTaxpayerNum + '</div><div class="col-30">开户行及账号</div><div class="col-65 text-right">' + data.salesTaxpayerBankAccount + '</div></div></div>';

        if (data.invoiceDetailData && data.invoiceDetailData.length > 0) {
            invoiceLiHtml += '<div class="content-block-inner"><div class="row no-gutter"><div class="col-40 text-center">货物或应税劳务服务</div><div class="col-20 text-center">金额</div><div class="col-20 text-center">税率</div><div class="col-20 text-center">税额</div>';
            for (var i = 0; i < data.invoiceDetailData.length; i++) {
                invoiceLiHtml += '<div class="col-40 text-center">' + data.invoiceDetailData[i].goodserviceName + '</div><div class="col-20 text-center">' + data.invoiceDetailData[i].sum + '</div><div class="col-20 text-center">' + data.invoiceDetailData[i].taxRate + '</div><div class="col-20 text-center">' + data.invoiceDetailData[i].tax + '</div>';

            }
            invoiceLiHtml += '</div></div>';
        }
        invoiceLiHtml += '<div data-id="' + data.invoiceNumber + '" data-totalTaxSum="' + data.totalTaxSum + '" class="content-block-inner color-red flex-center btn-del-invoice">删除此发票</div></div></div></li>';
        // 判断是否是添加第一张发票
        if (container.find('.invoice-detail ul').length == 0) {
            container.find('.invoice-detail').html('<ul></ul>');
        }
        container.find('.invoice-detail ul').append(invoiceLiHtml);
        container.find('.no-invoice-data').hide();
        app.closeModal('.popup-group-option');
        api.hideProgress();

        //删除先解除绑定，再绑定，防止重复加载
        container.find('.btn-del-invoice').off('click', delEvent);
        container.find('.btn-del-invoice').on('click', delEvent);
    }
    // 删除发票
    function delEvent() {
        var that = $$(this);
        app.confirm('确认删除此发票？', '温馨提醒', function () {
            app.showIndicator();
            var id = that.attr('data-id'),
                dataTotalTaxSum = that.attr('data-totalTaxSum'),
                item = that.parent().parent().parent();
            // 调整发票总金额
            invoiceAmount = invoiceAmount - parseFloat(dataTotalTaxSum);
            container.find('.invoiceAmount').text(invoiceAmount);
            // 先收起li，然后在删除dom(主要用在ios中)
            app.accordionToggle(item);
            // 删除dom中对应的数据,做一个延迟处理，用于收起li，否则没有效果
            setTimeout(function () {
                item.remove();
            }, 200);
            if (container.find('.invoice-detail ul li').length == 0) {
                container.find('.invoice-detail').html('');
                container.find('.no-invoice-data').show();
            }
            // 删除数组中对应的数据
            for (var i = 0; i < invoiceData.length; i++) {
                if (invoiceData[i].invoiceNumber == id) {
                    invoiceData.splice(i, 1); //删除下标为i的元素
                }
            }
            app.hideIndicator();
        });
    }
    //保存
    function saveInvoiceData() {
        app.showIndicator();
        var param = {
            ajaxUrl: 'api/services/app/speInvoice/BatchCreateSpeInvoice',
            ajaxMethod: 'post',
            ajaxValues: invoiceData,
            ajaxCallback: saveDataCallback,
            ajaxAgainEvt: saveInvoiceData,
            ajaxText: '编辑费用发票'
        }
        common.ajaxMethod(param);
    }
    function saveDataCallback(ret) {
        if (ret.result.status == 'y') {
            common.notification('恭喜', '保存成功', 'success');
            //更新列表
            $$(document).trigger('after-updata-invoice');
            //返回详情   (返回上一个页面)
            var currentView = app.getCurrentView();
            currentView.router.back();
        } else {
            //弹出提示,这里比较特殊返回信息里有是否是Y的判断,这里单独判断下
            app.modal({
                title: '操作失败',
                text: '<i class="icon icon-error"></i>' + '<p class="decription">' + ret.result.msg + '</p>',
                buttons: [{
                    text: '知道了'
                }]
            });
        }
    }
});